/* sudoku-saver.c generated by valac 0.56.14, the Vala compiler
 * generated from sudoku-saver.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libsudoku.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <json-glib/json-glib.h>
#include <float.h>
#include <math.h>

enum  {
	SUDOKU_SAVER_0_PROPERTY,
	SUDOKU_SAVER_NUM_PROPERTIES
};
static GParamSpec* sudoku_saver_properties[SUDOKU_SAVER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

static gpointer sudoku_saver_parent_class = NULL;
static gchar* sudoku_saver__savegame_file;
static gchar* sudoku_saver__savegame_file = NULL;
static gchar* sudoku_saver__finishgame_dir;
static gchar* sudoku_saver__finishgame_dir = NULL;

static void sudoku_saver_set_savegame_file (const gchar* value);
static void sudoku_saver_set_finishgame_dir (const gchar* value);
static SudokuGame* sudoku_saver_parse_json_to_game (SudokuSaver* self,
                                             const gchar* file_path);
static void sudoku_saver_create_file_for_game (SudokuSaver* self,
                                        SudokuGame* game,
                                        const gchar* file_name);
static gchar* sudoku_saver_serialize_game_to_json (SudokuSaver* self,
                                            SudokuGame* game);
static void _vala_array_add1 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static void _vala_JsonNode_free (JsonNode* self);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void sudoku_saver_finalize (GObject * obj);
static GType sudoku_saver_get_type_once (void);
static void _vala_sudoku_saver_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_sudoku_saver_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

SudokuSaver*
sudoku_saver_construct (GType object_type)
{
	SudokuSaver * self = NULL;
	GError* _inner_error0_ = NULL;
#line 29 "../lib/sudoku-saver.vala"
	self = (SudokuSaver*) g_object_new (object_type, NULL);
#line 88 "sudoku-saver.c"
	{
		gchar* config_dir = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* sudoku_data_dir = NULL;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* file = NULL;
		const gchar* _tmp10_;
		GFile* _tmp11_;
		GFile* _tmp12_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 34 "../lib/sudoku-saver.vala"
		_tmp0_ = g_get_user_data_dir ();
#line 34 "../lib/sudoku-saver.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 34 "../lib/sudoku-saver.vala"
		config_dir = _tmp1_;
#line 35 "../lib/sudoku-saver.vala"
		_tmp2_ = config_dir;
#line 35 "../lib/sudoku-saver.vala"
		_tmp3_ = g_build_path (G_DIR_SEPARATOR_S, _tmp2_, "gnome-sudoku", NULL);
#line 35 "../lib/sudoku-saver.vala"
		sudoku_data_dir = _tmp3_;
#line 36 "../lib/sudoku-saver.vala"
		_tmp4_ = sudoku_data_dir;
#line 36 "../lib/sudoku-saver.vala"
		_tmp5_ = g_build_path (G_DIR_SEPARATOR_S, _tmp4_, "savefile", NULL);
#line 36 "../lib/sudoku-saver.vala"
		_tmp6_ = _tmp5_;
#line 36 "../lib/sudoku-saver.vala"
		sudoku_saver_set_savegame_file (_tmp6_);
#line 36 "../lib/sudoku-saver.vala"
		_g_free0 (_tmp6_);
#line 37 "../lib/sudoku-saver.vala"
		_tmp7_ = sudoku_data_dir;
#line 37 "../lib/sudoku-saver.vala"
		_tmp8_ = g_build_path (G_DIR_SEPARATOR_S, _tmp7_, "finished", NULL);
#line 37 "../lib/sudoku-saver.vala"
		_tmp9_ = _tmp8_;
#line 37 "../lib/sudoku-saver.vala"
		sudoku_saver_set_finishgame_dir (_tmp9_);
#line 37 "../lib/sudoku-saver.vala"
		_g_free0 (_tmp9_);
#line 38 "../lib/sudoku-saver.vala"
		_tmp10_ = sudoku_data_dir;
#line 38 "../lib/sudoku-saver.vala"
		_tmp11_ = g_file_new_for_path (_tmp10_);
#line 38 "../lib/sudoku-saver.vala"
		file = _tmp11_;
#line 39 "../lib/sudoku-saver.vala"
		_tmp12_ = file;
#line 39 "../lib/sudoku-saver.vala"
		if (!g_file_query_exists (_tmp12_, NULL)) {
#line 152 "sudoku-saver.c"
			GFile* _tmp13_;
#line 40 "../lib/sudoku-saver.vala"
			_tmp13_ = file;
#line 40 "../lib/sudoku-saver.vala"
			g_file_make_directory (_tmp13_, NULL, &_inner_error0_);
#line 40 "../lib/sudoku-saver.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 40 "../lib/sudoku-saver.vala"
				_g_object_unref0 (file);
#line 40 "../lib/sudoku-saver.vala"
				_g_free0 (sudoku_data_dir);
#line 40 "../lib/sudoku-saver.vala"
				_g_free0 (config_dir);
#line 166 "sudoku-saver.c"
				goto __catch0_g_error;
			}
		}
#line 42 "../lib/sudoku-saver.vala"
		_tmp14_ = sudoku_saver_get_finishgame_dir ();
#line 42 "../lib/sudoku-saver.vala"
		_tmp15_ = _tmp14_;
#line 42 "../lib/sudoku-saver.vala"
		_tmp16_ = g_file_new_for_path (_tmp15_);
#line 42 "../lib/sudoku-saver.vala"
		_g_object_unref0 (file);
#line 42 "../lib/sudoku-saver.vala"
		file = _tmp16_;
#line 43 "../lib/sudoku-saver.vala"
		_tmp17_ = file;
#line 43 "../lib/sudoku-saver.vala"
		if (!g_file_query_exists (_tmp17_, NULL)) {
#line 184 "sudoku-saver.c"
			GFile* _tmp18_;
#line 44 "../lib/sudoku-saver.vala"
			_tmp18_ = file;
#line 44 "../lib/sudoku-saver.vala"
			g_file_make_directory (_tmp18_, NULL, &_inner_error0_);
#line 44 "../lib/sudoku-saver.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 44 "../lib/sudoku-saver.vala"
				_g_object_unref0 (file);
#line 44 "../lib/sudoku-saver.vala"
				_g_free0 (sudoku_data_dir);
#line 44 "../lib/sudoku-saver.vala"
				_g_free0 (config_dir);
#line 198 "sudoku-saver.c"
				goto __catch0_g_error;
			}
		}
#line 31 "../lib/sudoku-saver.vala"
		_g_object_unref0 (file);
#line 31 "../lib/sudoku-saver.vala"
		_g_free0 (sudoku_data_dir);
#line 31 "../lib/sudoku-saver.vala"
		_g_free0 (config_dir);
#line 208 "sudoku-saver.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 31 "../lib/sudoku-saver.vala"
		e = _inner_error0_;
#line 31 "../lib/sudoku-saver.vala"
		_inner_error0_ = NULL;
#line 48 "../lib/sudoku-saver.vala"
		_tmp19_ = e;
#line 48 "../lib/sudoku-saver.vala"
		_tmp20_ = _tmp19_->message;
#line 48 "../lib/sudoku-saver.vala"
		g_warning ("sudoku-saver.vala:48: %s", _tmp20_);
#line 31 "../lib/sudoku-saver.vala"
		_g_error_free0 (e);
#line 228 "sudoku-saver.c"
	}
	__finally0:
#line 31 "../lib/sudoku-saver.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 31 "../lib/sudoku-saver.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 31 "../lib/sudoku-saver.vala"
		g_clear_error (&_inner_error0_);
#line 31 "../lib/sudoku-saver.vala"
		return NULL;
#line 239 "sudoku-saver.c"
	}
#line 29 "../lib/sudoku-saver.vala"
	return self;
#line 243 "sudoku-saver.c"
}

SudokuSaver*
sudoku_saver_new (void)
{
#line 29 "../lib/sudoku-saver.vala"
	return sudoku_saver_construct (TYPE_SUDOKU_SAVER);
#line 251 "sudoku-saver.c"
}

SudokuGame*
sudoku_saver_get_savedgame (SudokuSaver* self)
{
	GFile* file = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	SudokuGame* _tmp6_;
	SudokuGame* result;
#line 52 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver_get_savegame_file ();
#line 54 "../lib/sudoku-saver.vala"
	_tmp1_ = _tmp0_;
#line 54 "../lib/sudoku-saver.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 54 "../lib/sudoku-saver.vala"
	file = _tmp2_;
#line 55 "../lib/sudoku-saver.vala"
	_tmp3_ = file;
#line 55 "../lib/sudoku-saver.vala"
	if (!g_file_query_exists (_tmp3_, NULL)) {
#line 56 "../lib/sudoku-saver.vala"
		result = NULL;
#line 56 "../lib/sudoku-saver.vala"
		_g_object_unref0 (file);
#line 56 "../lib/sudoku-saver.vala"
		return result;
#line 286 "sudoku-saver.c"
	}
#line 58 "../lib/sudoku-saver.vala"
	_tmp4_ = sudoku_saver_get_savegame_file ();
#line 58 "../lib/sudoku-saver.vala"
	_tmp5_ = _tmp4_;
#line 58 "../lib/sudoku-saver.vala"
	_tmp6_ = sudoku_saver_parse_json_to_game (self, _tmp5_);
#line 58 "../lib/sudoku-saver.vala"
	result = _tmp6_;
#line 58 "../lib/sudoku-saver.vala"
	_g_object_unref0 (file);
#line 58 "../lib/sudoku-saver.vala"
	return result;
#line 300 "sudoku-saver.c"
}

void
sudoku_saver_save_game (SudokuSaver* self,
                        SudokuGame* game)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 61 "../lib/sudoku-saver.vala"
	g_return_if_fail (self != NULL);
#line 61 "../lib/sudoku-saver.vala"
	g_return_if_fail (game != NULL);
#line 63 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver_get_savegame_file ();
#line 63 "../lib/sudoku-saver.vala"
	_tmp1_ = _tmp0_;
#line 63 "../lib/sudoku-saver.vala"
	sudoku_saver_create_file_for_game (self, game, _tmp1_);
#line 319 "sudoku-saver.c"
}

void
sudoku_saver_add_game_to_finished (SudokuSaver* self,
                                   SudokuGame* game,
                                   gboolean delete_savegame)
{
	gchar* file_name = NULL;
	SudokuBoard* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* file_path = NULL;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 66 "../lib/sudoku-saver.vala"
	g_return_if_fail (self != NULL);
#line 66 "../lib/sudoku-saver.vala"
	g_return_if_fail (game != NULL);
#line 68 "../lib/sudoku-saver.vala"
	_tmp0_ = game->board;
#line 68 "../lib/sudoku-saver.vala"
	_tmp1_ = sudoku_board_to_string (_tmp0_, TRUE);
#line 68 "../lib/sudoku-saver.vala"
	_tmp2_ = _tmp1_;
#line 68 "../lib/sudoku-saver.vala"
	_tmp3_ = g_strconcat (_tmp2_, ".save", NULL);
#line 68 "../lib/sudoku-saver.vala"
	_tmp4_ = _tmp3_;
#line 68 "../lib/sudoku-saver.vala"
	_g_free0 (_tmp2_);
#line 68 "../lib/sudoku-saver.vala"
	file_name = _tmp4_;
#line 69 "../lib/sudoku-saver.vala"
	_tmp5_ = sudoku_saver_get_finishgame_dir ();
#line 69 "../lib/sudoku-saver.vala"
	_tmp6_ = _tmp5_;
#line 69 "../lib/sudoku-saver.vala"
	_tmp7_ = file_name;
#line 69 "../lib/sudoku-saver.vala"
	_tmp8_ = g_build_path (G_DIR_SEPARATOR_S, _tmp6_, _tmp7_, NULL);
#line 69 "../lib/sudoku-saver.vala"
	file_path = _tmp8_;
#line 70 "../lib/sudoku-saver.vala"
	_tmp9_ = file_path;
#line 70 "../lib/sudoku-saver.vala"
	sudoku_saver_create_file_for_game (self, game, _tmp9_);
#line 72 "../lib/sudoku-saver.vala"
	if (delete_savegame) {
#line 374 "sudoku-saver.c"
		GFile* file = NULL;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		GFile* _tmp12_;
		GFile* _tmp13_;
#line 75 "../lib/sudoku-saver.vala"
		_tmp10_ = sudoku_saver_get_savegame_file ();
#line 75 "../lib/sudoku-saver.vala"
		_tmp11_ = _tmp10_;
#line 75 "../lib/sudoku-saver.vala"
		_tmp12_ = g_file_new_for_path (_tmp11_);
#line 75 "../lib/sudoku-saver.vala"
		file = _tmp12_;
#line 76 "../lib/sudoku-saver.vala"
		_tmp13_ = file;
#line 76 "../lib/sudoku-saver.vala"
		if (g_file_query_exists (_tmp13_, NULL)) {
#line 392 "sudoku-saver.c"
			{
				GFile* _tmp14_;
#line 80 "../lib/sudoku-saver.vala"
				_tmp14_ = file;
#line 80 "../lib/sudoku-saver.vala"
				g_file_delete (_tmp14_, NULL, &_inner_error0_);
#line 80 "../lib/sudoku-saver.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 401 "sudoku-saver.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GFile* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				GError* _tmp18_;
				const gchar* _tmp19_;
#line 78 "../lib/sudoku-saver.vala"
				e = _inner_error0_;
#line 78 "../lib/sudoku-saver.vala"
				_inner_error0_ = NULL;
#line 84 "../lib/sudoku-saver.vala"
				_tmp15_ = file;
#line 84 "../lib/sudoku-saver.vala"
				_tmp16_ = g_file_get_uri (_tmp15_);
#line 84 "../lib/sudoku-saver.vala"
				_tmp17_ = _tmp16_;
#line 84 "../lib/sudoku-saver.vala"
				_tmp18_ = e;
#line 84 "../lib/sudoku-saver.vala"
				_tmp19_ = _tmp18_->message;
#line 84 "../lib/sudoku-saver.vala"
				g_warning ("sudoku-saver.vala:84: Failed to delete %s: %s", _tmp17_, _tmp19_);
#line 84 "../lib/sudoku-saver.vala"
				_g_free0 (_tmp17_);
#line 78 "../lib/sudoku-saver.vala"
				_g_error_free0 (e);
#line 434 "sudoku-saver.c"
			}
			__finally0:
#line 78 "../lib/sudoku-saver.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 78 "../lib/sudoku-saver.vala"
				_g_object_unref0 (file);
#line 78 "../lib/sudoku-saver.vala"
				_g_free0 (file_path);
#line 78 "../lib/sudoku-saver.vala"
				_g_free0 (file_name);
#line 78 "../lib/sudoku-saver.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 78 "../lib/sudoku-saver.vala"
				g_clear_error (&_inner_error0_);
#line 78 "../lib/sudoku-saver.vala"
				return;
#line 451 "sudoku-saver.c"
			}
		}
#line 72 "../lib/sudoku-saver.vala"
		_g_object_unref0 (file);
#line 456 "sudoku-saver.c"
	}
#line 66 "../lib/sudoku-saver.vala"
	_g_free0 (file_path);
#line 66 "../lib/sudoku-saver.vala"
	_g_free0 (file_name);
#line 462 "sudoku-saver.c"
}

static void
sudoku_saver_create_file_for_game (SudokuSaver* self,
                                   SudokuGame* game,
                                   const gchar* file_name)
{
	gchar* json_str = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 90 "../lib/sudoku-saver.vala"
	g_return_if_fail (self != NULL);
#line 90 "../lib/sudoku-saver.vala"
	g_return_if_fail (game != NULL);
#line 90 "../lib/sudoku-saver.vala"
	g_return_if_fail (file_name != NULL);
#line 92 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver_serialize_game_to_json (self, game);
#line 92 "../lib/sudoku-saver.vala"
	json_str = _tmp0_;
#line 483 "sudoku-saver.c"
	{
#line 96 "../lib/sudoku-saver.vala"
		g_file_set_contents (file_name, json_str, (gssize) -1, &_inner_error0_);
#line 96 "../lib/sudoku-saver.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 489 "sudoku-saver.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 94 "../lib/sudoku-saver.vala"
		e = _inner_error0_;
#line 94 "../lib/sudoku-saver.vala"
		_inner_error0_ = NULL;
#line 100 "../lib/sudoku-saver.vala"
		_tmp1_ = e;
#line 100 "../lib/sudoku-saver.vala"
		_tmp2_ = _tmp1_->message;
#line 100 "../lib/sudoku-saver.vala"
		g_warning ("sudoku-saver.vala:100: %s", _tmp2_);
#line 94 "../lib/sudoku-saver.vala"
		_g_error_free0 (e);
#line 511 "sudoku-saver.c"
	}
	__finally0:
#line 94 "../lib/sudoku-saver.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../lib/sudoku-saver.vala"
		_g_free0 (json_str);
#line 94 "../lib/sudoku-saver.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 94 "../lib/sudoku-saver.vala"
		g_clear_error (&_inner_error0_);
#line 94 "../lib/sudoku-saver.vala"
		return;
#line 524 "sudoku-saver.c"
	}
#line 90 "../lib/sudoku-saver.vala"
	_g_free0 (json_str);
#line 528 "sudoku-saver.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 106 "../lib/sudoku-saver.vala"
	return self ? g_object_ref (self) : NULL;
#line 536 "sudoku-saver.c"
}

static void
_vala_array_add1 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 130 "../lib/sudoku-saver.vala"
	if ((*length) == (*size)) {
#line 130 "../lib/sudoku-saver.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 130 "../lib/sudoku-saver.vala"
		*array = g_renew (gint, *array, *size);
#line 551 "sudoku-saver.c"
	}
#line 130 "../lib/sudoku-saver.vala"
	(*array)[(*length)++] = value;
#line 555 "sudoku-saver.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 166 "../lib/sudoku-saver.vala"
	g_boxed_free (json_node_get_type (), self);
#line 563 "sudoku-saver.c"
}

static gchar*
sudoku_saver_serialize_game_to_json (SudokuSaver* self,
                                     SudokuGame* game)
{
	SudokuBoard* board = NULL;
	SudokuBoard* _tmp0_;
	SudokuBoard* _tmp1_;
	gint* board_cells = NULL;
	SudokuBoard* _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint* _tmp5_;
	gint board_cells_length1;
	gint board_cells_length2;
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp6_;
	JsonBuilder* _tmp7_;
	JsonBuilder* _tmp8_;
	JsonBuilder* _tmp9_;
	SudokuBoard* _tmp10_;
	DifficultyCategory _tmp11_;
	DifficultyCategory _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	JsonBuilder* _tmp15_;
	JsonBuilder* _tmp18_;
	JsonBuilder* _tmp19_;
	JsonBuilder* _tmp62_;
	JsonBuilder* _tmp63_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp64_;
	JsonNode* root = NULL;
	JsonBuilder* _tmp65_;
	JsonNode* _tmp66_;
	gchar* _tmp67_;
	gchar* result;
#line 104 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 104 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 106 "../lib/sudoku-saver.vala"
	_tmp0_ = game->board;
#line 106 "../lib/sudoku-saver.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 106 "../lib/sudoku-saver.vala"
	board = _tmp1_;
#line 107 "../lib/sudoku-saver.vala"
	_tmp2_ = board;
#line 107 "../lib/sudoku-saver.vala"
	_tmp5_ = sudoku_board_get_cells (_tmp2_, &_tmp3_, &_tmp4_);
#line 107 "../lib/sudoku-saver.vala"
	board_cells = _tmp5_;
#line 107 "../lib/sudoku-saver.vala"
	board_cells_length1 = _tmp3_;
#line 107 "../lib/sudoku-saver.vala"
	board_cells_length2 = _tmp4_;
#line 108 "../lib/sudoku-saver.vala"
	_tmp6_ = json_builder_new ();
#line 108 "../lib/sudoku-saver.vala"
	builder = _tmp6_;
#line 110 "../lib/sudoku-saver.vala"
	_tmp7_ = builder;
#line 110 "../lib/sudoku-saver.vala"
	json_builder_begin_object (_tmp7_);
#line 111 "../lib/sudoku-saver.vala"
	_tmp8_ = builder;
#line 111 "../lib/sudoku-saver.vala"
	json_builder_set_member_name (_tmp8_, "difficulty_category");
#line 112 "../lib/sudoku-saver.vala"
	_tmp9_ = builder;
#line 112 "../lib/sudoku-saver.vala"
	_tmp10_ = board;
#line 112 "../lib/sudoku-saver.vala"
	_tmp11_ = sudoku_board_get_difficulty_category (_tmp10_);
#line 112 "../lib/sudoku-saver.vala"
	_tmp12_ = _tmp11_;
#line 112 "../lib/sudoku-saver.vala"
	_tmp13_ = difficulty_category_to_untranslated_string (_tmp12_);
#line 112 "../lib/sudoku-saver.vala"
	_tmp14_ = _tmp13_;
#line 112 "../lib/sudoku-saver.vala"
	json_builder_add_string_value (_tmp9_, _tmp14_);
#line 112 "../lib/sudoku-saver.vala"
	_g_free0 (_tmp14_);
#line 114 "../lib/sudoku-saver.vala"
	_tmp15_ = builder;
#line 114 "../lib/sudoku-saver.vala"
	json_builder_set_member_name (_tmp15_, "time_elapsed");
#line 115 "../lib/sudoku-saver.vala"
	if (game->mode == GAME_MODE_CREATE) {
#line 656 "sudoku-saver.c"
		JsonBuilder* _tmp16_;
#line 116 "../lib/sudoku-saver.vala"
		_tmp16_ = builder;
#line 116 "../lib/sudoku-saver.vala"
		json_builder_add_double_value (_tmp16_, (gdouble) 0);
#line 662 "sudoku-saver.c"
	} else {
		JsonBuilder* _tmp17_;
#line 118 "../lib/sudoku-saver.vala"
		_tmp17_ = builder;
#line 118 "../lib/sudoku-saver.vala"
		json_builder_add_double_value (_tmp17_, sudoku_game_get_total_time_played (game));
#line 669 "sudoku-saver.c"
	}
#line 120 "../lib/sudoku-saver.vala"
	_tmp18_ = builder;
#line 120 "../lib/sudoku-saver.vala"
	json_builder_set_member_name (_tmp18_, "cells");
#line 121 "../lib/sudoku-saver.vala"
	_tmp19_ = builder;
#line 121 "../lib/sudoku-saver.vala"
	json_builder_begin_array (_tmp19_);
#line 679 "sudoku-saver.c"
	{
		gint i = 0;
#line 123 "../lib/sudoku-saver.vala"
		i = 0;
#line 684 "sudoku-saver.c"
		{
			gboolean _tmp20_ = FALSE;
#line 123 "../lib/sudoku-saver.vala"
			_tmp20_ = TRUE;
#line 123 "../lib/sudoku-saver.vala"
			while (TRUE) {
#line 691 "sudoku-saver.c"
				SudokuBoard* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
#line 123 "../lib/sudoku-saver.vala"
				if (!_tmp20_) {
#line 697 "sudoku-saver.c"
					gint _tmp21_;
#line 123 "../lib/sudoku-saver.vala"
					_tmp21_ = i;
#line 123 "../lib/sudoku-saver.vala"
					i = _tmp21_ + 1;
#line 703 "sudoku-saver.c"
				}
#line 123 "../lib/sudoku-saver.vala"
				_tmp20_ = FALSE;
#line 123 "../lib/sudoku-saver.vala"
				_tmp22_ = board;
#line 123 "../lib/sudoku-saver.vala"
				_tmp23_ = sudoku_board_get_rows (_tmp22_);
#line 123 "../lib/sudoku-saver.vala"
				_tmp24_ = _tmp23_;
#line 123 "../lib/sudoku-saver.vala"
				if (!(i < _tmp24_)) {
#line 123 "../lib/sudoku-saver.vala"
					break;
#line 717 "sudoku-saver.c"
				}
				{
					gint j = 0;
#line 125 "../lib/sudoku-saver.vala"
					j = 0;
#line 723 "sudoku-saver.c"
					{
						gboolean _tmp25_ = FALSE;
#line 125 "../lib/sudoku-saver.vala"
						_tmp25_ = TRUE;
#line 125 "../lib/sudoku-saver.vala"
						while (TRUE) {
#line 730 "sudoku-saver.c"
							SudokuBoard* _tmp27_;
							gint _tmp28_;
							gint _tmp29_;
							gint* earmarks = NULL;
							gint* _tmp30_;
							gint earmarks_length1;
							gint _earmarks_size_;
							gboolean _tmp37_ = FALSE;
							gint* _tmp38_;
							gint _tmp38__length1;
							gint _tmp38__length2;
							gint _tmp39_;
							JsonBuilder* _tmp41_;
							JsonBuilder* _tmp42_;
							JsonBuilder* _tmp43_;
							JsonBuilder* _tmp44_;
							JsonBuilder* _tmp45_;
							JsonBuilder* _tmp46_;
							JsonBuilder* _tmp47_;
							JsonBuilder* _tmp48_;
							gint* _tmp49_;
							gint _tmp49__length1;
							gint _tmp49__length2;
							gint _tmp50_;
							JsonBuilder* _tmp51_;
							JsonBuilder* _tmp52_;
							SudokuBoard* _tmp53_;
							gboolean* _tmp54_;
							gint _tmp54__length1;
							gint _tmp54__length2;
							gboolean _tmp55_;
							JsonBuilder* _tmp56_;
							JsonBuilder* _tmp57_;
							gint* _tmp58_;
							gint _tmp58__length1;
							JsonBuilder* _tmp60_;
							JsonBuilder* _tmp61_;
#line 125 "../lib/sudoku-saver.vala"
							if (!_tmp25_) {
#line 770 "sudoku-saver.c"
								gint _tmp26_;
#line 125 "../lib/sudoku-saver.vala"
								_tmp26_ = j;
#line 125 "../lib/sudoku-saver.vala"
								j = _tmp26_ + 1;
#line 776 "sudoku-saver.c"
							}
#line 125 "../lib/sudoku-saver.vala"
							_tmp25_ = FALSE;
#line 125 "../lib/sudoku-saver.vala"
							_tmp27_ = board;
#line 125 "../lib/sudoku-saver.vala"
							_tmp28_ = sudoku_board_get_cols (_tmp27_);
#line 125 "../lib/sudoku-saver.vala"
							_tmp29_ = _tmp28_;
#line 125 "../lib/sudoku-saver.vala"
							if (!(j < _tmp29_)) {
#line 125 "../lib/sudoku-saver.vala"
								break;
#line 790 "sudoku-saver.c"
							}
#line 127 "../lib/sudoku-saver.vala"
							_tmp30_ = g_new0 (gint, 0);
#line 127 "../lib/sudoku-saver.vala"
							earmarks = _tmp30_;
#line 127 "../lib/sudoku-saver.vala"
							earmarks_length1 = 0;
#line 127 "../lib/sudoku-saver.vala"
							_earmarks_size_ = earmarks_length1;
#line 800 "sudoku-saver.c"
							{
								gint k = 0;
#line 128 "../lib/sudoku-saver.vala"
								k = 1;
#line 805 "sudoku-saver.c"
								{
									gboolean _tmp31_ = FALSE;
#line 128 "../lib/sudoku-saver.vala"
									_tmp31_ = TRUE;
#line 128 "../lib/sudoku-saver.vala"
									while (TRUE) {
#line 812 "sudoku-saver.c"
										SudokuBoard* _tmp33_;
										gint _tmp34_;
										gint _tmp35_;
										SudokuBoard* _tmp36_;
#line 128 "../lib/sudoku-saver.vala"
										if (!_tmp31_) {
#line 819 "sudoku-saver.c"
											gint _tmp32_;
#line 128 "../lib/sudoku-saver.vala"
											_tmp32_ = k;
#line 128 "../lib/sudoku-saver.vala"
											k = _tmp32_ + 1;
#line 825 "sudoku-saver.c"
										}
#line 128 "../lib/sudoku-saver.vala"
										_tmp31_ = FALSE;
#line 128 "../lib/sudoku-saver.vala"
										_tmp33_ = board;
#line 128 "../lib/sudoku-saver.vala"
										_tmp34_ = sudoku_board_get_max_val (_tmp33_);
#line 128 "../lib/sudoku-saver.vala"
										_tmp35_ = _tmp34_;
#line 128 "../lib/sudoku-saver.vala"
										if (!(k <= _tmp35_)) {
#line 128 "../lib/sudoku-saver.vala"
											break;
#line 839 "sudoku-saver.c"
										}
#line 129 "../lib/sudoku-saver.vala"
										_tmp36_ = board;
#line 129 "../lib/sudoku-saver.vala"
										if (sudoku_board_is_earmark_enabled (_tmp36_, i, j, k)) {
#line 130 "../lib/sudoku-saver.vala"
											_vala_array_add1 (&earmarks, &earmarks_length1, &_earmarks_size_, k);
#line 847 "sudoku-saver.c"
										}
									}
								}
							}
#line 132 "../lib/sudoku-saver.vala"
							_tmp38_ = board_cells;
#line 132 "../lib/sudoku-saver.vala"
							_tmp38__length1 = board_cells_length1;
#line 132 "../lib/sudoku-saver.vala"
							_tmp38__length2 = board_cells_length2;
#line 132 "../lib/sudoku-saver.vala"
							_tmp39_ = _tmp38_[(i * _tmp38__length2) + j];
#line 132 "../lib/sudoku-saver.vala"
							if (_tmp39_ == 0) {
#line 862 "sudoku-saver.c"
								gint* _tmp40_;
								gint _tmp40__length1;
#line 132 "../lib/sudoku-saver.vala"
								_tmp40_ = earmarks;
#line 132 "../lib/sudoku-saver.vala"
								_tmp40__length1 = earmarks_length1;
#line 132 "../lib/sudoku-saver.vala"
								_tmp37_ = _tmp40__length1 == 0;
#line 871 "sudoku-saver.c"
							} else {
#line 132 "../lib/sudoku-saver.vala"
								_tmp37_ = FALSE;
#line 875 "sudoku-saver.c"
							}
#line 132 "../lib/sudoku-saver.vala"
							if (_tmp37_) {
#line 133 "../lib/sudoku-saver.vala"
								earmarks = (g_free (earmarks), NULL);
#line 133 "../lib/sudoku-saver.vala"
								continue;
#line 883 "sudoku-saver.c"
							}
#line 135 "../lib/sudoku-saver.vala"
							_tmp41_ = builder;
#line 135 "../lib/sudoku-saver.vala"
							json_builder_begin_object (_tmp41_);
#line 137 "../lib/sudoku-saver.vala"
							_tmp42_ = builder;
#line 137 "../lib/sudoku-saver.vala"
							json_builder_set_member_name (_tmp42_, "position");
#line 138 "../lib/sudoku-saver.vala"
							_tmp43_ = builder;
#line 138 "../lib/sudoku-saver.vala"
							json_builder_begin_array (_tmp43_);
#line 139 "../lib/sudoku-saver.vala"
							_tmp44_ = builder;
#line 139 "../lib/sudoku-saver.vala"
							json_builder_add_int_value (_tmp44_, (gint64) i);
#line 140 "../lib/sudoku-saver.vala"
							_tmp45_ = builder;
#line 140 "../lib/sudoku-saver.vala"
							json_builder_add_int_value (_tmp45_, (gint64) j);
#line 141 "../lib/sudoku-saver.vala"
							_tmp46_ = builder;
#line 141 "../lib/sudoku-saver.vala"
							json_builder_end_array (_tmp46_);
#line 142 "../lib/sudoku-saver.vala"
							_tmp47_ = builder;
#line 142 "../lib/sudoku-saver.vala"
							json_builder_set_member_name (_tmp47_, "value");
#line 143 "../lib/sudoku-saver.vala"
							_tmp48_ = builder;
#line 143 "../lib/sudoku-saver.vala"
							_tmp49_ = board_cells;
#line 143 "../lib/sudoku-saver.vala"
							_tmp49__length1 = board_cells_length1;
#line 143 "../lib/sudoku-saver.vala"
							_tmp49__length2 = board_cells_length2;
#line 143 "../lib/sudoku-saver.vala"
							_tmp50_ = _tmp49_[(i * _tmp49__length2) + j];
#line 143 "../lib/sudoku-saver.vala"
							json_builder_add_int_value (_tmp48_, (gint64) _tmp50_);
#line 144 "../lib/sudoku-saver.vala"
							_tmp51_ = builder;
#line 144 "../lib/sudoku-saver.vala"
							json_builder_set_member_name (_tmp51_, "fixed");
#line 145 "../lib/sudoku-saver.vala"
							_tmp52_ = builder;
#line 145 "../lib/sudoku-saver.vala"
							_tmp53_ = board;
#line 145 "../lib/sudoku-saver.vala"
							_tmp54_ = _tmp53_->is_fixed;
#line 145 "../lib/sudoku-saver.vala"
							_tmp54__length1 = _tmp53_->is_fixed_length1;
#line 145 "../lib/sudoku-saver.vala"
							_tmp54__length2 = _tmp53_->is_fixed_length2;
#line 145 "../lib/sudoku-saver.vala"
							_tmp55_ = _tmp54_[(i * _tmp54__length2) + j];
#line 145 "../lib/sudoku-saver.vala"
							json_builder_add_boolean_value (_tmp52_, _tmp55_);
#line 146 "../lib/sudoku-saver.vala"
							_tmp56_ = builder;
#line 146 "../lib/sudoku-saver.vala"
							json_builder_set_member_name (_tmp56_, "earmarks");
#line 147 "../lib/sudoku-saver.vala"
							_tmp57_ = builder;
#line 147 "../lib/sudoku-saver.vala"
							json_builder_begin_array (_tmp57_);
#line 149 "../lib/sudoku-saver.vala"
							_tmp58_ = earmarks;
#line 149 "../lib/sudoku-saver.vala"
							_tmp58__length1 = earmarks_length1;
#line 955 "sudoku-saver.c"
							{
								gint* k_collection = NULL;
								gint k_collection_length1 = 0;
								gint _k_collection_size_ = 0;
								gint k_it = 0;
#line 149 "../lib/sudoku-saver.vala"
								k_collection = _tmp58_;
#line 149 "../lib/sudoku-saver.vala"
								k_collection_length1 = _tmp58__length1;
#line 149 "../lib/sudoku-saver.vala"
								for (k_it = 0; k_it < k_collection_length1; k_it = k_it + 1) {
#line 967 "sudoku-saver.c"
									gint k = 0;
#line 149 "../lib/sudoku-saver.vala"
									k = k_collection[k_it];
#line 971 "sudoku-saver.c"
									{
										JsonBuilder* _tmp59_;
#line 150 "../lib/sudoku-saver.vala"
										_tmp59_ = builder;
#line 150 "../lib/sudoku-saver.vala"
										json_builder_add_int_value (_tmp59_, (gint64) k);
#line 978 "sudoku-saver.c"
									}
								}
							}
#line 152 "../lib/sudoku-saver.vala"
							_tmp60_ = builder;
#line 152 "../lib/sudoku-saver.vala"
							json_builder_end_array (_tmp60_);
#line 154 "../lib/sudoku-saver.vala"
							_tmp61_ = builder;
#line 154 "../lib/sudoku-saver.vala"
							json_builder_end_object (_tmp61_);
#line 125 "../lib/sudoku-saver.vala"
							earmarks = (g_free (earmarks), NULL);
#line 992 "sudoku-saver.c"
						}
					}
				}
			}
		}
	}
#line 158 "../lib/sudoku-saver.vala"
	_tmp62_ = builder;
#line 158 "../lib/sudoku-saver.vala"
	json_builder_end_array (_tmp62_);
#line 159 "../lib/sudoku-saver.vala"
	_tmp63_ = builder;
#line 159 "../lib/sudoku-saver.vala"
	json_builder_end_object (_tmp63_);
#line 161 "../lib/sudoku-saver.vala"
	_tmp64_ = json_generator_new ();
#line 161 "../lib/sudoku-saver.vala"
	generator = _tmp64_;
#line 162 "../lib/sudoku-saver.vala"
	json_generator_set_pretty (generator, TRUE);
#line 163 "../lib/sudoku-saver.vala"
	_tmp65_ = builder;
#line 163 "../lib/sudoku-saver.vala"
	_tmp66_ = json_builder_get_root (_tmp65_);
#line 163 "../lib/sudoku-saver.vala"
	root = _tmp66_;
#line 164 "../lib/sudoku-saver.vala"
	json_generator_set_root (generator, root);
#line 166 "../lib/sudoku-saver.vala"
	_tmp67_ = json_generator_to_data (generator, NULL);
#line 166 "../lib/sudoku-saver.vala"
	result = _tmp67_;
#line 166 "../lib/sudoku-saver.vala"
	__vala_JsonNode_free0 (root);
#line 166 "../lib/sudoku-saver.vala"
	_g_object_unref0 (generator);
#line 166 "../lib/sudoku-saver.vala"
	_g_object_unref0 (builder);
#line 166 "../lib/sudoku-saver.vala"
	board_cells = (g_free (board_cells), NULL);
#line 166 "../lib/sudoku-saver.vala"
	_g_object_unref0 (board);
#line 166 "../lib/sudoku-saver.vala"
	return result;
#line 1037 "sudoku-saver.c"
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 182 "../lib/sudoku-saver.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 1045 "sudoku-saver.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 182 "../lib/sudoku-saver.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 1053 "sudoku-saver.c"
}

static SudokuGame*
sudoku_saver_parse_json_to_game (SudokuSaver* self,
                                 const gchar* file_path)
{
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	SudokuBoard* board = NULL;
	SudokuBoard* _tmp2_;
	JsonNode* node = NULL;
	JsonParser* _tmp3_;
	JsonNode* _tmp4_;
	JsonNode* _tmp5_;
	JsonReader* reader = NULL;
	JsonNode* _tmp6_;
	JsonReader* _tmp7_;
	JsonReader* _tmp8_;
	JsonReader* _tmp9_;
	JsonReader* _tmp47_;
	JsonReader* _tmp48_;
	JsonReader* _tmp49_;
	SudokuBoard* _tmp50_;
	JsonReader* _tmp51_;
	JsonReader* _tmp52_;
	JsonReader* _tmp53_;
	JsonReader* _tmp54_;
	SudokuBoard* _tmp55_;
	JsonReader* _tmp56_;
	const gchar* _tmp57_;
	JsonReader* _tmp58_;
	SudokuBoard* _tmp59_;
	SudokuGame* _tmp60_;
	GError* _inner_error0_ = NULL;
	SudokuGame* result;
#line 169 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 169 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 171 "../lib/sudoku-saver.vala"
	_tmp0_ = json_parser_new ();
#line 171 "../lib/sudoku-saver.vala"
	parser = _tmp0_;
#line 1097 "sudoku-saver.c"
	{
		JsonParser* _tmp1_;
#line 174 "../lib/sudoku-saver.vala"
		_tmp1_ = parser;
#line 174 "../lib/sudoku-saver.vala"
		json_parser_load_from_file (_tmp1_, file_path, &_inner_error0_);
#line 174 "../lib/sudoku-saver.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1106 "sudoku-saver.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 172 "../lib/sudoku-saver.vala"
		g_clear_error (&_inner_error0_);
#line 178 "../lib/sudoku-saver.vala"
		result = NULL;
#line 178 "../lib/sudoku-saver.vala"
		_g_object_unref0 (parser);
#line 178 "../lib/sudoku-saver.vala"
		return result;
#line 1121 "sudoku-saver.c"
	}
	__finally0:
#line 172 "../lib/sudoku-saver.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "../lib/sudoku-saver.vala"
		_g_object_unref0 (parser);
#line 172 "../lib/sudoku-saver.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 172 "../lib/sudoku-saver.vala"
		g_clear_error (&_inner_error0_);
#line 172 "../lib/sudoku-saver.vala"
		return NULL;
#line 1134 "sudoku-saver.c"
	}
#line 181 "../lib/sudoku-saver.vala"
	_tmp2_ = sudoku_board_new (3, 3);
#line 181 "../lib/sudoku-saver.vala"
	board = _tmp2_;
#line 182 "../lib/sudoku-saver.vala"
	_tmp3_ = parser;
#line 182 "../lib/sudoku-saver.vala"
	_tmp4_ = json_parser_get_root (_tmp3_);
#line 182 "../lib/sudoku-saver.vala"
	_tmp5_ = __vala_JsonNode_copy0 (_tmp4_);
#line 182 "../lib/sudoku-saver.vala"
	node = _tmp5_;
#line 183 "../lib/sudoku-saver.vala"
	_tmp6_ = node;
#line 183 "../lib/sudoku-saver.vala"
	_tmp7_ = json_reader_new (_tmp6_);
#line 183 "../lib/sudoku-saver.vala"
	reader = _tmp7_;
#line 184 "../lib/sudoku-saver.vala"
	_tmp8_ = reader;
#line 184 "../lib/sudoku-saver.vala"
	json_reader_read_member (_tmp8_, "cells");
#line 185 "../lib/sudoku-saver.vala"
	_tmp9_ = reader;
#line 185 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (json_reader_is_array (_tmp9_), NULL);
#line 1162 "sudoku-saver.c"
	{
		gint i = 0;
#line 187 "../lib/sudoku-saver.vala"
		i = 0;
#line 1167 "sudoku-saver.c"
		{
			gboolean _tmp10_ = FALSE;
#line 187 "../lib/sudoku-saver.vala"
			_tmp10_ = TRUE;
#line 187 "../lib/sudoku-saver.vala"
			while (TRUE) {
#line 1174 "sudoku-saver.c"
				JsonReader* _tmp12_;
				JsonReader* _tmp13_;
				JsonReader* _tmp14_;
				JsonReader* _tmp15_;
				JsonReader* _tmp16_;
				JsonReader* _tmp17_;
				JsonReader* _tmp18_;
				gint row = 0;
				JsonReader* _tmp19_;
				JsonReader* _tmp20_;
				JsonReader* _tmp21_;
				JsonReader* _tmp22_;
				gint col = 0;
				JsonReader* _tmp23_;
				JsonReader* _tmp24_;
				JsonReader* _tmp25_;
				JsonReader* _tmp26_;
				JsonReader* _tmp27_;
				gint val = 0;
				JsonReader* _tmp28_;
				JsonReader* _tmp29_;
				JsonReader* _tmp30_;
				JsonReader* _tmp31_;
				gboolean is_fixed = FALSE;
				JsonReader* _tmp32_;
				JsonReader* _tmp33_;
				JsonReader* _tmp35_;
				JsonReader* _tmp36_;
				JsonReader* _tmp45_;
				JsonReader* _tmp46_;
#line 187 "../lib/sudoku-saver.vala"
				if (!_tmp10_) {
#line 1207 "sudoku-saver.c"
					gint _tmp11_;
#line 187 "../lib/sudoku-saver.vala"
					_tmp11_ = i;
#line 187 "../lib/sudoku-saver.vala"
					i = _tmp11_ + 1;
#line 1213 "sudoku-saver.c"
				}
#line 187 "../lib/sudoku-saver.vala"
				_tmp10_ = FALSE;
#line 187 "../lib/sudoku-saver.vala"
				_tmp12_ = reader;
#line 187 "../lib/sudoku-saver.vala"
				if (!(i < json_reader_count_elements (_tmp12_))) {
#line 187 "../lib/sudoku-saver.vala"
					break;
#line 1223 "sudoku-saver.c"
				}
#line 189 "../lib/sudoku-saver.vala"
				_tmp13_ = reader;
#line 189 "../lib/sudoku-saver.vala"
				json_reader_read_element (_tmp13_, (guint) i);
#line 191 "../lib/sudoku-saver.vala"
				_tmp14_ = reader;
#line 191 "../lib/sudoku-saver.vala"
				json_reader_read_member (_tmp14_, "position");
#line 192 "../lib/sudoku-saver.vala"
				_tmp15_ = reader;
#line 192 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_array (_tmp15_), NULL);
#line 193 "../lib/sudoku-saver.vala"
				_tmp16_ = reader;
#line 193 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_count_elements (_tmp16_) == 2, NULL);
#line 194 "../lib/sudoku-saver.vala"
				_tmp17_ = reader;
#line 194 "../lib/sudoku-saver.vala"
				json_reader_read_element (_tmp17_, (guint) 0);
#line 195 "../lib/sudoku-saver.vala"
				_tmp18_ = reader;
#line 195 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_value (_tmp18_), NULL);
#line 196 "../lib/sudoku-saver.vala"
				_tmp19_ = reader;
#line 196 "../lib/sudoku-saver.vala"
				row = (gint) json_reader_get_int_value (_tmp19_);
#line 197 "../lib/sudoku-saver.vala"
				_tmp20_ = reader;
#line 197 "../lib/sudoku-saver.vala"
				json_reader_end_element (_tmp20_);
#line 199 "../lib/sudoku-saver.vala"
				_tmp21_ = reader;
#line 199 "../lib/sudoku-saver.vala"
				json_reader_read_element (_tmp21_, (guint) 1);
#line 200 "../lib/sudoku-saver.vala"
				_tmp22_ = reader;
#line 200 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_value (_tmp22_), NULL);
#line 201 "../lib/sudoku-saver.vala"
				_tmp23_ = reader;
#line 201 "../lib/sudoku-saver.vala"
				col = (gint) json_reader_get_int_value (_tmp23_);
#line 202 "../lib/sudoku-saver.vala"
				_tmp24_ = reader;
#line 202 "../lib/sudoku-saver.vala"
				json_reader_end_element (_tmp24_);
#line 203 "../lib/sudoku-saver.vala"
				_tmp25_ = reader;
#line 203 "../lib/sudoku-saver.vala"
				json_reader_end_member (_tmp25_);
#line 205 "../lib/sudoku-saver.vala"
				_tmp26_ = reader;
#line 205 "../lib/sudoku-saver.vala"
				json_reader_read_member (_tmp26_, "value");
#line 206 "../lib/sudoku-saver.vala"
				_tmp27_ = reader;
#line 206 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_value (_tmp27_), NULL);
#line 207 "../lib/sudoku-saver.vala"
				_tmp28_ = reader;
#line 207 "../lib/sudoku-saver.vala"
				val = (gint) json_reader_get_int_value (_tmp28_);
#line 208 "../lib/sudoku-saver.vala"
				_tmp29_ = reader;
#line 208 "../lib/sudoku-saver.vala"
				json_reader_end_member (_tmp29_);
#line 210 "../lib/sudoku-saver.vala"
				_tmp30_ = reader;
#line 210 "../lib/sudoku-saver.vala"
				json_reader_read_member (_tmp30_, "fixed");
#line 211 "../lib/sudoku-saver.vala"
				_tmp31_ = reader;
#line 211 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_value (_tmp31_), NULL);
#line 212 "../lib/sudoku-saver.vala"
				_tmp32_ = reader;
#line 212 "../lib/sudoku-saver.vala"
				is_fixed = json_reader_get_boolean_value (_tmp32_);
#line 213 "../lib/sudoku-saver.vala"
				_tmp33_ = reader;
#line 213 "../lib/sudoku-saver.vala"
				json_reader_end_member (_tmp33_);
#line 215 "../lib/sudoku-saver.vala"
				if (val != 0) {
#line 1311 "sudoku-saver.c"
					SudokuBoard* _tmp34_;
#line 216 "../lib/sudoku-saver.vala"
					_tmp34_ = board;
#line 216 "../lib/sudoku-saver.vala"
					sudoku_board_insert (_tmp34_, row, col, val, is_fixed);
#line 1317 "sudoku-saver.c"
				}
#line 218 "../lib/sudoku-saver.vala"
				_tmp35_ = reader;
#line 218 "../lib/sudoku-saver.vala"
				json_reader_read_member (_tmp35_, "earmarks");
#line 219 "../lib/sudoku-saver.vala"
				_tmp36_ = reader;
#line 219 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_array (_tmp36_), NULL);
#line 1327 "sudoku-saver.c"
				{
					gint k = 0;
#line 220 "../lib/sudoku-saver.vala"
					k = 0;
#line 1332 "sudoku-saver.c"
					{
						gboolean _tmp37_ = FALSE;
#line 220 "../lib/sudoku-saver.vala"
						_tmp37_ = TRUE;
#line 220 "../lib/sudoku-saver.vala"
						while (TRUE) {
#line 1339 "sudoku-saver.c"
							JsonReader* _tmp39_;
							JsonReader* _tmp40_;
							JsonReader* _tmp41_;
							SudokuBoard* _tmp42_;
							JsonReader* _tmp43_;
							JsonReader* _tmp44_;
#line 220 "../lib/sudoku-saver.vala"
							if (!_tmp37_) {
#line 1348 "sudoku-saver.c"
								gint _tmp38_;
#line 220 "../lib/sudoku-saver.vala"
								_tmp38_ = k;
#line 220 "../lib/sudoku-saver.vala"
								k = _tmp38_ + 1;
#line 1354 "sudoku-saver.c"
							}
#line 220 "../lib/sudoku-saver.vala"
							_tmp37_ = FALSE;
#line 220 "../lib/sudoku-saver.vala"
							_tmp39_ = reader;
#line 220 "../lib/sudoku-saver.vala"
							if (!(k < json_reader_count_elements (_tmp39_))) {
#line 220 "../lib/sudoku-saver.vala"
								break;
#line 1364 "sudoku-saver.c"
							}
#line 222 "../lib/sudoku-saver.vala"
							_tmp40_ = reader;
#line 222 "../lib/sudoku-saver.vala"
							json_reader_read_element (_tmp40_, (guint) k);
#line 223 "../lib/sudoku-saver.vala"
							_tmp41_ = reader;
#line 223 "../lib/sudoku-saver.vala"
							g_return_val_if_fail (json_reader_is_value (_tmp41_), NULL);
#line 224 "../lib/sudoku-saver.vala"
							_tmp42_ = board;
#line 224 "../lib/sudoku-saver.vala"
							_tmp43_ = reader;
#line 224 "../lib/sudoku-saver.vala"
							sudoku_board_enable_earmark (_tmp42_, row, col, (gint) json_reader_get_int_value (_tmp43_));
#line 225 "../lib/sudoku-saver.vala"
							_tmp44_ = reader;
#line 225 "../lib/sudoku-saver.vala"
							json_reader_end_element (_tmp44_);
#line 1384 "sudoku-saver.c"
						}
					}
				}
#line 227 "../lib/sudoku-saver.vala"
				_tmp45_ = reader;
#line 227 "../lib/sudoku-saver.vala"
				json_reader_end_member (_tmp45_);
#line 229 "../lib/sudoku-saver.vala"
				_tmp46_ = reader;
#line 229 "../lib/sudoku-saver.vala"
				json_reader_end_element (_tmp46_);
#line 1396 "sudoku-saver.c"
			}
		}
	}
#line 231 "../lib/sudoku-saver.vala"
	_tmp47_ = reader;
#line 231 "../lib/sudoku-saver.vala"
	json_reader_end_member (_tmp47_);
#line 233 "../lib/sudoku-saver.vala"
	_tmp48_ = reader;
#line 233 "../lib/sudoku-saver.vala"
	json_reader_read_member (_tmp48_, "time_elapsed");
#line 234 "../lib/sudoku-saver.vala"
	_tmp49_ = reader;
#line 234 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (json_reader_is_value (_tmp49_), NULL);
#line 235 "../lib/sudoku-saver.vala"
	_tmp50_ = board;
#line 235 "../lib/sudoku-saver.vala"
	_tmp51_ = reader;
#line 235 "../lib/sudoku-saver.vala"
	sudoku_board_set_previous_played_time (_tmp50_, json_reader_get_double_value (_tmp51_));
#line 236 "../lib/sudoku-saver.vala"
	_tmp52_ = reader;
#line 236 "../lib/sudoku-saver.vala"
	json_reader_end_member (_tmp52_);
#line 238 "../lib/sudoku-saver.vala"
	_tmp53_ = reader;
#line 238 "../lib/sudoku-saver.vala"
	json_reader_read_member (_tmp53_, "difficulty_category");
#line 239 "../lib/sudoku-saver.vala"
	_tmp54_ = reader;
#line 239 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (json_reader_is_value (_tmp54_), NULL);
#line 240 "../lib/sudoku-saver.vala"
	_tmp55_ = board;
#line 240 "../lib/sudoku-saver.vala"
	_tmp56_ = reader;
#line 240 "../lib/sudoku-saver.vala"
	_tmp57_ = json_reader_get_string_value (_tmp56_);
#line 240 "../lib/sudoku-saver.vala"
	sudoku_board_set_difficulty_category (_tmp55_, difficulty_category_from_string (_tmp57_));
#line 241 "../lib/sudoku-saver.vala"
	_tmp58_ = reader;
#line 241 "../lib/sudoku-saver.vala"
	json_reader_end_member (_tmp58_);
#line 243 "../lib/sudoku-saver.vala"
	_tmp59_ = board;
#line 243 "../lib/sudoku-saver.vala"
	_tmp60_ = sudoku_game_new (_tmp59_);
#line 243 "../lib/sudoku-saver.vala"
	result = _tmp60_;
#line 243 "../lib/sudoku-saver.vala"
	_g_object_unref0 (reader);
#line 243 "../lib/sudoku-saver.vala"
	__vala_JsonNode_free0 (node);
#line 243 "../lib/sudoku-saver.vala"
	_g_object_unref0 (board);
#line 243 "../lib/sudoku-saver.vala"
	_g_object_unref0 (parser);
#line 243 "../lib/sudoku-saver.vala"
	return result;
#line 1458 "sudoku-saver.c"
}

const gchar*
sudoku_saver_get_savegame_file (void)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver__savegame_file;
#line 26 "../lib/sudoku-saver.vala"
	result = _tmp0_;
#line 26 "../lib/sudoku-saver.vala"
	return result;
#line 1472 "sudoku-saver.c"
}

static void
sudoku_saver_set_savegame_file (const gchar* value)
{
	gchar* _tmp0_;
#line 26 "../lib/sudoku-saver.vala"
	_tmp0_ = g_strdup (value);
#line 26 "../lib/sudoku-saver.vala"
	_g_free0 (sudoku_saver__savegame_file);
#line 26 "../lib/sudoku-saver.vala"
	sudoku_saver__savegame_file = _tmp0_;
#line 1485 "sudoku-saver.c"
}

const gchar*
sudoku_saver_get_finishgame_dir (void)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 27 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver__finishgame_dir;
#line 27 "../lib/sudoku-saver.vala"
	result = _tmp0_;
#line 27 "../lib/sudoku-saver.vala"
	return result;
#line 1499 "sudoku-saver.c"
}

static void
sudoku_saver_set_finishgame_dir (const gchar* value)
{
	gchar* _tmp0_;
#line 27 "../lib/sudoku-saver.vala"
	_tmp0_ = g_strdup (value);
#line 27 "../lib/sudoku-saver.vala"
	_g_free0 (sudoku_saver__finishgame_dir);
#line 27 "../lib/sudoku-saver.vala"
	sudoku_saver__finishgame_dir = _tmp0_;
#line 1512 "sudoku-saver.c"
}

static void
sudoku_saver_class_init (SudokuSaverClass * klass,
                         gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 24 "../lib/sudoku-saver.vala"
	sudoku_saver_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/sudoku-saver.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_saver_get_property;
#line 24 "../lib/sudoku-saver.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_saver_set_property;
#line 24 "../lib/sudoku-saver.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_saver_finalize;
#line 26 "../lib/sudoku-saver.vala"
	_tmp0_ = g_strdup ("");
#line 26 "../lib/sudoku-saver.vala"
	sudoku_saver__savegame_file = _tmp0_;
#line 27 "../lib/sudoku-saver.vala"
	_tmp1_ = g_strdup ("");
#line 27 "../lib/sudoku-saver.vala"
	sudoku_saver__finishgame_dir = _tmp1_;
#line 1537 "sudoku-saver.c"
}

static void
sudoku_saver_instance_init (SudokuSaver * self,
                            gpointer klass)
{
}

static void
sudoku_saver_finalize (GObject * obj)
{
	SudokuSaver * self;
#line 24 "../lib/sudoku-saver.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_SAVER, SudokuSaver);
#line 24 "../lib/sudoku-saver.vala"
	G_OBJECT_CLASS (sudoku_saver_parent_class)->finalize (obj);
#line 1554 "sudoku-saver.c"
}

static GType
sudoku_saver_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuSaverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_saver_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuSaver), 0, (GInstanceInitFunc) sudoku_saver_instance_init, NULL };
	GType sudoku_saver_type_id;
	sudoku_saver_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuSaver", &g_define_type_info, 0);
	return sudoku_saver_type_id;
}

GType
sudoku_saver_get_type (void)
{
	static volatile gsize sudoku_saver_type_id__once = 0;
	if (g_once_init_enter (&sudoku_saver_type_id__once)) {
		GType sudoku_saver_type_id;
		sudoku_saver_type_id = sudoku_saver_get_type_once ();
		g_once_init_leave (&sudoku_saver_type_id__once, sudoku_saver_type_id);
	}
	return sudoku_saver_type_id__once;
}

static void
_vala_sudoku_saver_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	SudokuSaver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_SAVER, SudokuSaver);
#line 24 "../lib/sudoku-saver.vala"
	switch (property_id) {
#line 1588 "sudoku-saver.c"
		default:
#line 24 "../lib/sudoku-saver.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-saver.vala"
		break;
#line 1594 "sudoku-saver.c"
	}
}

static void
_vala_sudoku_saver_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	SudokuSaver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_SAVER, SudokuSaver);
#line 24 "../lib/sudoku-saver.vala"
	switch (property_id) {
#line 1608 "sudoku-saver.c"
		default:
#line 24 "../lib/sudoku-saver.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-saver.vala"
		break;
#line 1614 "sudoku-saver.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

