/* sudoku-cell.c generated by valac 0.56.14, the Vala compiler
 * generated from sudoku-cell.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include "libsudoku.h"
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gsk/gsk.h>
#include <graphene-gobject.h>
#include <pango/pango.h>

#define SUDOKU_CELL_size_ratio 2
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
typedef struct _SudokuCellPrivate SudokuCellPrivate;
enum  {
	SUDOKU_CELL_0_PROPERTY,
	SUDOKU_CELL_VALUE_PROPERTY,
	SUDOKU_CELL_IS_FIXED_PROPERTY,
	SUDOKU_CELL_SELECTED_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY,
	SUDOKU_CELL_SHOW_WARNINGS_PROPERTY,
	SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY,
	SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY,
	SUDOKU_CELL_NUM_PROPERTIES
};
static GParamSpec* sudoku_cell_properties[SUDOKU_CELL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
typedef struct _NumberPickerPrivate NumberPickerPrivate;
typedef struct _Block10Data Block10Data;
#define _gsk_transform_unref0(var) ((var == NULL) ? NULL : (var = (gsk_transform_unref (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
	GtkPopover* popover;
	gboolean show_possibilities;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

struct _SudokuCellPrivate {
	gint row;
	gint col;
	SudokuGame* game;
	GtkGestureClick* button_controller;
	GtkGestureLongPress* long_press_controller;
	GtkEventControllerKey* key_controller;
	GtkLabel* value_label;
	GtkLabel** earmark_labels;
	gint earmark_labels_length1;
	gint _earmark_labels_size_;
	gboolean _selected;
	gboolean _highlighted_background;
	gboolean _highlighted_value;
	gboolean _show_warnings;
	gboolean _show_extra_warnings;
	gboolean control_key_pressed;
	gboolean initialized_earmarks;
	gboolean _initialize_earmarks;
};

struct _NumberPicker {
	GtkGrid parent_instance;
	NumberPickerPrivate * priv;
	gboolean is_earmark;
};

struct _NumberPickerClass {
	GtkGridClass parent_class;
};

struct _Block10Data {
	int _ref_count_;
	SudokuCell* self;
	NumberPicker* earmark_picker;
};

static gint SudokuCell_private_offset;
static gpointer sudoku_cell_parent_class = NULL;

VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame** game);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame** game);
VALA_EXTERN void sudoku_cell_set_value (SudokuCell* self,
                            gint value);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
static void sudoku_cell_long_press_cb (SudokuCell* self,
                                GtkGestureLongPress* event,
                                gdouble x,
                                gdouble y);
static void _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
static void sudoku_cell_button_released_cb (SudokuCell* self,
                                     GtkGestureClick* event,
                                     gint n_press,
                                     gdouble x,
                                     gdouble y);
static void _sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                 gint n_press,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
static gboolean sudoku_cell_key_pressed_cb (SudokuCell* self,
                                     guint keyval,
                                     guint keycode,
                                     GdkModifierType state);
static gboolean _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                           guint keyval,
                                                                           guint keycode,
                                                                           GdkModifierType state,
                                                                           gpointer self);
static void sudoku_cell_key_released_cb (SudokuCell* self,
                                  guint keyval,
                                  guint keycode,
                                  GdkModifierType state);
static void _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                         guint keyval,
                                                                         guint keycode,
                                                                         GdkModifierType state,
                                                                         gpointer self);
static void sudoku_cell_cell_changed_cb (SudokuCell* self,
                                  gint row,
                                  gint col,
                                  gint old_val,
                                  gint new_val);
static void _sudoku_cell_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                            gint row,
                                                            gint col,
                                                            gint old_val,
                                                            gint new_val,
                                                            gpointer self);
static void __lambda9_ (SudokuCell* self);
VALA_EXTERN void sudoku_cell_check_warnings (SudokuCell* self);
static void ___lambda9__gtk_popover_closed (GtkPopover* _sender,
                                     gpointer self);
static void sudoku_cell_get_visible_earmarks (SudokuCell* self);
static gint sudoku_cell_get_key_number (SudokuCell* self,
                                 guint keyval);
VALA_EXTERN GType number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NumberPicker, g_object_unref)
VALA_EXTERN void number_picker_set_earmark (NumberPicker* self,
                                gint row,
                                gint col,
                                gint index,
                                gboolean state);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
static void sudoku_cell_show_number_picker (SudokuCell* self);
static void sudoku_cell_show_earmark_picker (SudokuCell* self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
VALA_EXTERN NumberPicker* number_picker_new (SudokuBoard** board,
                                 gboolean earmark);
VALA_EXTERN NumberPicker* number_picker_construct (GType object_type,
                                       SudokuBoard** board,
                                       gboolean earmark);
VALA_EXTERN void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
VALA_EXTERN void number_picker_set_clear_button_enabled (NumberPicker* self,
                                             gboolean enabled);
static void __lambda7_ (Block10Data* _data10_,
                 gint number,
                 gboolean state);
static void ___lambda7__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                      gint number,
                                                      gboolean active,
                                                      gpointer self);
VALA_EXTERN void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
static void __lambda8_ (SudokuCell* self,
                 NumberPicker* o,
                 gint number);
static void ___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                              gint number,
                                              gpointer self);
VALA_EXTERN gboolean sudoku_cell_get_show_warnings (SudokuCell* self);
static gboolean sudoku_cell_warn_incorrect_solution (SudokuCell* self);
VALA_EXTERN gboolean sudoku_cell_get_show_extra_warnings (SudokuCell* self);
static void sudoku_cell_real_dispose (GObject* base);
static void sudoku_cell_real_size_allocate (GtkWidget* base,
                                     gint width,
                                     gint height,
                                     gint baseline);
static void sudoku_cell_set_font_size (SudokuCell* self,
                                GtkLabel** label,
                                gint font_size);
VALA_EXTERN gboolean sudoku_cell_get_selected (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_background (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
VALA_EXTERN void sudoku_cell_set_show_warnings (SudokuCell* self,
                                    gboolean value);
VALA_EXTERN void sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_initialize_earmarks (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_initialize_earmarks (SudokuCell* self,
                                          gboolean value);
static void sudoku_cell_finalize (GObject * obj);
static GType sudoku_cell_get_type_once (void);
static void _vala_sudoku_cell_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_cell_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_cell_get_instance_private (SudokuCell* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuCell_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 165 "../src/sudoku-cell.vala"
	return self ? g_object_ref (self) : NULL;
#line 299 "sudoku-cell.c"
}

static void
_sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
#line 182 "../src/sudoku-cell.vala"
	sudoku_cell_long_press_cb ((SudokuCell*) self, _sender, x, y);
#line 310 "sudoku-cell.c"
}

static void
_sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
#line 183 "../src/sudoku-cell.vala"
	sudoku_cell_button_released_cb ((SudokuCell*) self, _sender, n_press, x, y);
#line 322 "sudoku-cell.c"
}

static gboolean
_sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                  guint keyval,
                                                                  guint keycode,
                                                                  GdkModifierType state,
                                                                  gpointer self)
{
	gboolean result;
	result = sudoku_cell_key_pressed_cb ((SudokuCell*) self, keyval, keycode, state);
#line 184 "../src/sudoku-cell.vala"
	return result;
#line 336 "sudoku-cell.c"
}

static void
_sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                    guint keyval,
                                                                    guint keycode,
                                                                    GdkModifierType state,
                                                                    gpointer self)
{
#line 185 "../src/sudoku-cell.vala"
	sudoku_cell_key_released_cb ((SudokuCell*) self, keyval, keycode, state);
#line 348 "sudoku-cell.c"
}

static void
_sudoku_cell_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                       gint row,
                                                       gint col,
                                                       gint old_val,
                                                       gint new_val,
                                                       gpointer self)
{
#line 186 "../src/sudoku-cell.vala"
	sudoku_cell_cell_changed_cb ((SudokuCell*) self, row, col, old_val, new_val);
#line 361 "sudoku-cell.c"
}

static void
__lambda9_ (SudokuCell* self)
{
	GtkPopover* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 211 "../src/sudoku-cell.vala"
	_tmp0_ = self->popover;
#line 211 "../src/sudoku-cell.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 211 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 211 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 378 "sudoku-cell.c"
		GtkPopover* _tmp3_;
#line 213 "../src/sudoku-cell.vala"
		_tmp3_ = self->popover;
#line 213 "../src/sudoku-cell.vala"
		gtk_popover_set_child (_tmp3_, NULL);
#line 215 "../src/sudoku-cell.vala"
		sudoku_cell_check_warnings (self);
#line 216 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 388 "sudoku-cell.c"
	}
}

static void
___lambda9__gtk_popover_closed (GtkPopover* _sender,
                                gpointer self)
{
#line 210 "../src/sudoku-cell.vala"
	__lambda9_ ((SudokuCell*) self);
#line 398 "sudoku-cell.c"
}

SudokuCell*
sudoku_cell_construct (GType object_type,
                       gint row,
                       gint col,
                       SudokuGame** game)
{
	SudokuCell * self = NULL;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkGestureClick* _tmp4_;
	GtkGestureClick* _tmp5_;
	GtkEventController* _tmp6_;
	GtkGestureLongPress* _tmp7_;
	GtkEventController* _tmp8_;
	GtkEventControllerKey* _tmp9_;
	GtkEventController* _tmp10_;
	GtkGestureClick* _tmp11_;
	GtkGestureLongPress* _tmp12_;
	GtkGestureLongPress* _tmp13_;
	GtkGestureClick* _tmp14_;
	GtkEventControllerKey* _tmp15_;
	GtkEventControllerKey* _tmp16_;
	GtkLabel* _tmp17_;
	gint num = 0;
	GtkPopover* _tmp37_;
	GtkEventControllerKey* popover_controller = NULL;
	GtkEventControllerKey* _tmp38_;
	GtkEventControllerKey* _tmp39_;
	GtkEventControllerKey* _tmp40_;
	GtkWidget* _tmp41_ = NULL;
	GtkPopover* _tmp42_;
	GtkPopover* _tmp45_;
#line 159 "../src/sudoku-cell.vala"
	g_return_val_if_fail (*game != NULL, NULL);
#line 159 "../src/sudoku-cell.vala"
	self = (SudokuCell*) g_object_new (object_type, NULL);
#line 161 "../src/sudoku-cell.vala"
	gtk_widget_class_set_accessible_role (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), GTK_ACCESSIBLE_ROLE_BUTTON);
#line 163 "../src/sudoku-cell.vala"
	self->priv->row = row;
#line 164 "../src/sudoku-cell.vala"
	self->priv->col = col;
#line 165 "../src/sudoku-cell.vala"
	_tmp0_ = _g_object_ref0 (*game);
#line 165 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->game);
#line 165 "../src/sudoku-cell.vala"
	self->priv->game = _tmp0_;
#line 167 "../src/sudoku-cell.vala"
	_tmp1_ = (*game)->board;
#line 167 "../src/sudoku-cell.vala"
	sudoku_cell_set_value (self, sudoku_board_get (_tmp1_, row, col));
#line 169 "../src/sudoku-cell.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 170 "../src/sudoku-cell.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 172 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_is_fixed (self);
#line 172 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 172 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 173 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "fixed");
#line 467 "sudoku-cell.c"
	}
#line 175 "../src/sudoku-cell.vala"
	_tmp4_ = self->priv->button_controller;
#line 175 "../src/sudoku-cell.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp4_, (guint) 0);
#line 177 "../src/sudoku-cell.vala"
	_tmp5_ = self->priv->button_controller;
#line 177 "../src/sudoku-cell.vala"
	_tmp6_ = _g_object_ref0 ((GtkEventController*) _tmp5_);
#line 177 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp6_);
#line 178 "../src/sudoku-cell.vala"
	_tmp7_ = self->priv->long_press_controller;
#line 178 "../src/sudoku-cell.vala"
	_tmp8_ = _g_object_ref0 ((GtkEventController*) _tmp7_);
#line 178 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp8_);
#line 179 "../src/sudoku-cell.vala"
	_tmp9_ = self->priv->key_controller;
#line 179 "../src/sudoku-cell.vala"
	_tmp10_ = _g_object_ref0 ((GtkEventController*) _tmp9_);
#line 179 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp10_);
#line 180 "../src/sudoku-cell.vala"
	_tmp11_ = self->priv->button_controller;
#line 180 "../src/sudoku-cell.vala"
	_tmp12_ = self->priv->long_press_controller;
#line 180 "../src/sudoku-cell.vala"
	gtk_gesture_group ((GtkGesture*) _tmp11_, (GtkGesture*) _tmp12_);
#line 182 "../src/sudoku-cell.vala"
	_tmp13_ = self->priv->long_press_controller;
#line 182 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp13_, "pressed", (GCallback) _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed, self, 0);
#line 183 "../src/sudoku-cell.vala"
	_tmp14_ = self->priv->button_controller;
#line 183 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp14_, "released", (GCallback) _sudoku_cell_button_released_cb_gtk_gesture_click_released, self, 0);
#line 184 "../src/sudoku-cell.vala"
	_tmp15_ = self->priv->key_controller;
#line 184 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp15_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 185 "../src/sudoku-cell.vala"
	_tmp16_ = self->priv->key_controller;
#line 185 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp16_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
#line 186 "../src/sudoku-cell.vala"
	g_signal_connect_object (*game, "cell-changed", (GCallback) _sudoku_cell_cell_changed_cb_sudoku_game_cell_changed, self, 0);
#line 188 "../src/sudoku-cell.vala"
	_tmp17_ = self->priv->value_label;
#line 188 "../src/sudoku-cell.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp17_, (GtkWidget*) self);
#line 190 "../src/sudoku-cell.vala"
	num = 0;
#line 521 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 191 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 526 "sudoku-cell.c"
		{
			gboolean _tmp18_ = FALSE;
#line 191 "../src/sudoku-cell.vala"
			_tmp18_ = TRUE;
#line 191 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 533 "sudoku-cell.c"
				SudokuBoard* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
#line 191 "../src/sudoku-cell.vala"
				if (!_tmp18_) {
#line 539 "sudoku-cell.c"
					gint _tmp19_;
#line 191 "../src/sudoku-cell.vala"
					_tmp19_ = row_tmp;
#line 191 "../src/sudoku-cell.vala"
					row_tmp = _tmp19_ + 1;
#line 545 "sudoku-cell.c"
				}
#line 191 "../src/sudoku-cell.vala"
				_tmp18_ = FALSE;
#line 191 "../src/sudoku-cell.vala"
				_tmp20_ = (*game)->board;
#line 191 "../src/sudoku-cell.vala"
				_tmp21_ = sudoku_board_get_block_rows (_tmp20_);
#line 191 "../src/sudoku-cell.vala"
				_tmp22_ = _tmp21_;
#line 191 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp22_)) {
#line 191 "../src/sudoku-cell.vala"
					break;
#line 559 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 193 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 565 "sudoku-cell.c"
					{
						gboolean _tmp23_ = FALSE;
#line 193 "../src/sudoku-cell.vala"
						_tmp23_ = TRUE;
#line 193 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 572 "sudoku-cell.c"
							SudokuBoard* _tmp25_;
							gint _tmp26_;
							gint _tmp27_;
							gint _tmp28_;
							GtkLabel** _tmp29_;
							gint _tmp29__length1;
							gchar* _tmp30_;
							gchar* _tmp31_;
							GtkLabel* _tmp32_ = NULL;
							GtkLabel** _tmp33_;
							gint _tmp33__length1;
							GtkLabel* _tmp34_;
							GtkLabel** _tmp35_;
							gint _tmp35__length1;
							GtkLabel* _tmp36_;
#line 193 "../src/sudoku-cell.vala"
							if (!_tmp23_) {
#line 590 "sudoku-cell.c"
								gint _tmp24_;
#line 193 "../src/sudoku-cell.vala"
								_tmp24_ = col_tmp;
#line 193 "../src/sudoku-cell.vala"
								col_tmp = _tmp24_ + 1;
#line 596 "sudoku-cell.c"
							}
#line 193 "../src/sudoku-cell.vala"
							_tmp23_ = FALSE;
#line 193 "../src/sudoku-cell.vala"
							_tmp25_ = (*game)->board;
#line 193 "../src/sudoku-cell.vala"
							_tmp26_ = sudoku_board_get_block_cols (_tmp25_);
#line 193 "../src/sudoku-cell.vala"
							_tmp27_ = _tmp26_;
#line 193 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp27_)) {
#line 193 "../src/sudoku-cell.vala"
								break;
#line 610 "sudoku-cell.c"
							}
#line 195 "../src/sudoku-cell.vala"
							_tmp28_ = num;
#line 195 "../src/sudoku-cell.vala"
							num = _tmp28_ + 1;
#line 197 "../src/sudoku-cell.vala"
							_tmp29_ = self->priv->earmark_labels;
#line 197 "../src/sudoku-cell.vala"
							_tmp29__length1 = self->priv->earmark_labels_length1;
#line 197 "../src/sudoku-cell.vala"
							_tmp30_ = g_strdup_printf ("%i", num);
#line 197 "../src/sudoku-cell.vala"
							_tmp31_ = _tmp30_;
#line 197 "../src/sudoku-cell.vala"
							_tmp32_ = (GtkLabel*) gtk_label_new (_tmp31_);
#line 197 "../src/sudoku-cell.vala"
							gtk_widget_set_visible ((GtkWidget*) _tmp32_, FALSE);
#line 197 "../src/sudoku-cell.vala"
							g_object_ref_sink (_tmp32_);
#line 197 "../src/sudoku-cell.vala"
							_g_object_unref0 (_tmp29_[num - 1]);
#line 197 "../src/sudoku-cell.vala"
							_tmp29_[num - 1] = _tmp32_;
#line 197 "../src/sudoku-cell.vala"
							_g_free0 (_tmp31_);
#line 200 "../src/sudoku-cell.vala"
							_tmp33_ = self->priv->earmark_labels;
#line 200 "../src/sudoku-cell.vala"
							_tmp33__length1 = self->priv->earmark_labels_length1;
#line 200 "../src/sudoku-cell.vala"
							_tmp34_ = _tmp33_[num - 1];
#line 200 "../src/sudoku-cell.vala"
							gtk_widget_set_parent ((GtkWidget*) _tmp34_, (GtkWidget*) self);
#line 201 "../src/sudoku-cell.vala"
							_tmp35_ = self->priv->earmark_labels;
#line 201 "../src/sudoku-cell.vala"
							_tmp35__length1 = self->priv->earmark_labels_length1;
#line 201 "../src/sudoku-cell.vala"
							_tmp36_ = _tmp35_[num - 1];
#line 201 "../src/sudoku-cell.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp36_, "earmark");
#line 652 "sudoku-cell.c"
						}
					}
				}
			}
		}
	}
#line 205 "../src/sudoku-cell.vala"
	_tmp37_ = self->popover;
#line 205 "../src/sudoku-cell.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp37_, (GtkWidget*) self);
#line 206 "../src/sudoku-cell.vala"
	_tmp38_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 206 "../src/sudoku-cell.vala"
	popover_controller = _tmp38_;
#line 207 "../src/sudoku-cell.vala"
	_tmp39_ = popover_controller;
#line 207 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp39_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 208 "../src/sudoku-cell.vala"
	_tmp40_ = popover_controller;
#line 208 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp40_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
#line 209 "../src/sudoku-cell.vala"
	_tmp42_ = self->popover;
#line 209 "../src/sudoku-cell.vala"
	_tmp41_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp42_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp42_) : NULL;
#line 209 "../src/sudoku-cell.vala"
	if (_tmp41_ != NULL) {
#line 681 "sudoku-cell.c"
		GtkEventControllerKey* _tmp43_;
		GtkEventController* _tmp44_;
#line 209 "../src/sudoku-cell.vala"
		_tmp43_ = popover_controller;
#line 209 "../src/sudoku-cell.vala"
		_tmp44_ = _g_object_ref0 ((GtkEventController*) _tmp43_);
#line 209 "../src/sudoku-cell.vala"
		gtk_widget_add_controller (_tmp41_, _tmp44_);
#line 690 "sudoku-cell.c"
	}
#line 210 "../src/sudoku-cell.vala"
	_tmp45_ = self->popover;
#line 210 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp45_, "closed", (GCallback) ___lambda9__gtk_popover_closed, self, 0);
#line 221 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmarks (self);
#line 159 "../src/sudoku-cell.vala"
	_g_object_unref0 (popover_controller);
#line 159 "../src/sudoku-cell.vala"
	return self;
#line 702 "sudoku-cell.c"
}

SudokuCell*
sudoku_cell_new (gint row,
                 gint col,
                 SudokuGame** game)
{
#line 159 "../src/sudoku-cell.vala"
	return sudoku_cell_construct (TYPE_SUDOKU_CELL, row, col, game);
#line 712 "sudoku-cell.c"
}

static void
sudoku_cell_cell_changed_cb (SudokuCell* self,
                             gint row,
                             gint col,
                             gint old_val,
                             gint new_val)
{
	gboolean _tmp0_ = FALSE;
#line 228 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 233 "../src/sudoku-cell.vala"
	if (row == self->priv->row) {
#line 233 "../src/sudoku-cell.vala"
		_tmp0_ = col == self->priv->col;
#line 729 "sudoku-cell.c"
	} else {
#line 233 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 733 "sudoku-cell.c"
	}
#line 233 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 235 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, new_val);
#line 236 "../src/sudoku-cell.vala"
		g_object_notify ((GObject*) self, "value");
#line 237 "../src/sudoku-cell.vala"
		sudoku_cell_get_visible_earmarks (self);
#line 743 "sudoku-cell.c"
	}
}

static gboolean
sudoku_cell_key_pressed_cb (SudokuCell* self,
                            guint keyval,
                            guint keycode,
                            GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 241 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 245 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 245 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 761 "sudoku-cell.c"
	} else {
#line 245 "../src/sudoku-cell.vala"
		_tmp0_ = keyval == GDK_KEY_Control_R;
#line 765 "sudoku-cell.c"
	}
#line 245 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 246 "../src/sudoku-cell.vala"
		self->priv->control_key_pressed = TRUE;
#line 771 "sudoku-cell.c"
	}
#line 250 "../src/sudoku-cell.vala"
	result = FALSE;
#line 250 "../src/sudoku-cell.vala"
	return result;
#line 777 "sudoku-cell.c"
}

static void
sudoku_cell_key_released_cb (SudokuCell* self,
                             guint keyval,
                             guint keycode,
                             GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	gboolean _tmp8_ = FALSE;
	gint key = 0;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_ = FALSE;
	gboolean _tmp40_ = FALSE;
	gboolean _tmp41_ = FALSE;
#line 253 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/sudoku-cell.vala"
	_tmp1_ = self->priv->game;
#line 257 "../src/sudoku-cell.vala"
	if (_tmp1_->mode == GAME_MODE_PLAY) {
#line 801 "sudoku-cell.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 257 "../src/sudoku-cell.vala"
		_tmp3_ = sudoku_cell_get_is_fixed (self);
#line 257 "../src/sudoku-cell.vala"
		_tmp4_ = _tmp3_;
#line 257 "../src/sudoku-cell.vala"
		if (_tmp4_) {
#line 257 "../src/sudoku-cell.vala"
			_tmp2_ = TRUE;
#line 813 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 257 "../src/sudoku-cell.vala"
			_tmp5_ = self->priv->game;
#line 257 "../src/sudoku-cell.vala"
			_tmp6_ = sudoku_game_get_paused (_tmp5_);
#line 257 "../src/sudoku-cell.vala"
			_tmp7_ = _tmp6_;
#line 257 "../src/sudoku-cell.vala"
			_tmp2_ = _tmp7_;
#line 826 "sudoku-cell.c"
		}
#line 257 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp2_;
#line 830 "sudoku-cell.c"
	} else {
#line 257 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 834 "sudoku-cell.c"
	}
#line 257 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 258 "../src/sudoku-cell.vala"
		return;
#line 840 "sudoku-cell.c"
	}
#line 260 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 260 "../src/sudoku-cell.vala"
		_tmp8_ = TRUE;
#line 846 "sudoku-cell.c"
	} else {
#line 260 "../src/sudoku-cell.vala"
		_tmp8_ = keyval == GDK_KEY_Control_R;
#line 850 "sudoku-cell.c"
	}
#line 260 "../src/sudoku-cell.vala"
	if (_tmp8_) {
#line 262 "../src/sudoku-cell.vala"
		self->priv->control_key_pressed = FALSE;
#line 263 "../src/sudoku-cell.vala"
		sudoku_cell_check_warnings (self);
#line 858 "sudoku-cell.c"
	}
#line 266 "../src/sudoku-cell.vala"
	key = sudoku_cell_get_key_number (self, keyval);
#line 267 "../src/sudoku-cell.vala"
	if (key >= 1) {
#line 267 "../src/sudoku-cell.vala"
		_tmp9_ = key <= 9;
#line 866 "sudoku-cell.c"
	} else {
#line 267 "../src/sudoku-cell.vala"
		_tmp9_ = FALSE;
#line 870 "sudoku-cell.c"
	}
#line 267 "../src/sudoku-cell.vala"
	if (_tmp9_) {
#line 874 "sudoku-cell.c"
		NumberPicker* number_picker = NULL;
		GtkPopover* _tmp10_;
		GtkWidget* _tmp11_;
		NumberPicker* _tmp12_;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		GtkPopover* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
		gboolean want_earmark = FALSE;
		gboolean _tmp21_ = FALSE;
#line 270 "../src/sudoku-cell.vala"
		_tmp10_ = self->popover;
#line 270 "../src/sudoku-cell.vala"
		_tmp11_ = gtk_popover_get_child (_tmp10_);
#line 270 "../src/sudoku-cell.vala"
		_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_NUMBER_PICKER, NumberPicker));
#line 270 "../src/sudoku-cell.vala"
		number_picker = _tmp12_;
#line 272 "../src/sudoku-cell.vala"
		_tmp16_ = self->popover;
#line 272 "../src/sudoku-cell.vala"
		_tmp17_ = gtk_widget_get_visible ((GtkWidget*) _tmp16_);
#line 272 "../src/sudoku-cell.vala"
		_tmp18_ = _tmp17_;
#line 272 "../src/sudoku-cell.vala"
		if (_tmp18_) {
#line 903 "sudoku-cell.c"
			NumberPicker* _tmp19_;
#line 272 "../src/sudoku-cell.vala"
			_tmp19_ = number_picker;
#line 272 "../src/sudoku-cell.vala"
			_tmp15_ = _tmp19_ != NULL;
#line 909 "sudoku-cell.c"
		} else {
#line 272 "../src/sudoku-cell.vala"
			_tmp15_ = FALSE;
#line 913 "sudoku-cell.c"
		}
#line 272 "../src/sudoku-cell.vala"
		if (_tmp15_) {
#line 917 "sudoku-cell.c"
			NumberPicker* _tmp20_;
#line 272 "../src/sudoku-cell.vala"
			_tmp20_ = number_picker;
#line 272 "../src/sudoku-cell.vala"
			_tmp14_ = _tmp20_->is_earmark;
#line 923 "sudoku-cell.c"
		} else {
#line 272 "../src/sudoku-cell.vala"
			_tmp14_ = FALSE;
#line 927 "sudoku-cell.c"
		}
#line 272 "../src/sudoku-cell.vala"
		if (_tmp14_) {
#line 272 "../src/sudoku-cell.vala"
			_tmp13_ = TRUE;
#line 933 "sudoku-cell.c"
		} else {
#line 273 "../src/sudoku-cell.vala"
			_tmp13_ = (state & GDK_CONTROL_MASK) > 0;
#line 937 "sudoku-cell.c"
		}
#line 272 "../src/sudoku-cell.vala"
		want_earmark = _tmp13_;
#line 274 "../src/sudoku-cell.vala"
		if (want_earmark) {
#line 943 "sudoku-cell.c"
			SudokuGame* _tmp22_;
#line 274 "../src/sudoku-cell.vala"
			_tmp22_ = self->priv->game;
#line 274 "../src/sudoku-cell.vala"
			_tmp21_ = _tmp22_->mode == GAME_MODE_PLAY;
#line 949 "sudoku-cell.c"
		} else {
#line 274 "../src/sudoku-cell.vala"
			_tmp21_ = FALSE;
#line 953 "sudoku-cell.c"
		}
#line 274 "../src/sudoku-cell.vala"
		if (_tmp21_) {
#line 957 "sudoku-cell.c"
			gboolean new_state = FALSE;
			SudokuGame* _tmp23_;
			SudokuBoard* _tmp24_;
			gboolean _tmp25_ = FALSE;
			NumberPicker* _tmp26_;
#line 276 "../src/sudoku-cell.vala"
			_tmp23_ = self->priv->game;
#line 276 "../src/sudoku-cell.vala"
			_tmp24_ = _tmp23_->board;
#line 276 "../src/sudoku-cell.vala"
			new_state = !sudoku_board_is_earmark_enabled (_tmp24_, self->priv->row, self->priv->col, key);
#line 278 "../src/sudoku-cell.vala"
			_tmp26_ = number_picker;
#line 278 "../src/sudoku-cell.vala"
			if (_tmp26_ != NULL) {
#line 973 "sudoku-cell.c"
				NumberPicker* _tmp27_;
#line 278 "../src/sudoku-cell.vala"
				_tmp27_ = number_picker;
#line 278 "../src/sudoku-cell.vala"
				_tmp25_ = _tmp27_->is_earmark;
#line 979 "sudoku-cell.c"
			} else {
#line 278 "../src/sudoku-cell.vala"
				_tmp25_ = FALSE;
#line 983 "sudoku-cell.c"
			}
#line 278 "../src/sudoku-cell.vala"
			if (_tmp25_) {
#line 987 "sudoku-cell.c"
				NumberPicker* _tmp28_;
#line 280 "../src/sudoku-cell.vala"
				_tmp28_ = number_picker;
#line 280 "../src/sudoku-cell.vala"
				number_picker_set_earmark (_tmp28_, self->priv->row, self->priv->col, key - 1, new_state);
#line 993 "sudoku-cell.c"
			} else {
				SudokuGame* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
#line 284 "../src/sudoku-cell.vala"
				if (new_state) {
#line 1002 "sudoku-cell.c"
					SudokuGame* _tmp29_;
#line 285 "../src/sudoku-cell.vala"
					_tmp29_ = self->priv->game;
#line 285 "../src/sudoku-cell.vala"
					sudoku_game_enable_earmark (_tmp29_, self->priv->row, self->priv->col, key);
#line 1008 "sudoku-cell.c"
				} else {
					SudokuGame* _tmp30_;
#line 287 "../src/sudoku-cell.vala"
					_tmp30_ = self->priv->game;
#line 287 "../src/sudoku-cell.vala"
					sudoku_game_disable_earmark (_tmp30_, self->priv->row, self->priv->col, key);
#line 1015 "sudoku-cell.c"
				}
#line 288 "../src/sudoku-cell.vala"
				_tmp31_ = self->priv->game;
#line 288 "../src/sudoku-cell.vala"
				_tmp32_ = sudoku_cell_get_value (self);
#line 288 "../src/sudoku-cell.vala"
				_tmp33_ = _tmp32_;
#line 288 "../src/sudoku-cell.vala"
				_tmp34_ = sudoku_cell_get_value (self);
#line 288 "../src/sudoku-cell.vala"
				_tmp35_ = _tmp34_;
#line 288 "../src/sudoku-cell.vala"
				g_signal_emit_by_name (_tmp31_, "cell-changed", self->priv->row, self->priv->col, _tmp33_, _tmp35_);
#line 1029 "sudoku-cell.c"
			}
		} else {
			SudokuGame* _tmp36_;
			SudokuBoard* _tmp37_;
#line 293 "../src/sudoku-cell.vala"
			sudoku_cell_set_value (self, key);
#line 294 "../src/sudoku-cell.vala"
			_tmp36_ = self->priv->game;
#line 294 "../src/sudoku-cell.vala"
			_tmp37_ = _tmp36_->board;
#line 294 "../src/sudoku-cell.vala"
			sudoku_board_disable_all_earmarks (_tmp37_, self->priv->row, self->priv->col);
#line 1042 "sudoku-cell.c"
		}
#line 296 "../src/sudoku-cell.vala"
		_g_object_unref0 (number_picker);
#line 296 "../src/sudoku-cell.vala"
		return;
#line 1048 "sudoku-cell.c"
	}
#line 299 "../src/sudoku-cell.vala"
	if (key == 0) {
#line 299 "../src/sudoku-cell.vala"
		_tmp39_ = TRUE;
#line 1054 "sudoku-cell.c"
	} else {
#line 300 "../src/sudoku-cell.vala"
		_tmp39_ = keyval == GDK_KEY_BackSpace;
#line 1058 "sudoku-cell.c"
	}
#line 299 "../src/sudoku-cell.vala"
	if (_tmp39_) {
#line 299 "../src/sudoku-cell.vala"
		_tmp38_ = TRUE;
#line 1064 "sudoku-cell.c"
	} else {
#line 301 "../src/sudoku-cell.vala"
		_tmp38_ = keyval == GDK_KEY_Delete;
#line 1068 "sudoku-cell.c"
	}
#line 299 "../src/sudoku-cell.vala"
	if (_tmp38_) {
#line 303 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, 0);
#line 304 "../src/sudoku-cell.vala"
		g_object_notify ((GObject*) self, "value");
#line 305 "../src/sudoku-cell.vala"
		return;
#line 1078 "sudoku-cell.c"
	}
#line 308 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_space) {
#line 308 "../src/sudoku-cell.vala"
		_tmp41_ = TRUE;
#line 1084 "sudoku-cell.c"
	} else {
#line 309 "../src/sudoku-cell.vala"
		_tmp41_ = keyval == GDK_KEY_Return;
#line 1088 "sudoku-cell.c"
	}
#line 308 "../src/sudoku-cell.vala"
	if (_tmp41_) {
#line 308 "../src/sudoku-cell.vala"
		_tmp40_ = TRUE;
#line 1094 "sudoku-cell.c"
	} else {
#line 310 "../src/sudoku-cell.vala"
		_tmp40_ = keyval == GDK_KEY_KP_Enter;
#line 1098 "sudoku-cell.c"
	}
#line 308 "../src/sudoku-cell.vala"
	if (_tmp40_) {
#line 1102 "sudoku-cell.c"
		GtkPopover* _tmp42_;
		gboolean _tmp43_;
		gboolean _tmp44_;
#line 312 "../src/sudoku-cell.vala"
		_tmp42_ = self->popover;
#line 312 "../src/sudoku-cell.vala"
		_tmp43_ = gtk_widget_get_visible ((GtkWidget*) _tmp42_);
#line 312 "../src/sudoku-cell.vala"
		_tmp44_ = _tmp43_;
#line 312 "../src/sudoku-cell.vala"
		if (_tmp44_) {
#line 313 "../src/sudoku-cell.vala"
			return;
#line 1116 "sudoku-cell.c"
		}
#line 314 "../src/sudoku-cell.vala"
		sudoku_cell_show_number_picker (self);
#line 315 "../src/sudoku-cell.vala"
		return;
#line 1122 "sudoku-cell.c"
	}
}

static void
sudoku_cell_long_press_cb (SudokuCell* self,
                           GtkGestureLongPress* event,
                           gdouble x,
                           gdouble y)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
#line 319 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 319 "../src/sudoku-cell.vala"
	g_return_if_fail (event != NULL);
#line 323 "../src/sudoku-cell.vala"
	_tmp1_ = self->priv->game;
#line 323 "../src/sudoku-cell.vala"
	if (_tmp1_->mode == GAME_MODE_PLAY) {
#line 1142 "sudoku-cell.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 323 "../src/sudoku-cell.vala"
		_tmp3_ = sudoku_cell_get_is_fixed (self);
#line 323 "../src/sudoku-cell.vala"
		_tmp4_ = _tmp3_;
#line 323 "../src/sudoku-cell.vala"
		if (_tmp4_) {
#line 323 "../src/sudoku-cell.vala"
			_tmp2_ = TRUE;
#line 1154 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 323 "../src/sudoku-cell.vala"
			_tmp5_ = self->priv->game;
#line 323 "../src/sudoku-cell.vala"
			_tmp6_ = sudoku_game_get_paused (_tmp5_);
#line 323 "../src/sudoku-cell.vala"
			_tmp7_ = _tmp6_;
#line 323 "../src/sudoku-cell.vala"
			_tmp2_ = _tmp7_;
#line 1167 "sudoku-cell.c"
		}
#line 323 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp2_;
#line 1171 "sudoku-cell.c"
	} else {
#line 323 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 1175 "sudoku-cell.c"
	}
#line 323 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 324 "../src/sudoku-cell.vala"
		return;
#line 1181 "sudoku-cell.c"
	}
#line 326 "../src/sudoku-cell.vala"
	sudoku_cell_show_earmark_picker (self);
#line 1185 "sudoku-cell.c"
}

static void
sudoku_cell_button_released_cb (SudokuCell* self,
                                GtkGestureClick* event,
                                gint n_press,
                                gdouble x,
                                gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	SudokuGame* _tmp4_;
#line 329 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 329 "../src/sudoku-cell.vala"
	g_return_if_fail (event != NULL);
#line 334 "../src/sudoku-cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) event) != ((guint) GDK_BUTTON_PRIMARY)) {
#line 335 "../src/sudoku-cell.vala"
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) event) != ((guint) GDK_BUTTON_SECONDARY);
#line 1208 "sudoku-cell.c"
	} else {
#line 334 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 1212 "sudoku-cell.c"
	}
#line 334 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 336 "../src/sudoku-cell.vala"
		return;
#line 1218 "sudoku-cell.c"
	}
#line 338 "../src/sudoku-cell.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp1_, NULL);
#line 338 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 338 "../src/sudoku-cell.vala"
	if (!_tmp2_) {
#line 339 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 1228 "sudoku-cell.c"
	}
#line 341 "../src/sudoku-cell.vala"
	_tmp4_ = self->priv->game;
#line 341 "../src/sudoku-cell.vala"
	if (_tmp4_->mode == GAME_MODE_PLAY) {
#line 1234 "sudoku-cell.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 341 "../src/sudoku-cell.vala"
		_tmp6_ = sudoku_cell_get_is_fixed (self);
#line 341 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 341 "../src/sudoku-cell.vala"
		if (_tmp7_) {
#line 341 "../src/sudoku-cell.vala"
			_tmp5_ = TRUE;
#line 1246 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 341 "../src/sudoku-cell.vala"
			_tmp8_ = self->priv->game;
#line 341 "../src/sudoku-cell.vala"
			_tmp9_ = sudoku_game_get_paused (_tmp8_);
#line 341 "../src/sudoku-cell.vala"
			_tmp10_ = _tmp9_;
#line 341 "../src/sudoku-cell.vala"
			_tmp5_ = _tmp10_;
#line 1259 "sudoku-cell.c"
		}
#line 341 "../src/sudoku-cell.vala"
		_tmp3_ = _tmp5_;
#line 1263 "sudoku-cell.c"
	} else {
#line 341 "../src/sudoku-cell.vala"
		_tmp3_ = FALSE;
#line 1267 "sudoku-cell.c"
	}
#line 341 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 342 "../src/sudoku-cell.vala"
		return;
#line 1273 "sudoku-cell.c"
	}
#line 344 "../src/sudoku-cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) event) == ((guint) GDK_BUTTON_PRIMARY)) {
#line 1277 "sudoku-cell.c"
		gboolean _tmp11_ = FALSE;
#line 346 "../src/sudoku-cell.vala"
		if (!self->show_possibilities) {
#line 1281 "sudoku-cell.c"
			GdkEventSequence* _tmp12_;
			GdkEvent* _tmp13_;
#line 347 "../src/sudoku-cell.vala"
			_tmp12_ = gtk_gesture_get_last_updated_sequence ((GtkGesture*) event);
#line 347 "../src/sudoku-cell.vala"
			_tmp13_ = gtk_gesture_get_last_event ((GtkGesture*) event, _tmp12_);
#line 347 "../src/sudoku-cell.vala"
			_tmp11_ = (gdk_event_get_modifier_state (_tmp13_) & GDK_CONTROL_MASK) > 0;
#line 1290 "sudoku-cell.c"
		} else {
#line 346 "../src/sudoku-cell.vala"
			_tmp11_ = FALSE;
#line 1294 "sudoku-cell.c"
		}
#line 346 "../src/sudoku-cell.vala"
		if (_tmp11_) {
#line 348 "../src/sudoku-cell.vala"
			sudoku_cell_show_earmark_picker (self);
#line 1300 "sudoku-cell.c"
		} else {
#line 350 "../src/sudoku-cell.vala"
			sudoku_cell_show_number_picker (self);
#line 1304 "sudoku-cell.c"
		}
	} else {
		gboolean _tmp14_ = FALSE;
#line 352 "../src/sudoku-cell.vala"
		if (!self->show_possibilities) {
#line 353 "../src/sudoku-cell.vala"
			_tmp14_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) event) == ((guint) GDK_BUTTON_SECONDARY);
#line 1312 "sudoku-cell.c"
		} else {
#line 352 "../src/sudoku-cell.vala"
			_tmp14_ = FALSE;
#line 1316 "sudoku-cell.c"
		}
#line 352 "../src/sudoku-cell.vala"
		if (_tmp14_) {
#line 354 "../src/sudoku-cell.vala"
			sudoku_cell_show_earmark_picker (self);
#line 1322 "sudoku-cell.c"
		}
	}
}

static gint
sudoku_cell_get_key_number (SudokuCell* self,
                            guint keyval)
{
	gint result;
#line 357 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 359 "../src/sudoku-cell.vala"
	switch (keyval) {
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_0:
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_0:
#line 1340 "sudoku-cell.c"
		{
#line 363 "../src/sudoku-cell.vala"
			result = 0;
#line 363 "../src/sudoku-cell.vala"
			return result;
#line 1346 "sudoku-cell.c"
		}
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_1:
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_1:
#line 1352 "sudoku-cell.c"
		{
#line 366 "../src/sudoku-cell.vala"
			result = 1;
#line 366 "../src/sudoku-cell.vala"
			return result;
#line 1358 "sudoku-cell.c"
		}
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_2:
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_2:
#line 1364 "sudoku-cell.c"
		{
#line 369 "../src/sudoku-cell.vala"
			result = 2;
#line 369 "../src/sudoku-cell.vala"
			return result;
#line 1370 "sudoku-cell.c"
		}
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_3:
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_3:
#line 1376 "sudoku-cell.c"
		{
#line 372 "../src/sudoku-cell.vala"
			result = 3;
#line 372 "../src/sudoku-cell.vala"
			return result;
#line 1382 "sudoku-cell.c"
		}
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_4:
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_4:
#line 1388 "sudoku-cell.c"
		{
#line 375 "../src/sudoku-cell.vala"
			result = 4;
#line 375 "../src/sudoku-cell.vala"
			return result;
#line 1394 "sudoku-cell.c"
		}
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_5:
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_5:
#line 1400 "sudoku-cell.c"
		{
#line 378 "../src/sudoku-cell.vala"
			result = 5;
#line 378 "../src/sudoku-cell.vala"
			return result;
#line 1406 "sudoku-cell.c"
		}
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_6:
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_6:
#line 1412 "sudoku-cell.c"
		{
#line 381 "../src/sudoku-cell.vala"
			result = 6;
#line 381 "../src/sudoku-cell.vala"
			return result;
#line 1418 "sudoku-cell.c"
		}
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_7:
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_7:
#line 1424 "sudoku-cell.c"
		{
#line 384 "../src/sudoku-cell.vala"
			result = 7;
#line 384 "../src/sudoku-cell.vala"
			return result;
#line 1430 "sudoku-cell.c"
		}
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_8:
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_8:
#line 1436 "sudoku-cell.c"
		{
#line 387 "../src/sudoku-cell.vala"
			result = 8;
#line 387 "../src/sudoku-cell.vala"
			return result;
#line 1442 "sudoku-cell.c"
		}
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_9:
#line 359 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_9:
#line 1448 "sudoku-cell.c"
		{
#line 390 "../src/sudoku-cell.vala"
			result = 9;
#line 390 "../src/sudoku-cell.vala"
			return result;
#line 1454 "sudoku-cell.c"
		}
		default:
		{
#line 392 "../src/sudoku-cell.vala"
			result = -1;
#line 392 "../src/sudoku-cell.vala"
			return result;
#line 1462 "sudoku-cell.c"
		}
	}
}

static void
sudoku_cell_get_visible_earmarks (SudokuCell* self)
{
	gboolean* marks = NULL;
	gint marks_length1;
	gint _marks_size_;
	gint num = 0;
#line 396 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 398 "../src/sudoku-cell.vala"
	marks = NULL;
#line 398 "../src/sudoku-cell.vala"
	marks_length1 = 0;
#line 398 "../src/sudoku-cell.vala"
	_marks_size_ = marks_length1;
#line 399 "../src/sudoku-cell.vala"
	if (!self->show_possibilities) {
#line 1484 "sudoku-cell.c"
		SudokuGame* _tmp18_;
		SudokuBoard* _tmp19_;
		gint _tmp20_ = 0;
		gboolean* _tmp21_;
#line 401 "../src/sudoku-cell.vala"
		if (!self->priv->initialized_earmarks) {
#line 1491 "sudoku-cell.c"
			gboolean _tmp0_ = FALSE;
			gboolean _tmp1_ = FALSE;
#line 403 "../src/sudoku-cell.vala"
			if (self->priv->_initialize_earmarks) {
#line 1496 "sudoku-cell.c"
				SudokuGame* _tmp2_;
#line 403 "../src/sudoku-cell.vala"
				_tmp2_ = self->priv->game;
#line 403 "../src/sudoku-cell.vala"
				_tmp1_ = _tmp2_->mode == GAME_MODE_PLAY;
#line 1502 "sudoku-cell.c"
			} else {
#line 403 "../src/sudoku-cell.vala"
				_tmp1_ = FALSE;
#line 1506 "sudoku-cell.c"
			}
#line 403 "../src/sudoku-cell.vala"
			if (_tmp1_) {
#line 1510 "sudoku-cell.c"
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				gdouble _tmp5_;
				gdouble _tmp6_;
#line 404 "../src/sudoku-cell.vala"
				_tmp3_ = self->priv->game;
#line 404 "../src/sudoku-cell.vala"
				_tmp4_ = _tmp3_->board;
#line 404 "../src/sudoku-cell.vala"
				_tmp5_ = sudoku_board_get_previous_played_time (_tmp4_);
#line 404 "../src/sudoku-cell.vala"
				_tmp6_ = _tmp5_;
#line 404 "../src/sudoku-cell.vala"
				_tmp0_ = _tmp6_ == 0.0;
#line 1525 "sudoku-cell.c"
			} else {
#line 403 "../src/sudoku-cell.vala"
				_tmp0_ = FALSE;
#line 1529 "sudoku-cell.c"
			}
#line 403 "../src/sudoku-cell.vala"
			if (_tmp0_) {
#line 1533 "sudoku-cell.c"
				SudokuGame* _tmp7_;
				SudokuBoard* _tmp8_;
				gint _tmp9_ = 0;
				gboolean* _tmp10_;
#line 406 "../src/sudoku-cell.vala"
				_tmp7_ = self->priv->game;
#line 406 "../src/sudoku-cell.vala"
				_tmp8_ = _tmp7_->board;
#line 406 "../src/sudoku-cell.vala"
				_tmp10_ = sudoku_board_get_possibilities_as_bool_array (_tmp8_, self->priv->row, self->priv->col, &_tmp9_);
#line 406 "../src/sudoku-cell.vala"
				marks = (g_free (marks), NULL);
#line 406 "../src/sudoku-cell.vala"
				marks = _tmp10_;
#line 406 "../src/sudoku-cell.vala"
				marks_length1 = _tmp9_;
#line 406 "../src/sudoku-cell.vala"
				_marks_size_ = marks_length1;
#line 1552 "sudoku-cell.c"
				{
					gint num = 0;
#line 407 "../src/sudoku-cell.vala"
					num = 1;
#line 1557 "sudoku-cell.c"
					{
						gboolean _tmp11_ = FALSE;
#line 407 "../src/sudoku-cell.vala"
						_tmp11_ = TRUE;
#line 407 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 1564 "sudoku-cell.c"
							gboolean* _tmp13_;
							gint _tmp13__length1;
							gboolean* _tmp14_;
							gint _tmp14__length1;
							gboolean _tmp15_;
#line 407 "../src/sudoku-cell.vala"
							if (!_tmp11_) {
#line 1572 "sudoku-cell.c"
								gint _tmp12_;
#line 407 "../src/sudoku-cell.vala"
								_tmp12_ = num;
#line 407 "../src/sudoku-cell.vala"
								num = _tmp12_ + 1;
#line 1578 "sudoku-cell.c"
							}
#line 407 "../src/sudoku-cell.vala"
							_tmp11_ = FALSE;
#line 407 "../src/sudoku-cell.vala"
							_tmp13_ = marks;
#line 407 "../src/sudoku-cell.vala"
							_tmp13__length1 = marks_length1;
#line 407 "../src/sudoku-cell.vala"
							if (!(num <= _tmp13__length1)) {
#line 407 "../src/sudoku-cell.vala"
								break;
#line 1590 "sudoku-cell.c"
							}
#line 409 "../src/sudoku-cell.vala"
							_tmp14_ = marks;
#line 409 "../src/sudoku-cell.vala"
							_tmp14__length1 = marks_length1;
#line 409 "../src/sudoku-cell.vala"
							_tmp15_ = _tmp14_[num - 1];
#line 409 "../src/sudoku-cell.vala"
							if (_tmp15_) {
#line 1600 "sudoku-cell.c"
								SudokuGame* _tmp16_;
								SudokuBoard* _tmp17_;
#line 411 "../src/sudoku-cell.vala"
								_tmp16_ = self->priv->game;
#line 411 "../src/sudoku-cell.vala"
								_tmp17_ = _tmp16_->board;
#line 411 "../src/sudoku-cell.vala"
								sudoku_board_enable_earmark (_tmp17_, self->priv->row, self->priv->col, num);
#line 1609 "sudoku-cell.c"
							}
						}
					}
				}
			}
#line 415 "../src/sudoku-cell.vala"
			self->priv->initialized_earmarks = TRUE;
#line 1617 "sudoku-cell.c"
		}
#line 418 "../src/sudoku-cell.vala"
		_tmp18_ = self->priv->game;
#line 418 "../src/sudoku-cell.vala"
		_tmp19_ = _tmp18_->board;
#line 418 "../src/sudoku-cell.vala"
		_tmp21_ = sudoku_board_get_earmarks (_tmp19_, self->priv->row, self->priv->col, &_tmp20_);
#line 418 "../src/sudoku-cell.vala"
		marks = (g_free (marks), NULL);
#line 418 "../src/sudoku-cell.vala"
		marks = _tmp21_;
#line 418 "../src/sudoku-cell.vala"
		marks_length1 = _tmp20_;
#line 418 "../src/sudoku-cell.vala"
		_marks_size_ = marks_length1;
#line 1633 "sudoku-cell.c"
	} else {
		gint _tmp22_;
		gint _tmp23_;
#line 420 "../src/sudoku-cell.vala"
		_tmp22_ = sudoku_cell_get_value (self);
#line 420 "../src/sudoku-cell.vala"
		_tmp23_ = _tmp22_;
#line 420 "../src/sudoku-cell.vala"
		if (_tmp23_ == 0) {
#line 1643 "sudoku-cell.c"
			SudokuGame* _tmp24_;
			SudokuBoard* _tmp25_;
			gint _tmp26_ = 0;
			gboolean* _tmp27_;
#line 422 "../src/sudoku-cell.vala"
			_tmp24_ = self->priv->game;
#line 422 "../src/sudoku-cell.vala"
			_tmp25_ = _tmp24_->board;
#line 422 "../src/sudoku-cell.vala"
			_tmp27_ = sudoku_board_get_possibilities_as_bool_array (_tmp25_, self->priv->row, self->priv->col, &_tmp26_);
#line 422 "../src/sudoku-cell.vala"
			marks = (g_free (marks), NULL);
#line 422 "../src/sudoku-cell.vala"
			marks = _tmp27_;
#line 422 "../src/sudoku-cell.vala"
			marks_length1 = _tmp26_;
#line 422 "../src/sudoku-cell.vala"
			_marks_size_ = marks_length1;
#line 1662 "sudoku-cell.c"
		}
	}
#line 425 "../src/sudoku-cell.vala"
	num = 0;
#line 1667 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 426 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 1672 "sudoku-cell.c"
		{
			gboolean _tmp28_ = FALSE;
#line 426 "../src/sudoku-cell.vala"
			_tmp28_ = TRUE;
#line 426 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 1679 "sudoku-cell.c"
				SudokuGame* _tmp30_;
				SudokuBoard* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
#line 426 "../src/sudoku-cell.vala"
				if (!_tmp28_) {
#line 1686 "sudoku-cell.c"
					gint _tmp29_;
#line 426 "../src/sudoku-cell.vala"
					_tmp29_ = row_tmp;
#line 426 "../src/sudoku-cell.vala"
					row_tmp = _tmp29_ + 1;
#line 1692 "sudoku-cell.c"
				}
#line 426 "../src/sudoku-cell.vala"
				_tmp28_ = FALSE;
#line 426 "../src/sudoku-cell.vala"
				_tmp30_ = self->priv->game;
#line 426 "../src/sudoku-cell.vala"
				_tmp31_ = _tmp30_->board;
#line 426 "../src/sudoku-cell.vala"
				_tmp32_ = sudoku_board_get_block_rows (_tmp31_);
#line 426 "../src/sudoku-cell.vala"
				_tmp33_ = _tmp32_;
#line 426 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp33_)) {
#line 426 "../src/sudoku-cell.vala"
					break;
#line 1708 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 428 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 1714 "sudoku-cell.c"
					{
						gboolean _tmp34_ = FALSE;
#line 428 "../src/sudoku-cell.vala"
						_tmp34_ = TRUE;
#line 428 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 1721 "sudoku-cell.c"
							SudokuGame* _tmp36_;
							SudokuBoard* _tmp37_;
							gint _tmp38_;
							gint _tmp39_;
							gint _tmp40_;
							gboolean _tmp41_ = FALSE;
							gboolean* _tmp42_;
							gint _tmp42__length1;
#line 428 "../src/sudoku-cell.vala"
							if (!_tmp34_) {
#line 1732 "sudoku-cell.c"
								gint _tmp35_;
#line 428 "../src/sudoku-cell.vala"
								_tmp35_ = col_tmp;
#line 428 "../src/sudoku-cell.vala"
								col_tmp = _tmp35_ + 1;
#line 1738 "sudoku-cell.c"
							}
#line 428 "../src/sudoku-cell.vala"
							_tmp34_ = FALSE;
#line 428 "../src/sudoku-cell.vala"
							_tmp36_ = self->priv->game;
#line 428 "../src/sudoku-cell.vala"
							_tmp37_ = _tmp36_->board;
#line 428 "../src/sudoku-cell.vala"
							_tmp38_ = sudoku_board_get_block_cols (_tmp37_);
#line 428 "../src/sudoku-cell.vala"
							_tmp39_ = _tmp38_;
#line 428 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp39_)) {
#line 428 "../src/sudoku-cell.vala"
								break;
#line 1754 "sudoku-cell.c"
							}
#line 430 "../src/sudoku-cell.vala"
							_tmp40_ = num;
#line 430 "../src/sudoku-cell.vala"
							num = _tmp40_ + 1;
#line 432 "../src/sudoku-cell.vala"
							_tmp42_ = marks;
#line 432 "../src/sudoku-cell.vala"
							_tmp42__length1 = marks_length1;
#line 432 "../src/sudoku-cell.vala"
							if (_tmp42_ == NULL) {
#line 432 "../src/sudoku-cell.vala"
								_tmp41_ = TRUE;
#line 1768 "sudoku-cell.c"
							} else {
								gint _tmp43_;
								gint _tmp44_;
#line 432 "../src/sudoku-cell.vala"
								_tmp43_ = sudoku_cell_get_value (self);
#line 432 "../src/sudoku-cell.vala"
								_tmp44_ = _tmp43_;
#line 432 "../src/sudoku-cell.vala"
								_tmp41_ = _tmp44_ != 0;
#line 1778 "sudoku-cell.c"
							}
#line 432 "../src/sudoku-cell.vala"
							if (_tmp41_) {
#line 1782 "sudoku-cell.c"
								GtkLabel** _tmp45_;
								gint _tmp45__length1;
								GtkLabel* _tmp46_;
#line 433 "../src/sudoku-cell.vala"
								_tmp45_ = self->priv->earmark_labels;
#line 433 "../src/sudoku-cell.vala"
								_tmp45__length1 = self->priv->earmark_labels_length1;
#line 433 "../src/sudoku-cell.vala"
								_tmp46_ = _tmp45_[num - 1];
#line 433 "../src/sudoku-cell.vala"
								gtk_widget_set_visible ((GtkWidget*) _tmp46_, FALSE);
#line 1794 "sudoku-cell.c"
							} else {
								GtkLabel** _tmp47_;
								gint _tmp47__length1;
								GtkLabel* _tmp48_;
								gboolean* _tmp49_;
								gint _tmp49__length1;
								gboolean _tmp50_;
#line 435 "../src/sudoku-cell.vala"
								_tmp47_ = self->priv->earmark_labels;
#line 435 "../src/sudoku-cell.vala"
								_tmp47__length1 = self->priv->earmark_labels_length1;
#line 435 "../src/sudoku-cell.vala"
								_tmp48_ = _tmp47_[num - 1];
#line 435 "../src/sudoku-cell.vala"
								_tmp49_ = marks;
#line 435 "../src/sudoku-cell.vala"
								_tmp49__length1 = marks_length1;
#line 435 "../src/sudoku-cell.vala"
								_tmp50_ = _tmp49_[num - 1];
#line 435 "../src/sudoku-cell.vala"
								gtk_widget_set_visible ((GtkWidget*) _tmp48_, _tmp50_);
#line 1816 "sudoku-cell.c"
							}
						}
					}
				}
			}
		}
	}
#line 396 "../src/sudoku-cell.vala"
	marks = (g_free (marks), NULL);
#line 1826 "sudoku-cell.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 440 "../src/sudoku-cell.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 440 "../src/sudoku-cell.vala"
	return _data10_;
#line 1836 "sudoku-cell.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 440 "../src/sudoku-cell.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 1846 "sudoku-cell.c"
		SudokuCell* self;
#line 440 "../src/sudoku-cell.vala"
		self = _data10_->self;
#line 440 "../src/sudoku-cell.vala"
		_g_object_unref0 (_data10_->earmark_picker);
#line 440 "../src/sudoku-cell.vala"
		_g_object_unref0 (self);
#line 440 "../src/sudoku-cell.vala"
		g_slice_free (Block10Data, _data10_);
#line 1856 "sudoku-cell.c"
	}
}

static void
__lambda7_ (Block10Data* _data10_,
            gint number,
            gboolean state)
{
	SudokuCell* self;
	SudokuGame* _tmp3_;
	SudokuBoard* _tmp4_;
	SudokuGame* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
#line 446 "../src/sudoku-cell.vala"
	self = _data10_->self;
#line 447 "../src/sudoku-cell.vala"
	if (state) {
#line 1877 "sudoku-cell.c"
		SudokuGame* _tmp0_;
#line 449 "../src/sudoku-cell.vala"
		_tmp0_ = self->priv->game;
#line 449 "../src/sudoku-cell.vala"
		sudoku_game_enable_earmark (_tmp0_, self->priv->row, self->priv->col, number);
#line 1883 "sudoku-cell.c"
	} else {
#line 453 "../src/sudoku-cell.vala"
		if (number == 0) {
#line 1887 "sudoku-cell.c"
			SudokuGame* _tmp1_;
#line 454 "../src/sudoku-cell.vala"
			_tmp1_ = self->priv->game;
#line 454 "../src/sudoku-cell.vala"
			sudoku_game_disable_all_earmarks (_tmp1_, self->priv->row, self->priv->col);
#line 1893 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp2_;
#line 456 "../src/sudoku-cell.vala"
			_tmp2_ = self->priv->game;
#line 456 "../src/sudoku-cell.vala"
			sudoku_game_disable_earmark (_tmp2_, self->priv->row, self->priv->col, number);
#line 1900 "sudoku-cell.c"
		}
	}
#line 459 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->game;
#line 459 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_->board;
#line 459 "../src/sudoku-cell.vala"
	if (!sudoku_board_has_earmarks (_tmp4_, self->priv->row, self->priv->col)) {
#line 1909 "sudoku-cell.c"
		NumberPicker* _tmp5_;
#line 460 "../src/sudoku-cell.vala"
		_tmp5_ = _data10_->earmark_picker;
#line 460 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_enabled (_tmp5_, FALSE);
#line 1915 "sudoku-cell.c"
	} else {
		NumberPicker* _tmp6_;
#line 462 "../src/sudoku-cell.vala"
		_tmp6_ = _data10_->earmark_picker;
#line 462 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_enabled (_tmp6_, TRUE);
#line 1922 "sudoku-cell.c"
	}
#line 464 "../src/sudoku-cell.vala"
	sudoku_cell_check_warnings (self);
#line 465 "../src/sudoku-cell.vala"
	_tmp7_ = self->priv->game;
#line 465 "../src/sudoku-cell.vala"
	_tmp8_ = sudoku_cell_get_value (self);
#line 465 "../src/sudoku-cell.vala"
	_tmp9_ = _tmp8_;
#line 465 "../src/sudoku-cell.vala"
	_tmp10_ = sudoku_cell_get_value (self);
#line 465 "../src/sudoku-cell.vala"
	_tmp11_ = _tmp10_;
#line 465 "../src/sudoku-cell.vala"
	g_signal_emit_by_name (_tmp7_, "cell-changed", self->priv->row, self->priv->col, _tmp9_, _tmp11_);
#line 1938 "sudoku-cell.c"
}

static void
___lambda7__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                 gint number,
                                                 gboolean active,
                                                 gpointer self)
{
#line 446 "../src/sudoku-cell.vala"
	__lambda7_ (self, number, active);
#line 1949 "sudoku-cell.c"
}

static void
sudoku_cell_show_earmark_picker (SudokuCell* self)
{
	Block10Data* _data10_;
	SudokuGame* _tmp0_;
	NumberPicker* _tmp1_;
	NumberPicker* _tmp2_;
	SudokuGame* _tmp3_;
	SudokuBoard* _tmp4_;
	NumberPicker* _tmp6_;
	NumberPicker* _tmp7_;
	GtkPopover* _tmp8_;
	NumberPicker* _tmp9_;
	GtkPopover* _tmp10_;
#line 440 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 440 "../src/sudoku-cell.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 440 "../src/sudoku-cell.vala"
	_data10_->_ref_count_ = 1;
#line 440 "../src/sudoku-cell.vala"
	_data10_->self = g_object_ref (self);
#line 442 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 442 "../src/sudoku-cell.vala"
	_tmp1_ = number_picker_new (&_tmp0_->board, TRUE);
#line 442 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp1_);
#line 442 "../src/sudoku-cell.vala"
	_data10_->earmark_picker = _tmp1_;
#line 443 "../src/sudoku-cell.vala"
	_tmp2_ = _data10_->earmark_picker;
#line 443 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_visibility (_tmp2_, TRUE);
#line 444 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->game;
#line 444 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_->board;
#line 444 "../src/sudoku-cell.vala"
	if (!sudoku_board_has_earmarks (_tmp4_, self->priv->row, self->priv->col)) {
#line 1992 "sudoku-cell.c"
		NumberPicker* _tmp5_;
#line 445 "../src/sudoku-cell.vala"
		_tmp5_ = _data10_->earmark_picker;
#line 445 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_enabled (_tmp5_, FALSE);
#line 1998 "sudoku-cell.c"
	}
#line 446 "../src/sudoku-cell.vala"
	_tmp6_ = _data10_->earmark_picker;
#line 446 "../src/sudoku-cell.vala"
	g_signal_connect_data (_tmp6_, "earmark-state-changed", (GCallback) ___lambda7__number_picker_earmark_state_changed, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 467 "../src/sudoku-cell.vala"
	_tmp7_ = _data10_->earmark_picker;
#line 467 "../src/sudoku-cell.vala"
	number_picker_set_earmarks (_tmp7_, self->priv->row, self->priv->col);
#line 468 "../src/sudoku-cell.vala"
	_tmp8_ = self->popover;
#line 468 "../src/sudoku-cell.vala"
	_tmp9_ = _data10_->earmark_picker;
#line 468 "../src/sudoku-cell.vala"
	gtk_popover_set_child (_tmp8_, (GtkWidget*) _tmp9_);
#line 470 "../src/sudoku-cell.vala"
	_tmp10_ = self->popover;
#line 470 "../src/sudoku-cell.vala"
	gtk_popover_popup (_tmp10_);
#line 440 "../src/sudoku-cell.vala"
	block10_data_unref (_data10_);
#line 440 "../src/sudoku-cell.vala"
	_data10_ = NULL;
#line 2022 "sudoku-cell.c"
}

static void
__lambda8_ (SudokuCell* self,
            NumberPicker* o,
            gint number)
{
	GtkPopover* _tmp0_;
	SudokuGame* _tmp1_;
	SudokuBoard* _tmp2_;
	SudokuGame* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 476 "../src/sudoku-cell.vala"
	g_return_if_fail (o != NULL);
#line 477 "../src/sudoku-cell.vala"
	_tmp0_ = self->popover;
#line 477 "../src/sudoku-cell.vala"
	gtk_popover_popdown (_tmp0_);
#line 479 "../src/sudoku-cell.vala"
	sudoku_cell_set_value (self, number);
#line 480 "../src/sudoku-cell.vala"
	if (number == 0) {
#line 481 "../src/sudoku-cell.vala"
		g_object_notify ((GObject*) self, "value");
#line 2050 "sudoku-cell.c"
	}
#line 482 "../src/sudoku-cell.vala"
	_tmp1_ = self->priv->game;
#line 482 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_->board;
#line 482 "../src/sudoku-cell.vala"
	sudoku_board_disable_all_earmarks (_tmp2_, self->priv->row, self->priv->col);
#line 483 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->game;
#line 483 "../src/sudoku-cell.vala"
	_tmp4_ = sudoku_cell_get_value (self);
#line 483 "../src/sudoku-cell.vala"
	_tmp5_ = _tmp4_;
#line 483 "../src/sudoku-cell.vala"
	_tmp6_ = sudoku_cell_get_value (self);
#line 483 "../src/sudoku-cell.vala"
	_tmp7_ = _tmp6_;
#line 483 "../src/sudoku-cell.vala"
	g_signal_emit_by_name (_tmp3_, "cell-changed", self->priv->row, self->priv->col, _tmp5_, _tmp7_);
#line 2070 "sudoku-cell.c"
}

static void
___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                         gint number,
                                         gpointer self)
{
#line 476 "../src/sudoku-cell.vala"
	__lambda8_ ((SudokuCell*) self, _sender, number);
#line 2080 "sudoku-cell.c"
}

static void
sudoku_cell_show_number_picker (SudokuCell* self)
{
	NumberPicker* number_picker = NULL;
	SudokuGame* _tmp0_;
	NumberPicker* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkPopover* _tmp4_;
	GtkPopover* _tmp5_;
#line 473 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 475 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 475 "../src/sudoku-cell.vala"
	_tmp1_ = number_picker_new (&_tmp0_->board, FALSE);
#line 475 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp1_);
#line 475 "../src/sudoku-cell.vala"
	number_picker = _tmp1_;
#line 476 "../src/sudoku-cell.vala"
	g_signal_connect_object (number_picker, "number-picked", (GCallback) ___lambda8__number_picker_number_picked, self, 0);
#line 485 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_value (self);
#line 485 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 485 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_visibility (number_picker, _tmp3_ != 0);
#line 486 "../src/sudoku-cell.vala"
	_tmp4_ = self->popover;
#line 486 "../src/sudoku-cell.vala"
	gtk_popover_set_child (_tmp4_, (GtkWidget*) number_picker);
#line 488 "../src/sudoku-cell.vala"
	_tmp5_ = self->popover;
#line 488 "../src/sudoku-cell.vala"
	gtk_popover_popup (_tmp5_);
#line 473 "../src/sudoku-cell.vala"
	_g_object_unref0 (number_picker);
#line 2121 "sudoku-cell.c"
}

void
sudoku_cell_check_warnings (SudokuCell* self)
{
	gboolean _error_ = FALSE;
	gint solution = 0;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gboolean* marks = NULL;
	SudokuGame* _tmp2_;
	SudokuBoard* _tmp3_;
	gint _tmp4_ = 0;
	gboolean* _tmp5_;
	gint marks_length1;
	gint _marks_size_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_;
	gboolean _tmp27_;
	gint _tmp32_;
	gint _tmp33_;
#line 491 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 493 "../src/sudoku-cell.vala"
	_error_ = FALSE;
#line 494 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 494 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_->board;
#line 494 "../src/sudoku-cell.vala"
	solution = sudoku_board_get_solution (_tmp1_, self->priv->row, self->priv->col);
#line 495 "../src/sudoku-cell.vala"
	_tmp2_ = self->priv->game;
#line 495 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_->board;
#line 495 "../src/sudoku-cell.vala"
	_tmp5_ = sudoku_board_get_earmarks (_tmp3_, self->priv->row, self->priv->col, &_tmp4_);
#line 495 "../src/sudoku-cell.vala"
	marks = _tmp5_;
#line 495 "../src/sudoku-cell.vala"
	marks_length1 = _tmp4_;
#line 495 "../src/sudoku-cell.vala"
	_marks_size_ = marks_length1;
#line 497 "../src/sudoku-cell.vala"
	_tmp8_ = sudoku_cell_get_show_warnings (self);
#line 497 "../src/sudoku-cell.vala"
	_tmp9_ = _tmp8_;
#line 497 "../src/sudoku-cell.vala"
	if (_tmp9_) {
#line 2176 "sudoku-cell.c"
		gint _tmp10_;
		gint _tmp11_;
#line 498 "../src/sudoku-cell.vala"
		_tmp10_ = sudoku_cell_get_value (self);
#line 498 "../src/sudoku-cell.vala"
		_tmp11_ = _tmp10_;
#line 498 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp11_ == 0;
#line 2185 "sudoku-cell.c"
	} else {
#line 497 "../src/sudoku-cell.vala"
		_tmp7_ = FALSE;
#line 2189 "sudoku-cell.c"
	}
#line 497 "../src/sudoku-cell.vala"
	if (_tmp7_) {
#line 2193 "sudoku-cell.c"
		SudokuGame* _tmp12_;
		SudokuBoard* _tmp13_;
#line 499 "../src/sudoku-cell.vala"
		_tmp12_ = self->priv->game;
#line 499 "../src/sudoku-cell.vala"
		_tmp13_ = _tmp12_->board;
#line 499 "../src/sudoku-cell.vala"
		_tmp6_ = sudoku_board_count_possibilities (_tmp13_, self->priv->row, self->priv->col) == 0;
#line 2202 "sudoku-cell.c"
	} else {
#line 497 "../src/sudoku-cell.vala"
		_tmp6_ = FALSE;
#line 2206 "sudoku-cell.c"
	}
#line 497 "../src/sudoku-cell.vala"
	if (_tmp6_) {
#line 2210 "sudoku-cell.c"
		GtkLabel* _tmp14_;
#line 501 "../src/sudoku-cell.vala"
		_tmp14_ = self->priv->value_label;
#line 501 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp14_, "X");
#line 2216 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 504 "../src/sudoku-cell.vala"
		_tmp15_ = self->priv->value_label;
#line 504 "../src/sudoku-cell.vala"
		_tmp16_ = sudoku_cell_get_value (self);
#line 504 "../src/sudoku-cell.vala"
		_tmp17_ = _tmp16_;
#line 504 "../src/sudoku-cell.vala"
		_tmp18_ = g_strdup_printf ("%i", _tmp17_);
#line 504 "../src/sudoku-cell.vala"
		_tmp19_ = _tmp18_;
#line 504 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp15_, _tmp19_);
#line 504 "../src/sudoku-cell.vala"
		_g_free0 (_tmp19_);
#line 2237 "sudoku-cell.c"
	}
#line 506 "../src/sudoku-cell.vala"
	if (sudoku_cell_warn_incorrect_solution (self)) {
#line 2241 "sudoku-cell.c"
		gint _tmp21_;
		gint _tmp22_;
#line 506 "../src/sudoku-cell.vala"
		_tmp21_ = sudoku_cell_get_value (self);
#line 506 "../src/sudoku-cell.vala"
		_tmp22_ = _tmp21_;
#line 506 "../src/sudoku-cell.vala"
		_tmp20_ = _tmp22_ != 0;
#line 2250 "sudoku-cell.c"
	} else {
#line 506 "../src/sudoku-cell.vala"
		_tmp20_ = FALSE;
#line 2254 "sudoku-cell.c"
	}
#line 506 "../src/sudoku-cell.vala"
	if (_tmp20_) {
#line 2258 "sudoku-cell.c"
		gint _tmp23_;
		gint _tmp24_;
#line 507 "../src/sudoku-cell.vala"
		_tmp23_ = sudoku_cell_get_value (self);
#line 507 "../src/sudoku-cell.vala"
		_tmp24_ = _tmp23_;
#line 507 "../src/sudoku-cell.vala"
		_error_ = _tmp24_ != solution;
#line 2267 "sudoku-cell.c"
	}
#line 509 "../src/sudoku-cell.vala"
	_tmp26_ = sudoku_cell_get_show_warnings (self);
#line 509 "../src/sudoku-cell.vala"
	_tmp27_ = _tmp26_;
#line 509 "../src/sudoku-cell.vala"
	if (_tmp27_) {
#line 2275 "sudoku-cell.c"
		SudokuGame* _tmp28_;
		SudokuBoard* _tmp29_;
		GeeSet* _tmp30_;
		Coord _tmp31_ = {0};
#line 510 "../src/sudoku-cell.vala"
		_tmp28_ = self->priv->game;
#line 510 "../src/sudoku-cell.vala"
		_tmp29_ = _tmp28_->board;
#line 510 "../src/sudoku-cell.vala"
		_tmp30_ = _tmp29_->broken_coords;
#line 510 "../src/sudoku-cell.vala"
		coord_init (&_tmp31_, self->priv->row, self->priv->col);
#line 510 "../src/sudoku-cell.vala"
		_tmp25_ = gee_collection_contains ((GeeCollection*) _tmp30_, &_tmp31_);
#line 2290 "sudoku-cell.c"
	} else {
#line 509 "../src/sudoku-cell.vala"
		_tmp25_ = FALSE;
#line 2294 "sudoku-cell.c"
	}
#line 509 "../src/sudoku-cell.vala"
	if (_tmp25_) {
#line 512 "../src/sudoku-cell.vala"
		_error_ = TRUE;
#line 2300 "sudoku-cell.c"
	}
#line 515 "../src/sudoku-cell.vala"
	if (_error_) {
#line 516 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "error");
#line 2306 "sudoku-cell.c"
	} else {
#line 518 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "error");
#line 2310 "sudoku-cell.c"
	}
#line 520 "../src/sudoku-cell.vala"
	_tmp32_ = sudoku_cell_get_value (self);
#line 520 "../src/sudoku-cell.vala"
	_tmp33_ = _tmp32_;
#line 520 "../src/sudoku-cell.vala"
	if (_tmp33_ != 0) {
#line 521 "../src/sudoku-cell.vala"
		marks = (g_free (marks), NULL);
#line 521 "../src/sudoku-cell.vala"
		return;
#line 2322 "sudoku-cell.c"
	}
	{
		gint num = 0;
#line 523 "../src/sudoku-cell.vala"
		num = 1;
#line 2328 "sudoku-cell.c"
		{
			gboolean _tmp34_ = FALSE;
#line 523 "../src/sudoku-cell.vala"
			_tmp34_ = TRUE;
#line 523 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 2335 "sudoku-cell.c"
				gboolean* _tmp36_;
				gint _tmp36__length1;
				gboolean* _tmp37_;
				gint _tmp37__length1;
				gboolean _tmp38_;
#line 523 "../src/sudoku-cell.vala"
				if (!_tmp34_) {
#line 2343 "sudoku-cell.c"
					gint _tmp35_;
#line 523 "../src/sudoku-cell.vala"
					_tmp35_ = num;
#line 523 "../src/sudoku-cell.vala"
					num = _tmp35_ + 1;
#line 2349 "sudoku-cell.c"
				}
#line 523 "../src/sudoku-cell.vala"
				_tmp34_ = FALSE;
#line 523 "../src/sudoku-cell.vala"
				_tmp36_ = marks;
#line 523 "../src/sudoku-cell.vala"
				_tmp36__length1 = marks_length1;
#line 523 "../src/sudoku-cell.vala"
				if (!(num <= _tmp36__length1)) {
#line 523 "../src/sudoku-cell.vala"
					break;
#line 2361 "sudoku-cell.c"
				}
#line 525 "../src/sudoku-cell.vala"
				_tmp37_ = marks;
#line 525 "../src/sudoku-cell.vala"
				_tmp37__length1 = marks_length1;
#line 525 "../src/sudoku-cell.vala"
				_tmp38_ = _tmp37_[num - 1];
#line 525 "../src/sudoku-cell.vala"
				if (_tmp38_) {
#line 2371 "sudoku-cell.c"
					gboolean _tmp39_ = FALSE;
					gboolean _tmp40_ = FALSE;
					gboolean _tmp41_;
					gboolean _tmp42_;
#line 527 "../src/sudoku-cell.vala"
					_tmp41_ = sudoku_cell_get_show_warnings (self);
#line 527 "../src/sudoku-cell.vala"
					_tmp42_ = _tmp41_;
#line 527 "../src/sudoku-cell.vala"
					if (_tmp42_) {
#line 2382 "sudoku-cell.c"
						SudokuGame* _tmp43_;
						SudokuBoard* _tmp44_;
#line 527 "../src/sudoku-cell.vala"
						_tmp43_ = self->priv->game;
#line 527 "../src/sudoku-cell.vala"
						_tmp44_ = _tmp43_->board;
#line 527 "../src/sudoku-cell.vala"
						_tmp40_ = !sudoku_board_is_possible (_tmp44_, self->priv->row, self->priv->col, num);
#line 2391 "sudoku-cell.c"
					} else {
#line 527 "../src/sudoku-cell.vala"
						_tmp40_ = FALSE;
#line 2395 "sudoku-cell.c"
					}
#line 527 "../src/sudoku-cell.vala"
					if (_tmp40_) {
#line 527 "../src/sudoku-cell.vala"
						_tmp39_ = TRUE;
#line 2401 "sudoku-cell.c"
					} else {
						gboolean _tmp45_ = FALSE;
#line 527 "../src/sudoku-cell.vala"
						if (sudoku_cell_warn_incorrect_solution (self)) {
#line 527 "../src/sudoku-cell.vala"
							_tmp45_ = num != solution;
#line 2408 "sudoku-cell.c"
						} else {
#line 527 "../src/sudoku-cell.vala"
							_tmp45_ = FALSE;
#line 2412 "sudoku-cell.c"
						}
#line 527 "../src/sudoku-cell.vala"
						_tmp39_ = _tmp45_;
#line 2416 "sudoku-cell.c"
					}
#line 527 "../src/sudoku-cell.vala"
					if (_tmp39_) {
#line 2420 "sudoku-cell.c"
						GtkLabel** _tmp46_;
						gint _tmp46__length1;
						GtkLabel* _tmp47_;
#line 528 "../src/sudoku-cell.vala"
						_tmp46_ = self->priv->earmark_labels;
#line 528 "../src/sudoku-cell.vala"
						_tmp46__length1 = self->priv->earmark_labels_length1;
#line 528 "../src/sudoku-cell.vala"
						_tmp47_ = _tmp46_[num - 1];
#line 528 "../src/sudoku-cell.vala"
						gtk_widget_add_css_class ((GtkWidget*) _tmp47_, "error");
#line 2432 "sudoku-cell.c"
					} else {
						GtkLabel** _tmp48_;
						gint _tmp48__length1;
						GtkLabel* _tmp49_;
#line 530 "../src/sudoku-cell.vala"
						_tmp48_ = self->priv->earmark_labels;
#line 530 "../src/sudoku-cell.vala"
						_tmp48__length1 = self->priv->earmark_labels_length1;
#line 530 "../src/sudoku-cell.vala"
						_tmp49_ = _tmp48_[num - 1];
#line 530 "../src/sudoku-cell.vala"
						gtk_widget_remove_css_class ((GtkWidget*) _tmp49_, "error");
#line 2445 "sudoku-cell.c"
					}
				}
			}
		}
	}
#line 491 "../src/sudoku-cell.vala"
	marks = (g_free (marks), NULL);
#line 2453 "sudoku-cell.c"
}

static gboolean
sudoku_cell_warn_incorrect_solution (SudokuCell* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 538 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 544 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_show_extra_warnings (self);
#line 544 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 544 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 545 "../src/sudoku-cell.vala"
		_tmp1_ = !self->priv->control_key_pressed;
#line 2474 "sudoku-cell.c"
	} else {
#line 544 "../src/sudoku-cell.vala"
		_tmp1_ = FALSE;
#line 2478 "sudoku-cell.c"
	}
#line 544 "../src/sudoku-cell.vala"
	if (_tmp1_) {
#line 2482 "sudoku-cell.c"
		SudokuGame* _tmp4_;
		SudokuBoard* _tmp5_;
#line 546 "../src/sudoku-cell.vala"
		_tmp4_ = self->priv->game;
#line 546 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_->board;
#line 546 "../src/sudoku-cell.vala"
		_tmp0_ = sudoku_board_solved (_tmp5_);
#line 2491 "sudoku-cell.c"
	} else {
#line 544 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 2495 "sudoku-cell.c"
	}
#line 544 "../src/sudoku-cell.vala"
	result = _tmp0_;
#line 544 "../src/sudoku-cell.vala"
	return result;
#line 2501 "sudoku-cell.c"
}

static void
sudoku_cell_real_dispose (GObject* base)
{
	SudokuCell * self;
	GtkLabel* _tmp0_;
#line 549 "../src/sudoku-cell.vala"
	self = (SudokuCell*) base;
#line 551 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 553 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->value_label;
#line 553 "../src/sudoku-cell.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 2517 "sudoku-cell.c"
}

static gpointer
_gsk_transform_ref0 (gpointer self)
{
#line 571 "../src/sudoku-cell.vala"
	return self ? gsk_transform_ref (self) : NULL;
#line 2525 "sudoku-cell.c"
}

static void
sudoku_cell_real_size_allocate (GtkWidget* base,
                                gint width,
                                gint height,
                                gint baseline)
{
	SudokuCell * self;
	GtkPopover* _tmp0_;
	gint value_width = 0;
	gint value_height = 0;
	GskTransform* center = NULL;
	GskTransform* _tmp1_;
	graphene_point_t _tmp2_ = {0};
	graphene_point_t _tmp3_;
	GskTransform* _tmp4_;
	GtkLabel* _tmp5_;
	GskTransform* _tmp6_;
	GskTransform* _tmp7_;
	gint earmark_width = 0;
	gint earmark_height = 0;
	SudokuGame* _tmp8_;
	SudokuBoard* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	SudokuGame* _tmp12_;
	SudokuBoard* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint num = 0;
#line 556 "../src/sudoku-cell.vala"
	self = (SudokuCell*) base;
#line 560 "../src/sudoku-cell.vala"
	_tmp0_ = self->popover;
#line 560 "../src/sudoku-cell.vala"
	gtk_popover_present (_tmp0_);
#line 563 "../src/sudoku-cell.vala"
	value_height = MIN (width, height);
#line 563 "../src/sudoku-cell.vala"
	value_width = value_height;
#line 565 "../src/sudoku-cell.vala"
	sudoku_cell_set_font_size (self, &self->priv->value_label, height / SUDOKU_CELL_size_ratio);
#line 567 "../src/sudoku-cell.vala"
	_tmp1_ = gsk_transform_new ();
#line 567 "../src/sudoku-cell.vala"
	memset (&_tmp2_, 0, sizeof (graphene_point_t));
#line 567 "../src/sudoku-cell.vala"
	_tmp3_ = *graphene_point_init (&_tmp2_, (gfloat) ((width - value_width) / 2), (gfloat) ((height - value_height) / 2));
#line 567 "../src/sudoku-cell.vala"
	_tmp4_ = gsk_transform_translate (_tmp1_, &_tmp3_);
#line 567 "../src/sudoku-cell.vala"
	center = _tmp4_;
#line 571 "../src/sudoku-cell.vala"
	_tmp5_ = self->priv->value_label;
#line 571 "../src/sudoku-cell.vala"
	_tmp6_ = center;
#line 571 "../src/sudoku-cell.vala"
	_tmp7_ = _gsk_transform_ref0 (_tmp6_);
#line 571 "../src/sudoku-cell.vala"
	gtk_widget_allocate ((GtkWidget*) _tmp5_, value_width, value_height, baseline, _tmp7_);
#line 574 "../src/sudoku-cell.vala"
	_tmp8_ = self->priv->game;
#line 574 "../src/sudoku-cell.vala"
	_tmp9_ = _tmp8_->board;
#line 574 "../src/sudoku-cell.vala"
	_tmp10_ = sudoku_board_get_block_cols (_tmp9_);
#line 574 "../src/sudoku-cell.vala"
	_tmp11_ = _tmp10_;
#line 574 "../src/sudoku-cell.vala"
	earmark_width = width / _tmp11_;
#line 575 "../src/sudoku-cell.vala"
	_tmp12_ = self->priv->game;
#line 575 "../src/sudoku-cell.vala"
	_tmp13_ = _tmp12_->board;
#line 575 "../src/sudoku-cell.vala"
	_tmp14_ = sudoku_board_get_block_rows (_tmp13_);
#line 575 "../src/sudoku-cell.vala"
	_tmp15_ = _tmp14_;
#line 575 "../src/sudoku-cell.vala"
	earmark_height = height / _tmp15_;
#line 577 "../src/sudoku-cell.vala"
	num = 0;
#line 2609 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 578 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 2614 "sudoku-cell.c"
		{
			gboolean _tmp16_ = FALSE;
#line 578 "../src/sudoku-cell.vala"
			_tmp16_ = TRUE;
#line 578 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 2621 "sudoku-cell.c"
				SudokuGame* _tmp18_;
				SudokuBoard* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
#line 578 "../src/sudoku-cell.vala"
				if (!_tmp16_) {
#line 2628 "sudoku-cell.c"
					gint _tmp17_;
#line 578 "../src/sudoku-cell.vala"
					_tmp17_ = row_tmp;
#line 578 "../src/sudoku-cell.vala"
					row_tmp = _tmp17_ + 1;
#line 2634 "sudoku-cell.c"
				}
#line 578 "../src/sudoku-cell.vala"
				_tmp16_ = FALSE;
#line 578 "../src/sudoku-cell.vala"
				_tmp18_ = self->priv->game;
#line 578 "../src/sudoku-cell.vala"
				_tmp19_ = _tmp18_->board;
#line 578 "../src/sudoku-cell.vala"
				_tmp20_ = sudoku_board_get_block_rows (_tmp19_);
#line 578 "../src/sudoku-cell.vala"
				_tmp21_ = _tmp20_;
#line 578 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp21_)) {
#line 578 "../src/sudoku-cell.vala"
					break;
#line 2650 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 580 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 2656 "sudoku-cell.c"
					{
						gboolean _tmp22_ = FALSE;
#line 580 "../src/sudoku-cell.vala"
						_tmp22_ = TRUE;
#line 580 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 2663 "sudoku-cell.c"
							SudokuGame* _tmp24_;
							SudokuBoard* _tmp25_;
							gint _tmp26_;
							gint _tmp27_;
							gint _tmp28_;
							GtkLabel** _tmp29_;
							gint _tmp29__length1;
							GskTransform* earmark_position = NULL;
							GskTransform* _tmp30_;
							graphene_point_t _tmp31_ = {0};
							SudokuGame* _tmp32_;
							SudokuBoard* _tmp33_;
							gint _tmp34_;
							gint _tmp35_;
							graphene_point_t _tmp36_;
							GskTransform* _tmp37_;
							GtkLabel** _tmp38_;
							gint _tmp38__length1;
							GtkLabel* _tmp39_;
							GskTransform* _tmp40_;
							GskTransform* _tmp41_;
#line 580 "../src/sudoku-cell.vala"
							if (!_tmp22_) {
#line 2687 "sudoku-cell.c"
								gint _tmp23_;
#line 580 "../src/sudoku-cell.vala"
								_tmp23_ = col_tmp;
#line 580 "../src/sudoku-cell.vala"
								col_tmp = _tmp23_ + 1;
#line 2693 "sudoku-cell.c"
							}
#line 580 "../src/sudoku-cell.vala"
							_tmp22_ = FALSE;
#line 580 "../src/sudoku-cell.vala"
							_tmp24_ = self->priv->game;
#line 580 "../src/sudoku-cell.vala"
							_tmp25_ = _tmp24_->board;
#line 580 "../src/sudoku-cell.vala"
							_tmp26_ = sudoku_board_get_block_cols (_tmp25_);
#line 580 "../src/sudoku-cell.vala"
							_tmp27_ = _tmp26_;
#line 580 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp27_)) {
#line 580 "../src/sudoku-cell.vala"
								break;
#line 2709 "sudoku-cell.c"
							}
#line 582 "../src/sudoku-cell.vala"
							_tmp28_ = num;
#line 582 "../src/sudoku-cell.vala"
							num = _tmp28_ + 1;
#line 584 "../src/sudoku-cell.vala"
							_tmp29_ = self->priv->earmark_labels;
#line 584 "../src/sudoku-cell.vala"
							_tmp29__length1 = self->priv->earmark_labels_length1;
#line 584 "../src/sudoku-cell.vala"
							sudoku_cell_set_font_size (self, &_tmp29_[num - 1], (height / SUDOKU_CELL_size_ratio) / 2);
#line 586 "../src/sudoku-cell.vala"
							_tmp30_ = gsk_transform_new ();
#line 586 "../src/sudoku-cell.vala"
							memset (&_tmp31_, 0, sizeof (graphene_point_t));
#line 586 "../src/sudoku-cell.vala"
							_tmp32_ = self->priv->game;
#line 586 "../src/sudoku-cell.vala"
							_tmp33_ = _tmp32_->board;
#line 586 "../src/sudoku-cell.vala"
							_tmp34_ = sudoku_board_get_block_rows (_tmp33_);
#line 586 "../src/sudoku-cell.vala"
							_tmp35_ = _tmp34_;
#line 586 "../src/sudoku-cell.vala"
							_tmp36_ = *graphene_point_init (&_tmp31_, (gfloat) (col_tmp * earmark_width), (gfloat) (((_tmp35_ - row_tmp) - 1) * earmark_height));
#line 586 "../src/sudoku-cell.vala"
							_tmp37_ = gsk_transform_translate (_tmp30_, &_tmp36_);
#line 586 "../src/sudoku-cell.vala"
							earmark_position = _tmp37_;
#line 591 "../src/sudoku-cell.vala"
							_tmp38_ = self->priv->earmark_labels;
#line 591 "../src/sudoku-cell.vala"
							_tmp38__length1 = self->priv->earmark_labels_length1;
#line 591 "../src/sudoku-cell.vala"
							_tmp39_ = _tmp38_[num - 1];
#line 591 "../src/sudoku-cell.vala"
							_tmp40_ = earmark_position;
#line 591 "../src/sudoku-cell.vala"
							_tmp41_ = _gsk_transform_ref0 (_tmp40_);
#line 591 "../src/sudoku-cell.vala"
							gtk_widget_allocate ((GtkWidget*) _tmp39_, earmark_width, earmark_height, baseline, _tmp41_);
#line 580 "../src/sudoku-cell.vala"
							_gsk_transform_unref0 (earmark_position);
#line 2753 "sudoku-cell.c"
						}
					}
				}
			}
		}
	}
#line 556 "../src/sudoku-cell.vala"
	_gsk_transform_unref0 (center);
#line 2762 "sudoku-cell.c"
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 598 "../src/sudoku-cell.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 2770 "sudoku-cell.c"
}

static void
sudoku_cell_set_font_size (SudokuCell* self,
                           GtkLabel** label,
                           gint font_size)
{
	PangoAttrList* attr_list = NULL;
	PangoAttrList* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp4_;
	PangoAttribute* _tmp5_;
	PangoAttrList* _tmp6_;
#line 596 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 596 "../src/sudoku-cell.vala"
	g_return_if_fail (*label != NULL);
#line 598 "../src/sudoku-cell.vala"
	_tmp0_ = gtk_label_get_attributes (*label);
#line 598 "../src/sudoku-cell.vala"
	_tmp1_ = _pango_attr_list_ref0 (_tmp0_);
#line 598 "../src/sudoku-cell.vala"
	attr_list = _tmp1_;
#line 599 "../src/sudoku-cell.vala"
	_tmp2_ = attr_list;
#line 599 "../src/sudoku-cell.vala"
	if (_tmp2_ == NULL) {
#line 2799 "sudoku-cell.c"
		PangoAttrList* _tmp3_;
#line 600 "../src/sudoku-cell.vala"
		_tmp3_ = pango_attr_list_new ();
#line 600 "../src/sudoku-cell.vala"
		_pango_attr_list_unref0 (attr_list);
#line 600 "../src/sudoku-cell.vala"
		attr_list = _tmp3_;
#line 2807 "sudoku-cell.c"
	}
#line 602 "../src/sudoku-cell.vala"
	_tmp4_ = attr_list;
#line 602 "../src/sudoku-cell.vala"
	_tmp5_ = pango_attr_size_new_absolute (font_size * PANGO_SCALE);
#line 602 "../src/sudoku-cell.vala"
	pango_attr_list_change (_tmp4_, _tmp5_);
#line 606 "../src/sudoku-cell.vala"
	_tmp6_ = attr_list;
#line 606 "../src/sudoku-cell.vala"
	gtk_label_set_attributes (*label, _tmp6_);
#line 596 "../src/sudoku-cell.vala"
	_pango_attr_list_unref0 (attr_list);
#line 2821 "sudoku-cell.c"
}

gint
sudoku_cell_get_value (SudokuCell* self)
{
	gint result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
#line 48 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 48 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 48 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_->board;
#line 48 "../src/sudoku-cell.vala"
	result = sudoku_board_get (_tmp1_, self->priv->row, self->priv->col);
#line 48 "../src/sudoku-cell.vala"
	return result;
#line 2840 "sudoku-cell.c"
}

void
sudoku_cell_set_value (SudokuCell* self,
                       gint value)
{
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuGame* _tmp9_;
	SudokuBoard* _tmp10_;
	GtkLabel* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	SudokuGame* _tmp14_;
#line 49 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/sudoku-cell.vala"
	if (value != 0) {
#line 2859 "sudoku-cell.c"
		GtkLabel* _tmp0_;
#line 51 "../src/sudoku-cell.vala"
		_tmp0_ = self->priv->value_label;
#line 51 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, TRUE);
#line 2865 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp1_;
#line 53 "../src/sudoku-cell.vala"
		_tmp1_ = self->priv->value_label;
#line 53 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
#line 2872 "sudoku-cell.c"
	}
#line 55 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_is_fixed (self);
#line 55 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 55 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 2880 "sudoku-cell.c"
		SudokuGame* _tmp4_;
#line 57 "../src/sudoku-cell.vala"
		_tmp4_ = self->priv->game;
#line 57 "../src/sudoku-cell.vala"
		if (_tmp4_->mode == GAME_MODE_PLAY) {
#line 58 "../src/sudoku-cell.vala"
			return;
#line 2888 "sudoku-cell.c"
		}
	}
#line 61 "../src/sudoku-cell.vala"
	if (value == 0) {
#line 2893 "sudoku-cell.c"
		SudokuGame* _tmp5_;
		SudokuBoard* _tmp6_;
		SudokuGame* _tmp8_;
#line 63 "../src/sudoku-cell.vala"
		_tmp5_ = self->priv->game;
#line 63 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_->board;
#line 63 "../src/sudoku-cell.vala"
		if (sudoku_board_get (_tmp6_, self->priv->row, self->priv->col) != 0) {
#line 2903 "sudoku-cell.c"
			SudokuGame* _tmp7_;
#line 64 "../src/sudoku-cell.vala"
			_tmp7_ = self->priv->game;
#line 64 "../src/sudoku-cell.vala"
			sudoku_game_remove (_tmp7_, self->priv->row, self->priv->col);
#line 2909 "sudoku-cell.c"
		}
#line 65 "../src/sudoku-cell.vala"
		_tmp8_ = self->priv->game;
#line 65 "../src/sudoku-cell.vala"
		if (_tmp8_->mode == GAME_MODE_PLAY) {
#line 66 "../src/sudoku-cell.vala"
			return;
#line 2917 "sudoku-cell.c"
		}
	}
#line 69 "../src/sudoku-cell.vala"
	_tmp9_ = self->priv->game;
#line 69 "../src/sudoku-cell.vala"
	_tmp10_ = _tmp9_->board;
#line 69 "../src/sudoku-cell.vala"
	if (value == sudoku_board_get (_tmp10_, self->priv->row, self->priv->col)) {
#line 70 "../src/sudoku-cell.vala"
		return;
#line 2928 "sudoku-cell.c"
	}
#line 72 "../src/sudoku-cell.vala"
	_tmp11_ = self->priv->value_label;
#line 72 "../src/sudoku-cell.vala"
	_tmp12_ = g_strdup_printf ("%i", value);
#line 72 "../src/sudoku-cell.vala"
	_tmp13_ = _tmp12_;
#line 72 "../src/sudoku-cell.vala"
	gtk_label_set_label (_tmp11_, _tmp13_);
#line 72 "../src/sudoku-cell.vala"
	_g_free0 (_tmp13_);
#line 74 "../src/sudoku-cell.vala"
	_tmp14_ = self->priv->game;
#line 74 "../src/sudoku-cell.vala"
	sudoku_game_insert (_tmp14_, self->priv->row, self->priv->col, value);
#line 49 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY]);
#line 2946 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_is_fixed (SudokuCell* self)
{
	gboolean result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gboolean* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gboolean _tmp3_;
#line 80 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 80 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 80 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_->board;
#line 80 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_->is_fixed;
#line 80 "../src/sudoku-cell.vala"
	_tmp2__length1 = _tmp1_->is_fixed_length1;
#line 80 "../src/sudoku-cell.vala"
	_tmp2__length2 = _tmp1_->is_fixed_length2;
#line 80 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_[(self->priv->row * _tmp2__length2) + self->priv->col];
#line 80 "../src/sudoku-cell.vala"
	result = _tmp3_;
#line 80 "../src/sudoku-cell.vala"
	return result;
#line 2977 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_selected (SudokuCell* self)
{
	gboolean result;
#line 85 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 85 "../src/sudoku-cell.vala"
	result = self->priv->_selected;
#line 85 "../src/sudoku-cell.vala"
	return result;
#line 2990 "sudoku-cell.c"
}

void
sudoku_cell_set_selected (SudokuCell* self,
                          gboolean value)
{
#line 86 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/sudoku-cell.vala"
	self->priv->_selected = value;
#line 89 "../src/sudoku-cell.vala"
	if (value) {
#line 90 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "selected");
#line 3005 "sudoku-cell.c"
	} else {
#line 92 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "selected");
#line 3009 "sudoku-cell.c"
	}
#line 86 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY]);
#line 3013 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_highlighted_background (SudokuCell* self)
{
	gboolean result;
#line 98 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 98 "../src/sudoku-cell.vala"
	result = self->priv->_highlighted_background;
#line 98 "../src/sudoku-cell.vala"
	return result;
#line 3026 "sudoku-cell.c"
}

void
sudoku_cell_set_highlighted_background (SudokuCell* self,
                                        gboolean value)
{
#line 99 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/sudoku-cell.vala"
	self->priv->_highlighted_background = value;
#line 102 "../src/sudoku-cell.vala"
	if (value) {
#line 103 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-bg");
#line 3041 "sudoku-cell.c"
	} else {
#line 105 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-bg");
#line 3045 "sudoku-cell.c"
	}
#line 99 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY]);
#line 3049 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_highlighted_value (SudokuCell* self)
{
	gboolean result;
#line 111 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 111 "../src/sudoku-cell.vala"
	result = self->priv->_highlighted_value;
#line 111 "../src/sudoku-cell.vala"
	return result;
#line 3062 "sudoku-cell.c"
}

void
sudoku_cell_set_highlighted_value (SudokuCell* self,
                                   gboolean value)
{
	gboolean _tmp0_ = FALSE;
#line 112 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/sudoku-cell.vala"
	self->priv->_highlighted_value = value;
#line 115 "../src/sudoku-cell.vala"
	if (value) {
#line 115 "../src/sudoku-cell.vala"
		_tmp0_ = !gtk_widget_has_css_class ((GtkWidget*) self, "error");
#line 3078 "sudoku-cell.c"
	} else {
#line 115 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 3082 "sudoku-cell.c"
	}
#line 115 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 116 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-label");
#line 3088 "sudoku-cell.c"
	} else {
#line 118 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-label");
#line 3092 "sudoku-cell.c"
	}
#line 112 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY]);
#line 3096 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_show_warnings (SudokuCell* self)
{
	gboolean result;
#line 125 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 125 "../src/sudoku-cell.vala"
	result = self->priv->_show_warnings;
#line 125 "../src/sudoku-cell.vala"
	return result;
#line 3109 "sudoku-cell.c"
}

void
sudoku_cell_set_show_warnings (SudokuCell* self,
                               gboolean value)
{
#line 126 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/sudoku-cell.vala"
	self->priv->_show_warnings = value;
#line 129 "../src/sudoku-cell.vala"
	sudoku_cell_check_warnings (self);
#line 126 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SHOW_WARNINGS_PROPERTY]);
#line 3124 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_show_extra_warnings (SudokuCell* self)
{
	gboolean result;
#line 136 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 136 "../src/sudoku-cell.vala"
	result = self->priv->_show_extra_warnings;
#line 136 "../src/sudoku-cell.vala"
	return result;
#line 3137 "sudoku-cell.c"
}

void
sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                     gboolean value)
{
#line 137 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/sudoku-cell.vala"
	self->priv->_show_extra_warnings = value;
#line 140 "../src/sudoku-cell.vala"
	sudoku_cell_check_warnings (self);
#line 137 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY]);
#line 3152 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_initialize_earmarks (SudokuCell* self)
{
	gboolean result;
#line 151 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 151 "../src/sudoku-cell.vala"
	result = self->priv->_initialize_earmarks;
#line 151 "../src/sudoku-cell.vala"
	return result;
#line 3165 "sudoku-cell.c"
}

void
sudoku_cell_set_initialize_earmarks (SudokuCell* self,
                                     gboolean value)
{
#line 152 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/sudoku-cell.vala"
	self->priv->_initialize_earmarks = value;
#line 155 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmarks (self);
#line 152 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY]);
#line 3180 "sudoku-cell.c"
}

static void
sudoku_cell_class_init (SudokuCellClass * klass,
                        gpointer klass_data)
{
#line 24 "../src/sudoku-cell.vala"
	sudoku_cell_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/sudoku-cell.vala"
	g_type_class_adjust_private_offset (klass, &SudokuCell_private_offset);
#line 24 "../src/sudoku-cell.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_cell_real_dispose;
#line 24 "../src/sudoku-cell.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_cell_real_size_allocate;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_cell_get_property;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_cell_set_property;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_cell_finalize;
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_IS_FIXED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_IS_FIXED_PROPERTY] = g_param_spec_boolean ("is-fixed", "is-fixed", "is-fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SELECTED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY] = g_param_spec_boolean ("highlighted-background", "highlighted-background", "highlighted-background", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY] = g_param_spec_boolean ("highlighted-value", "highlighted-value", "highlighted-value", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SHOW_WARNINGS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-extra-warnings", "show-extra-warnings", "show-extra-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY] = g_param_spec_boolean ("initialize-earmarks", "initialize-earmarks", "initialize-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 225 "../src/sudoku-cell.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "sudokucell");
#line 3219 "sudoku-cell.c"
}

static void
sudoku_cell_instance_init (SudokuCell * self,
                           gpointer klass)
{
	GtkGestureClick* _tmp0_;
	GtkGestureLongPress* _tmp1_;
	GtkEventControllerKey* _tmp2_;
	GtkPopover* _tmp3_;
	GtkLabel* _tmp4_ = NULL;
	GtkLabel** _tmp5_;
#line 24 "../src/sudoku-cell.vala"
	self->priv = sudoku_cell_get_instance_private (self);
#line 33 "../src/sudoku-cell.vala"
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 33 "../src/sudoku-cell.vala"
	self->priv->button_controller = _tmp0_;
#line 34 "../src/sudoku-cell.vala"
	_tmp1_ = (GtkGestureLongPress*) gtk_gesture_long_press_new ();
#line 34 "../src/sudoku-cell.vala"
	self->priv->long_press_controller = _tmp1_;
#line 35 "../src/sudoku-cell.vala"
	_tmp2_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 35 "../src/sudoku-cell.vala"
	self->priv->key_controller = _tmp2_;
#line 37 "../src/sudoku-cell.vala"
	_tmp3_ = (GtkPopover*) gtk_popover_new ();
#line 37 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp3_);
#line 37 "../src/sudoku-cell.vala"
	self->popover = _tmp3_;
#line 41 "../src/sudoku-cell.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new ("");
#line 41 "../src/sudoku-cell.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
#line 41 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp4_);
#line 41 "../src/sudoku-cell.vala"
	self->priv->value_label = _tmp4_;
#line 44 "../src/sudoku-cell.vala"
	_tmp5_ = g_new0 (GtkLabel*, 8 + 1);
#line 44 "../src/sudoku-cell.vala"
	self->priv->earmark_labels = _tmp5_;
#line 44 "../src/sudoku-cell.vala"
	self->priv->earmark_labels_length1 = 8;
#line 44 "../src/sudoku-cell.vala"
	self->priv->_earmark_labels_size_ = self->priv->earmark_labels_length1;
#line 83 "../src/sudoku-cell.vala"
	self->priv->_selected = FALSE;
#line 96 "../src/sudoku-cell.vala"
	self->priv->_highlighted_background = FALSE;
#line 109 "../src/sudoku-cell.vala"
	self->priv->_highlighted_value = FALSE;
#line 122 "../src/sudoku-cell.vala"
	self->priv->_show_warnings = TRUE;
#line 133 "../src/sudoku-cell.vala"
	self->priv->_show_extra_warnings = FALSE;
#line 3278 "sudoku-cell.c"
}

static void
sudoku_cell_finalize (GObject * obj)
{
	SudokuCell * self;
#line 24 "../src/sudoku-cell.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_CELL, SudokuCell);
#line 30 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->game);
#line 33 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 34 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->long_press_controller);
#line 35 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 37 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->popover);
#line 41 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->value_label);
#line 44 "../src/sudoku-cell.vala"
	self->priv->earmark_labels = (_vala_array_free (self->priv->earmark_labels, self->priv->earmark_labels_length1, (GDestroyNotify) g_object_unref), NULL);
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->finalize (obj);
#line 3303 "sudoku-cell.c"
}

static GType
sudoku_cell_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuCellClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_cell_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuCell), 0, (GInstanceInitFunc) sudoku_cell_instance_init, NULL };
	GType sudoku_cell_type_id;
	sudoku_cell_type_id = g_type_register_static (gtk_widget_get_type (), "SudokuCell", &g_define_type_info, 0);
	SudokuCell_private_offset = g_type_add_instance_private (sudoku_cell_type_id, sizeof (SudokuCellPrivate));
	return sudoku_cell_type_id;
}

GType
sudoku_cell_get_type (void)
{
	static volatile gsize sudoku_cell_type_id__once = 0;
	if (g_once_init_enter (&sudoku_cell_type_id__once)) {
		GType sudoku_cell_type_id;
		sudoku_cell_type_id = sudoku_cell_get_type_once ();
		g_once_init_leave (&sudoku_cell_type_id__once, sudoku_cell_type_id);
	}
	return sudoku_cell_type_id__once;
}

static void
_vala_sudoku_cell_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/sudoku-cell.vala"
	switch (property_id) {
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_int (value, sudoku_cell_get_value (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_IS_FIXED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_is_fixed (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_selected (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlighted_background (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlighted_value (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_show_warnings (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_show_extra_warnings (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_initialize_earmarks (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3386 "sudoku-cell.c"
		default:
#line 24 "../src/sudoku-cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3392 "sudoku-cell.c"
	}
}

static void
_vala_sudoku_cell_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/sudoku-cell.vala"
	switch (property_id) {
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, g_value_get_int (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_selected (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_highlighted_background (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_highlighted_value (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_show_warnings (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_show_extra_warnings (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_initialize_earmarks (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3448 "sudoku-cell.c"
		default:
#line 24 "../src/sudoku-cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3454 "sudoku-cell.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

