/* sudoku-view.c generated by valac 0.56.14, the Vala compiler
 * generated from sudoku-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include "libsudoku.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <pango/pango.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block11Data Block11Data;

#define TYPE_SUDOKU_FRAME (sudoku_frame_get_type ())
#define SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_FRAME, SudokuFrame))
#define SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_FRAME, SudokuFrameClass))
#define IS_SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_FRAME))
#define IS_SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_FRAME))
#define SUDOKU_FRAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_FRAME, SudokuFrameClass))

typedef struct _SudokuFrame SudokuFrame;
typedef struct _SudokuFrameClass SudokuFrameClass;
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
typedef struct _Block12Data Block12Data;
typedef struct _SudokuCellPrivate SudokuCellPrivate;

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
	SudokuGame* game;
	gint selected_row;
	gint selected_col;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

struct _SudokuViewPrivate {
	SudokuCell** cells;
	gint cells_length1;
	gint cells_length2;
	GtkLabel* paused;
	gboolean previous_board_broken_state;
	GtkOverlay* overlay;
	GtkGrid* grid;
	gboolean _show_warnings;
	gboolean _show_extra_warnings;
	gboolean _show_possibilities;
	gboolean _initialize_earmarks;
	gboolean _highlighter;
};

struct _Block11Data {
	int _ref_count_;
	SudokuView* self;
	SudokuGame* game;
};

struct _Block12Data {
	int _ref_count_;
	Block11Data * _data11_;
	SudokuCell* cell;
	gint cell_row;
	gint cell_col;
};

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
	GtkPopover* popover;
	gboolean show_possibilities;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
static void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
VALA_EXTERN SudokuView* sudoku_view_new (gint frame_size,
                             SudokuGame* game);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   gint frame_size,
                                   SudokuGame* game);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
VALA_EXTERN GType sudoku_frame_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuFrame, g_object_unref)
VALA_EXTERN SudokuFrame* sudoku_frame_new (GtkWidget* child);
VALA_EXTERN SudokuFrame* sudoku_frame_construct (GType object_type,
                                     GtkWidget* child);
static void __lambda10_ (SudokuView* self);
static void ___lambda10__sudoku_game_paused_changed (SudokuGame* _sender,
                                              gpointer self);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame** game);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame** game);
static void ________lambda11_ (Block12Data* _data12_);
static void sudoku_view_update_highlights (SudokuView* self);
static void _________lambda11__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
static void ________lambda12_ (Block12Data* _data12_,
                        GObject* s,
                        GParamSpec* p);
static void _________lambda12__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_check_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
static void sudoku_view_clear_highlights (SudokuView* self);
VALA_EXTERN void sudoku_view_clear (SudokuView* self);
VALA_EXTERN void sudoku_view_redraw (SudokuView* self);
VALA_EXTERN gboolean sudoku_view_get_show_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
VALA_EXTERN void sudoku_cell_set_show_warnings (SudokuCell* self,
                                    gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_extra_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_extra_warnings (SudokuView* self,
                                          gboolean value);
VALA_EXTERN void sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_possibilities (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
VALA_EXTERN gboolean sudoku_view_get_initialize_earmarks (SudokuView* self);
VALA_EXTERN void sudoku_view_set_initialize_earmarks (SudokuView* self,
                                          gboolean value);
VALA_EXTERN void sudoku_cell_set_initialize_earmarks (SudokuCell* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_view_get_highlighter (SudokuView* self);
VALA_EXTERN void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
static gboolean _sudoku_view___lambda13_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda13__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda14_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda14__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda15_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda15__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda16_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda16__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static void sudoku_view_finalize (GObject * obj);
static GType sudoku_view_get_type_once (void);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}

static void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 39 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/sudoku-view.vala"
	if (self->selected_row >= 0) {
#line 41 "../src/sudoku-view.vala"
		_tmp0_ = self->selected_col >= 0;
#line 272 "sudoku-view.c"
	} else {
#line 41 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 276 "sudoku-view.c"
	}
#line 41 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 280 "sudoku-view.c"
		SudokuCell** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCell* _tmp2_;
#line 43 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->cells;
#line 43 "../src/sudoku-view.vala"
		_tmp1__length1 = self->priv->cells_length1;
#line 43 "../src/sudoku-view.vala"
		_tmp1__length2 = self->priv->cells_length2;
#line 43 "../src/sudoku-view.vala"
		_tmp2_ = _tmp1_[(self->selected_row * _tmp1__length2) + self->selected_col];
#line 43 "../src/sudoku-view.vala"
		sudoku_cell_set_selected (_tmp2_, FALSE);
#line 295 "sudoku-view.c"
	}
#line 45 "../src/sudoku-view.vala"
	self->selected_row = cell_row;
#line 46 "../src/sudoku-view.vala"
	self->selected_col = cell_col;
#line 47 "../src/sudoku-view.vala"
	if (self->selected_row >= 0) {
#line 47 "../src/sudoku-view.vala"
		_tmp3_ = self->selected_col >= 0;
#line 305 "sudoku-view.c"
	} else {
#line 47 "../src/sudoku-view.vala"
		_tmp3_ = FALSE;
#line 309 "sudoku-view.c"
	}
#line 47 "../src/sudoku-view.vala"
	if (_tmp3_) {
#line 313 "sudoku-view.c"
		SudokuCell** _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		SudokuCell* _tmp5_;
#line 49 "../src/sudoku-view.vala"
		_tmp4_ = self->priv->cells;
#line 49 "../src/sudoku-view.vala"
		_tmp4__length1 = self->priv->cells_length1;
#line 49 "../src/sudoku-view.vala"
		_tmp4__length2 = self->priv->cells_length2;
#line 49 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_[(self->selected_row * _tmp4__length2) + self->selected_col];
#line 49 "../src/sudoku-view.vala"
		sudoku_cell_set_selected (_tmp5_, TRUE);
#line 328 "sudoku-view.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 53 "../src/sudoku-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 337 "sudoku-view.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 53 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 53 "../src/sudoku-view.vala"
	return _data11_;
#line 347 "sudoku-view.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 53 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 357 "sudoku-view.c"
		SudokuView* self;
#line 53 "../src/sudoku-view.vala"
		self = _data11_->self;
#line 53 "../src/sudoku-view.vala"
		_g_object_unref0 (_data11_->game);
#line 53 "../src/sudoku-view.vala"
		_g_object_unref0 (self);
#line 53 "../src/sudoku-view.vala"
		g_slice_free (Block11Data, _data11_);
#line 367 "sudoku-view.c"
	}
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 73 "../src/sudoku-view.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 376 "sudoku-view.c"
}

static void
__lambda10_ (SudokuView* self)
{
	PangoAttrList* attr_list = NULL;
	GtkLabel* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp3_;
	PangoAttrList* _tmp5_;
	PangoAttribute* _tmp6_;
	GtkLabel* _tmp7_;
	PangoAttrList* _tmp8_;
	SudokuGame* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
#line 73 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->paused;
#line 73 "../src/sudoku-view.vala"
	_tmp1_ = gtk_label_get_attributes (_tmp0_);
#line 73 "../src/sudoku-view.vala"
	_tmp2_ = _pango_attr_list_ref0 (_tmp1_);
#line 73 "../src/sudoku-view.vala"
	attr_list = _tmp2_;
#line 74 "../src/sudoku-view.vala"
	_tmp3_ = attr_list;
#line 74 "../src/sudoku-view.vala"
	if (_tmp3_ == NULL) {
#line 406 "sudoku-view.c"
		PangoAttrList* _tmp4_;
#line 75 "../src/sudoku-view.vala"
		_tmp4_ = pango_attr_list_new ();
#line 75 "../src/sudoku-view.vala"
		_pango_attr_list_unref0 (attr_list);
#line 75 "../src/sudoku-view.vala"
		attr_list = _tmp4_;
#line 414 "sudoku-view.c"
	}
#line 77 "../src/sudoku-view.vala"
	_tmp5_ = attr_list;
#line 77 "../src/sudoku-view.vala"
	_tmp6_ = pango_attr_size_new_absolute (((gint) (gtk_widget_get_width ((GtkWidget*) self) * 0.125)) * PANGO_SCALE);
#line 77 "../src/sudoku-view.vala"
	pango_attr_list_change (_tmp5_, _tmp6_);
#line 81 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->paused;
#line 81 "../src/sudoku-view.vala"
	_tmp8_ = attr_list;
#line 81 "../src/sudoku-view.vala"
	gtk_label_set_attributes (_tmp7_, _tmp8_);
#line 83 "../src/sudoku-view.vala"
	_tmp9_ = self->game;
#line 83 "../src/sudoku-view.vala"
	_tmp10_ = sudoku_game_get_paused (_tmp9_);
#line 83 "../src/sudoku-view.vala"
	_tmp11_ = _tmp10_;
#line 83 "../src/sudoku-view.vala"
	if (_tmp11_) {
#line 436 "sudoku-view.c"
		GtkLabel* _tmp12_;
#line 84 "../src/sudoku-view.vala"
		_tmp12_ = self->priv->paused;
#line 84 "../src/sudoku-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp12_, TRUE);
#line 442 "sudoku-view.c"
	} else {
		GtkLabel* _tmp13_;
#line 86 "../src/sudoku-view.vala"
		_tmp13_ = self->priv->paused;
#line 86 "../src/sudoku-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
#line 449 "sudoku-view.c"
	}
#line 71 "../src/sudoku-view.vala"
	_pango_attr_list_unref0 (attr_list);
#line 453 "sudoku-view.c"
}

static void
___lambda10__sudoku_game_paused_changed (SudokuGame* _sender,
                                         gpointer self)
{
#line 71 "../src/sudoku-view.vala"
	__lambda10_ ((SudokuView*) self);
#line 462 "sudoku-view.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 119 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 119 "../src/sudoku-view.vala"
	return _data12_;
#line 472 "sudoku-view.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 119 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 482 "sudoku-view.c"
		SudokuView* self;
#line 119 "../src/sudoku-view.vala"
		self = _data12_->_data11_->self;
#line 119 "../src/sudoku-view.vala"
		_g_object_unref0 (_data12_->cell);
#line 119 "../src/sudoku-view.vala"
		block11_data_unref (_data12_->_data11_);
#line 119 "../src/sudoku-view.vala"
		_data12_->_data11_ = NULL;
#line 119 "../src/sudoku-view.vala"
		g_slice_free (Block12Data, _data12_);
#line 494 "sudoku-view.c"
	}
}

static void
________lambda11_ (Block12Data* _data12_)
{
	Block11Data* _data11_;
	SudokuView* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	SudokuCell* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 125 "../src/sudoku-view.vala"
	_data11_ = _data12_->_data11_;
#line 125 "../src/sudoku-view.vala"
	self = _data11_->self;
#line 126 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_game_get_paused (_data11_->game);
#line 126 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 126 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 127 "../src/sudoku-view.vala"
		return;
#line 521 "sudoku-view.c"
	}
#line 131 "../src/sudoku-view.vala"
	_tmp3_ = _data12_->cell;
#line 131 "../src/sudoku-view.vala"
	g_object_get ((GtkWidget*) _tmp3_, "has-focus", &_tmp4_, NULL);
#line 131 "../src/sudoku-view.vala"
	_tmp5_ = _tmp4_;
#line 131 "../src/sudoku-view.vala"
	if (_tmp5_) {
#line 131 "../src/sudoku-view.vala"
		_tmp2_ = TRUE;
#line 533 "sudoku-view.c"
	} else {
		SudokuCell* _tmp6_;
		GtkPopover* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 131 "../src/sudoku-view.vala"
		_tmp6_ = _data12_->cell;
#line 131 "../src/sudoku-view.vala"
		_tmp7_ = _tmp6_->popover;
#line 131 "../src/sudoku-view.vala"
		_tmp8_ = gtk_widget_get_visible ((GtkWidget*) _tmp7_);
#line 131 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_;
#line 131 "../src/sudoku-view.vala"
		_tmp2_ = _tmp9_;
#line 549 "sudoku-view.c"
	}
#line 131 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 132 "../src/sudoku-view.vala"
		sudoku_view_set_selected (self, _data12_->cell_row, _data12_->cell_col);
#line 555 "sudoku-view.c"
	} else {
#line 134 "../src/sudoku-view.vala"
		sudoku_view_set_selected (self, -1, -1);
#line 559 "sudoku-view.c"
	}
#line 136 "../src/sudoku-view.vala"
	sudoku_view_update_highlights (self);
#line 563 "sudoku-view.c"
}

static void
_________lambda11__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
#line 125 "../src/sudoku-view.vala"
	________lambda11_ (self);
#line 573 "sudoku-view.c"
}

static void
________lambda12_ (Block12Data* _data12_,
                   GObject* s,
                   GParamSpec* p)
{
	Block11Data* _data11_;
	SudokuView* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 139 "../src/sudoku-view.vala"
	_data11_ = _data12_->_data11_;
#line 139 "../src/sudoku-view.vala"
	self = _data11_->self;
#line 139 "../src/sudoku-view.vala"
	g_return_if_fail (s != NULL);
#line 139 "../src/sudoku-view.vala"
	g_return_if_fail (p != NULL);
#line 140 "../src/sudoku-view.vala"
	if (self->priv->_show_possibilities) {
#line 140 "../src/sudoku-view.vala"
		_tmp2_ = TRUE;
#line 598 "sudoku-view.c"
	} else {
#line 140 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->_show_warnings;
#line 602 "sudoku-view.c"
	}
#line 140 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 140 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 608 "sudoku-view.c"
	} else {
		SudokuBoard* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 140 "../src/sudoku-view.vala"
		_tmp3_ = _data11_->game->board;
#line 140 "../src/sudoku-view.vala"
		_tmp4_ = sudoku_board_get_broken (_tmp3_);
#line 140 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_;
#line 140 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_;
#line 621 "sudoku-view.c"
	}
#line 140 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 140 "../src/sudoku-view.vala"
		_tmp0_ = TRUE;
#line 627 "sudoku-view.c"
	} else {
#line 140 "../src/sudoku-view.vala"
		_tmp0_ = self->priv->previous_board_broken_state;
#line 631 "sudoku-view.c"
	}
#line 140 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 635 "sudoku-view.c"
		SudokuBoard* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 141 "../src/sudoku-view.vala"
		_tmp6_ = _data11_->game->board;
#line 141 "../src/sudoku-view.vala"
		_tmp7_ = sudoku_board_get_broken (_tmp6_);
#line 141 "../src/sudoku-view.vala"
		_tmp8_ = _tmp7_;
#line 141 "../src/sudoku-view.vala"
		self->priv->previous_board_broken_state = _tmp8_;
#line 647 "sudoku-view.c"
	}
#line 143 "../src/sudoku-view.vala"
	sudoku_view_update_highlights (self);
#line 651 "sudoku-view.c"
}

static void
_________lambda12__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
#line 139 "../src/sudoku-view.vala"
	________lambda12_ (self, _sender, pspec);
#line 661 "sudoku-view.c"
}

SudokuView*
sudoku_view_construct (GType object_type,
                       gint frame_size,
                       SudokuGame* game)
{
	SudokuView * self = NULL;
	Block11Data* _data11_;
	SudokuGame* _tmp0_;
	GtkOverlay* _tmp1_;
	SudokuFrame* frame = NULL;
	GtkOverlay* _tmp2_;
	SudokuFrame* _tmp3_;
	SudokuFrame* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkGrid* _tmp7_;
	SudokuGame* _tmp9_;
	SudokuGame* _tmp10_;
	GtkGrid* _tmp11_ = NULL;
	GtkGrid* _tmp12_;
	GtkGrid** blocks = NULL;
	SudokuBoard* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	SudokuBoard* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	GtkGrid** _tmp19_;
	gint blocks_length1;
	gint blocks_length2;
	SudokuBoard* _tmp41_;
	gint _tmp42_;
	gint _tmp43_;
	SudokuBoard* _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	SudokuCell** _tmp47_;
	GtkOverlay* _tmp79_;
	GtkLabel* _tmp80_;
	GtkOverlay* _tmp81_;
	GtkGrid* _tmp82_;
	GtkGrid* _tmp83_;
	GtkOverlay* _tmp84_;
	GtkLabel* _tmp85_;
#line 53 "../src/sudoku-view.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 53 "../src/sudoku-view.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 53 "../src/sudoku-view.vala"
	_data11_->_ref_count_ = 1;
#line 53 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 53 "../src/sudoku-view.vala"
	_g_object_unref0 (_data11_->game);
#line 53 "../src/sudoku-view.vala"
	_data11_->game = _tmp0_;
#line 53 "../src/sudoku-view.vala"
	self = (SudokuView*) g_object_new (object_type, NULL);
#line 53 "../src/sudoku-view.vala"
	_data11_->self = g_object_ref (self);
#line 55 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 57 "../src/sudoku-view.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 58 "../src/sudoku-view.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 60 "../src/sudoku-view.vala"
	_tmp1_ = (GtkOverlay*) gtk_overlay_new ();
#line 60 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp1_);
#line 60 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 60 "../src/sudoku-view.vala"
	self->priv->overlay = _tmp1_;
#line 61 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->overlay;
#line 61 "../src/sudoku-view.vala"
	_tmp3_ = sudoku_frame_new ((GtkWidget*) _tmp2_);
#line 61 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp3_);
#line 61 "../src/sudoku-view.vala"
	frame = _tmp3_;
#line 62 "../src/sudoku-view.vala"
	_tmp4_ = frame;
#line 62 "../src/sudoku-view.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp4_);
#line 64 "../src/sudoku-view.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new ("Paused");
#line 64 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp5_);
#line 64 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused);
#line 64 "../src/sudoku-view.vala"
	self->priv->paused = _tmp5_;
#line 65 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->paused;
#line 65 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp6_, "paused");
#line 67 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->grid;
#line 67 "../src/sudoku-view.vala"
	if (_tmp7_ != NULL) {
#line 766 "sudoku-view.c"
		GtkOverlay* _tmp8_;
#line 68 "../src/sudoku-view.vala"
		_tmp8_ = self->priv->overlay;
#line 68 "../src/sudoku-view.vala"
		gtk_overlay_set_child (_tmp8_, NULL);
#line 772 "sudoku-view.c"
	}
#line 70 "../src/sudoku-view.vala"
	_tmp9_ = _g_object_ref0 (_data11_->game);
#line 70 "../src/sudoku-view.vala"
	_g_object_unref0 (self->game);
#line 70 "../src/sudoku-view.vala"
	self->game = _tmp9_;
#line 71 "../src/sudoku-view.vala"
	_tmp10_ = self->game;
#line 71 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp10_, "paused-changed", (GCallback) ___lambda10__sudoku_game_paused_changed, self, 0);
#line 89 "../src/sudoku-view.vala"
	_tmp11_ = (GtkGrid*) gtk_grid_new ();
#line 89 "../src/sudoku-view.vala"
	gtk_grid_set_row_spacing (_tmp11_, 2);
#line 89 "../src/sudoku-view.vala"
	gtk_grid_set_column_spacing (_tmp11_, 2);
#line 89 "../src/sudoku-view.vala"
	gtk_grid_set_column_homogeneous (_tmp11_, TRUE);
#line 89 "../src/sudoku-view.vala"
	gtk_grid_set_row_homogeneous (_tmp11_, TRUE);
#line 89 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp11_, TRUE);
#line 89 "../src/sudoku-view.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp11_, TRUE);
#line 89 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp11_);
#line 89 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 89 "../src/sudoku-view.vala"
	self->priv->grid = _tmp11_;
#line 97 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->grid;
#line 97 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp12_, "board");
#line 99 "../src/sudoku-view.vala"
	_tmp13_ = _data11_->game->board;
#line 99 "../src/sudoku-view.vala"
	_tmp14_ = sudoku_board_get_block_rows (_tmp13_);
#line 99 "../src/sudoku-view.vala"
	_tmp15_ = _tmp14_;
#line 99 "../src/sudoku-view.vala"
	_tmp16_ = _data11_->game->board;
#line 99 "../src/sudoku-view.vala"
	_tmp17_ = sudoku_board_get_block_cols (_tmp16_);
#line 99 "../src/sudoku-view.vala"
	_tmp18_ = _tmp17_;
#line 99 "../src/sudoku-view.vala"
	_tmp19_ = g_new0 (GtkGrid*, (_tmp15_ * _tmp18_) + 1);
#line 99 "../src/sudoku-view.vala"
	blocks = _tmp19_;
#line 99 "../src/sudoku-view.vala"
	blocks_length1 = _tmp15_;
#line 99 "../src/sudoku-view.vala"
	blocks_length2 = _tmp18_;
#line 828 "sudoku-view.c"
	{
		gint block_row = 0;
#line 100 "../src/sudoku-view.vala"
		block_row = 0;
#line 833 "sudoku-view.c"
		{
			gboolean _tmp20_ = FALSE;
#line 100 "../src/sudoku-view.vala"
			_tmp20_ = TRUE;
#line 100 "../src/sudoku-view.vala"
			while (TRUE) {
#line 840 "sudoku-view.c"
				SudokuBoard* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
#line 100 "../src/sudoku-view.vala"
				if (!_tmp20_) {
#line 846 "sudoku-view.c"
					gint _tmp21_;
#line 100 "../src/sudoku-view.vala"
					_tmp21_ = block_row;
#line 100 "../src/sudoku-view.vala"
					block_row = _tmp21_ + 1;
#line 852 "sudoku-view.c"
				}
#line 100 "../src/sudoku-view.vala"
				_tmp20_ = FALSE;
#line 100 "../src/sudoku-view.vala"
				_tmp22_ = _data11_->game->board;
#line 100 "../src/sudoku-view.vala"
				_tmp23_ = sudoku_board_get_block_rows (_tmp22_);
#line 100 "../src/sudoku-view.vala"
				_tmp24_ = _tmp23_;
#line 100 "../src/sudoku-view.vala"
				if (!(block_row < _tmp24_)) {
#line 100 "../src/sudoku-view.vala"
					break;
#line 866 "sudoku-view.c"
				}
				{
					gint block_col = 0;
#line 102 "../src/sudoku-view.vala"
					block_col = 0;
#line 872 "sudoku-view.c"
					{
						gboolean _tmp25_ = FALSE;
#line 102 "../src/sudoku-view.vala"
						_tmp25_ = TRUE;
#line 102 "../src/sudoku-view.vala"
						while (TRUE) {
#line 879 "sudoku-view.c"
							SudokuBoard* _tmp27_;
							gint _tmp28_;
							gint _tmp29_;
							GtkGrid* block_grid = NULL;
							GtkGrid* _tmp30_;
							GtkGrid* _tmp31_;
							GtkGrid* _tmp32_;
							GtkGrid* _tmp33_;
							GtkGrid* _tmp34_;
							GtkGrid* _tmp35_;
							GtkGrid* _tmp36_;
							GtkGrid* _tmp37_;
							GtkGrid** _tmp38_;
							gint _tmp38__length1;
							gint _tmp38__length2;
							GtkGrid* _tmp39_;
							GtkGrid* _tmp40_;
#line 102 "../src/sudoku-view.vala"
							if (!_tmp25_) {
#line 899 "sudoku-view.c"
								gint _tmp26_;
#line 102 "../src/sudoku-view.vala"
								_tmp26_ = block_col;
#line 102 "../src/sudoku-view.vala"
								block_col = _tmp26_ + 1;
#line 905 "sudoku-view.c"
							}
#line 102 "../src/sudoku-view.vala"
							_tmp25_ = FALSE;
#line 102 "../src/sudoku-view.vala"
							_tmp27_ = _data11_->game->board;
#line 102 "../src/sudoku-view.vala"
							_tmp28_ = sudoku_board_get_block_cols (_tmp27_);
#line 102 "../src/sudoku-view.vala"
							_tmp29_ = _tmp28_;
#line 102 "../src/sudoku-view.vala"
							if (!(block_col < _tmp29_)) {
#line 102 "../src/sudoku-view.vala"
								break;
#line 919 "sudoku-view.c"
							}
#line 104 "../src/sudoku-view.vala"
							_tmp30_ = (GtkGrid*) gtk_grid_new ();
#line 104 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp30_);
#line 104 "../src/sudoku-view.vala"
							block_grid = _tmp30_;
#line 105 "../src/sudoku-view.vala"
							_tmp31_ = block_grid;
#line 105 "../src/sudoku-view.vala"
							gtk_grid_set_row_spacing (_tmp31_, 1);
#line 106 "../src/sudoku-view.vala"
							_tmp32_ = block_grid;
#line 106 "../src/sudoku-view.vala"
							gtk_grid_set_column_spacing (_tmp32_, 1);
#line 107 "../src/sudoku-view.vala"
							_tmp33_ = block_grid;
#line 107 "../src/sudoku-view.vala"
							gtk_grid_set_column_homogeneous (_tmp33_, TRUE);
#line 108 "../src/sudoku-view.vala"
							_tmp34_ = block_grid;
#line 108 "../src/sudoku-view.vala"
							gtk_grid_set_row_homogeneous (_tmp34_, TRUE);
#line 109 "../src/sudoku-view.vala"
							_tmp35_ = block_grid;
#line 109 "../src/sudoku-view.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp35_, "block");
#line 110 "../src/sudoku-view.vala"
							_tmp36_ = self->priv->grid;
#line 110 "../src/sudoku-view.vala"
							_tmp37_ = block_grid;
#line 110 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp36_, (GtkWidget*) _tmp37_, block_col, block_row, 1, 1);
#line 112 "../src/sudoku-view.vala"
							_tmp38_ = blocks;
#line 112 "../src/sudoku-view.vala"
							_tmp38__length1 = blocks_length1;
#line 112 "../src/sudoku-view.vala"
							_tmp38__length2 = blocks_length2;
#line 112 "../src/sudoku-view.vala"
							_tmp39_ = block_grid;
#line 112 "../src/sudoku-view.vala"
							_tmp40_ = _g_object_ref0 (_tmp39_);
#line 112 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp38_[(block_row * _tmp38__length2) + block_col]);
#line 112 "../src/sudoku-view.vala"
							_tmp38_[(block_row * _tmp38__length2) + block_col] = _tmp40_;
#line 102 "../src/sudoku-view.vala"
							_g_object_unref0 (block_grid);
#line 969 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 116 "../src/sudoku-view.vala"
	_tmp41_ = _data11_->game->board;
#line 116 "../src/sudoku-view.vala"
	_tmp42_ = sudoku_board_get_rows (_tmp41_);
#line 116 "../src/sudoku-view.vala"
	_tmp43_ = _tmp42_;
#line 116 "../src/sudoku-view.vala"
	_tmp44_ = _data11_->game->board;
#line 116 "../src/sudoku-view.vala"
	_tmp45_ = sudoku_board_get_cols (_tmp44_);
#line 116 "../src/sudoku-view.vala"
	_tmp46_ = _tmp45_;
#line 116 "../src/sudoku-view.vala"
	_tmp47_ = g_new0 (SudokuCell*, (_tmp43_ * _tmp46_) + 1);
#line 116 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 116 "../src/sudoku-view.vala"
	self->priv->cells = _tmp47_;
#line 116 "../src/sudoku-view.vala"
	self->priv->cells_length1 = _tmp43_;
#line 116 "../src/sudoku-view.vala"
	self->priv->cells_length2 = _tmp46_;
#line 998 "sudoku-view.c"
	{
		gint row = 0;
#line 117 "../src/sudoku-view.vala"
		row = 0;
#line 1003 "sudoku-view.c"
		{
			gboolean _tmp48_ = FALSE;
#line 117 "../src/sudoku-view.vala"
			_tmp48_ = TRUE;
#line 117 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1010 "sudoku-view.c"
				SudokuBoard* _tmp50_;
				gint _tmp51_;
				gint _tmp52_;
#line 117 "../src/sudoku-view.vala"
				if (!_tmp48_) {
#line 1016 "sudoku-view.c"
					gint _tmp49_;
#line 117 "../src/sudoku-view.vala"
					_tmp49_ = row;
#line 117 "../src/sudoku-view.vala"
					row = _tmp49_ + 1;
#line 1022 "sudoku-view.c"
				}
#line 117 "../src/sudoku-view.vala"
				_tmp48_ = FALSE;
#line 117 "../src/sudoku-view.vala"
				_tmp50_ = _data11_->game->board;
#line 117 "../src/sudoku-view.vala"
				_tmp51_ = sudoku_board_get_rows (_tmp50_);
#line 117 "../src/sudoku-view.vala"
				_tmp52_ = _tmp51_;
#line 117 "../src/sudoku-view.vala"
				if (!(row < _tmp52_)) {
#line 117 "../src/sudoku-view.vala"
					break;
#line 1036 "sudoku-view.c"
				}
				{
					gint col = 0;
#line 119 "../src/sudoku-view.vala"
					col = 0;
#line 1042 "sudoku-view.c"
					{
						gboolean _tmp53_ = FALSE;
#line 119 "../src/sudoku-view.vala"
						_tmp53_ = TRUE;
#line 119 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1049 "sudoku-view.c"
							Block12Data* _data12_;
							SudokuBoard* _tmp55_;
							gint _tmp56_;
							gint _tmp57_;
							SudokuCell* _tmp58_;
							SudokuCell* _tmp59_;
							SudokuCell* _tmp60_;
							SudokuCell** _tmp61_;
							gint _tmp61__length1;
							gint _tmp61__length2;
							SudokuCell* _tmp62_;
							SudokuCell* _tmp63_;
							GtkGrid** _tmp64_;
							gint _tmp64__length1;
							gint _tmp64__length2;
							SudokuBoard* _tmp65_;
							gint _tmp66_;
							gint _tmp67_;
							SudokuBoard* _tmp68_;
							gint _tmp69_;
							gint _tmp70_;
							GtkGrid* _tmp71_;
							SudokuCell* _tmp72_;
							SudokuBoard* _tmp73_;
							gint _tmp74_;
							gint _tmp75_;
							SudokuBoard* _tmp76_;
							gint _tmp77_;
							gint _tmp78_;
#line 119 "../src/sudoku-view.vala"
							_data12_ = g_slice_new0 (Block12Data);
#line 119 "../src/sudoku-view.vala"
							_data12_->_ref_count_ = 1;
#line 119 "../src/sudoku-view.vala"
							_data12_->_data11_ = block11_data_ref (_data11_);
#line 119 "../src/sudoku-view.vala"
							if (!_tmp53_) {
#line 1087 "sudoku-view.c"
								gint _tmp54_;
#line 119 "../src/sudoku-view.vala"
								_tmp54_ = col;
#line 119 "../src/sudoku-view.vala"
								col = _tmp54_ + 1;
#line 1093 "sudoku-view.c"
							}
#line 119 "../src/sudoku-view.vala"
							_tmp53_ = FALSE;
#line 119 "../src/sudoku-view.vala"
							_tmp55_ = _data11_->game->board;
#line 119 "../src/sudoku-view.vala"
							_tmp56_ = sudoku_board_get_cols (_tmp55_);
#line 119 "../src/sudoku-view.vala"
							_tmp57_ = _tmp56_;
#line 119 "../src/sudoku-view.vala"
							if (!(col < _tmp57_)) {
#line 119 "../src/sudoku-view.vala"
								block12_data_unref (_data12_);
#line 119 "../src/sudoku-view.vala"
								_data12_ = NULL;
#line 119 "../src/sudoku-view.vala"
								break;
#line 1111 "sudoku-view.c"
							}
#line 121 "../src/sudoku-view.vala"
							_tmp58_ = sudoku_cell_new (row, col, &self->game);
#line 121 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp58_);
#line 121 "../src/sudoku-view.vala"
							_data12_->cell = _tmp58_;
#line 122 "../src/sudoku-view.vala"
							_data12_->cell_row = row;
#line 123 "../src/sudoku-view.vala"
							_data12_->cell_col = col;
#line 125 "../src/sudoku-view.vala"
							_tmp59_ = _data12_->cell;
#line 125 "../src/sudoku-view.vala"
							g_signal_connect_data ((GObject*) _tmp59_, "notify::has-focus", (GCallback) _________lambda11__g_object_notify, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 139 "../src/sudoku-view.vala"
							_tmp60_ = _data12_->cell;
#line 139 "../src/sudoku-view.vala"
							g_signal_connect_data ((GObject*) _tmp60_, "notify::value", (GCallback) _________lambda12__g_object_notify, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 146 "../src/sudoku-view.vala"
							_tmp61_ = self->priv->cells;
#line 146 "../src/sudoku-view.vala"
							_tmp61__length1 = self->priv->cells_length1;
#line 146 "../src/sudoku-view.vala"
							_tmp61__length2 = self->priv->cells_length2;
#line 146 "../src/sudoku-view.vala"
							_tmp62_ = _data12_->cell;
#line 146 "../src/sudoku-view.vala"
							_tmp63_ = _g_object_ref0 (_tmp62_);
#line 146 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp61_[(row * _tmp61__length2) + col]);
#line 146 "../src/sudoku-view.vala"
							_tmp61_[(row * _tmp61__length2) + col] = _tmp63_;
#line 148 "../src/sudoku-view.vala"
							_tmp64_ = blocks;
#line 148 "../src/sudoku-view.vala"
							_tmp64__length1 = blocks_length1;
#line 148 "../src/sudoku-view.vala"
							_tmp64__length2 = blocks_length2;
#line 148 "../src/sudoku-view.vala"
							_tmp65_ = _data11_->game->board;
#line 148 "../src/sudoku-view.vala"
							_tmp66_ = sudoku_board_get_block_rows (_tmp65_);
#line 148 "../src/sudoku-view.vala"
							_tmp67_ = _tmp66_;
#line 148 "../src/sudoku-view.vala"
							_tmp68_ = _data11_->game->board;
#line 148 "../src/sudoku-view.vala"
							_tmp69_ = sudoku_board_get_block_cols (_tmp68_);
#line 148 "../src/sudoku-view.vala"
							_tmp70_ = _tmp69_;
#line 148 "../src/sudoku-view.vala"
							_tmp71_ = _tmp64_[((row / _tmp67_) * _tmp64__length2) + (col / _tmp70_)];
#line 148 "../src/sudoku-view.vala"
							_tmp72_ = _data12_->cell;
#line 148 "../src/sudoku-view.vala"
							_tmp73_ = _data11_->game->board;
#line 148 "../src/sudoku-view.vala"
							_tmp74_ = sudoku_board_get_block_cols (_tmp73_);
#line 148 "../src/sudoku-view.vala"
							_tmp75_ = _tmp74_;
#line 148 "../src/sudoku-view.vala"
							_tmp76_ = _data11_->game->board;
#line 148 "../src/sudoku-view.vala"
							_tmp77_ = sudoku_board_get_block_rows (_tmp76_);
#line 148 "../src/sudoku-view.vala"
							_tmp78_ = _tmp77_;
#line 148 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp71_, (GtkWidget*) _tmp72_, col % _tmp75_, row % _tmp78_, 1, 1);
#line 119 "../src/sudoku-view.vala"
							block12_data_unref (_data12_);
#line 119 "../src/sudoku-view.vala"
							_data12_ = NULL;
#line 1185 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 152 "../src/sudoku-view.vala"
	_tmp79_ = self->priv->overlay;
#line 152 "../src/sudoku-view.vala"
	_tmp80_ = self->priv->paused;
#line 152 "../src/sudoku-view.vala"
	gtk_overlay_add_overlay (_tmp79_, (GtkWidget*) _tmp80_);
#line 153 "../src/sudoku-view.vala"
	_tmp81_ = self->priv->overlay;
#line 153 "../src/sudoku-view.vala"
	_tmp82_ = self->priv->grid;
#line 153 "../src/sudoku-view.vala"
	gtk_overlay_set_child (_tmp81_, (GtkWidget*) _tmp82_);
#line 154 "../src/sudoku-view.vala"
	_tmp83_ = self->priv->grid;
#line 154 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp83_);
#line 155 "../src/sudoku-view.vala"
	_tmp84_ = self->priv->overlay;
#line 155 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp84_);
#line 156 "../src/sudoku-view.vala"
	_tmp85_ = self->priv->paused;
#line 156 "../src/sudoku-view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp85_, FALSE);
#line 53 "../src/sudoku-view.vala"
	blocks = (_vala_array_free (blocks, blocks_length1 * blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 53 "../src/sudoku-view.vala"
	_g_object_unref0 (frame);
#line 53 "../src/sudoku-view.vala"
	block11_data_unref (_data11_);
#line 53 "../src/sudoku-view.vala"
	_data11_ = NULL;
#line 53 "../src/sudoku-view.vala"
	return self;
#line 1226 "sudoku-view.c"
}

SudokuView*
sudoku_view_new (gint frame_size,
                 SudokuGame* game)
{
#line 53 "../src/sudoku-view.vala"
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, frame_size, game);
#line 1235 "sudoku-view.c"
}

static void
sudoku_view_update_highlights (SudokuView* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean has_selection = FALSE;
	gint cell_value = 0;
#line 227 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 229 "../src/sudoku-view.vala"
	if (self->selected_row >= 0) {
#line 229 "../src/sudoku-view.vala"
		_tmp0_ = self->selected_col >= 0;
#line 1250 "sudoku-view.c"
	} else {
#line 229 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 1254 "sudoku-view.c"
	}
#line 229 "../src/sudoku-view.vala"
	has_selection = _tmp0_;
#line 230 "../src/sudoku-view.vala"
	cell_value = -1;
#line 231 "../src/sudoku-view.vala"
	if (has_selection) {
#line 1262 "sudoku-view.c"
		SudokuCell** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCell* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 232 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->cells;
#line 232 "../src/sudoku-view.vala"
		_tmp1__length1 = self->priv->cells_length1;
#line 232 "../src/sudoku-view.vala"
		_tmp1__length2 = self->priv->cells_length2;
#line 232 "../src/sudoku-view.vala"
		_tmp2_ = _tmp1_[(self->selected_row * _tmp1__length2) + self->selected_col];
#line 232 "../src/sudoku-view.vala"
		_tmp3_ = sudoku_cell_get_value (_tmp2_);
#line 232 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_;
#line 232 "../src/sudoku-view.vala"
		cell_value = _tmp4_;
#line 1283 "sudoku-view.c"
	}
	{
		gint col_tmp = 0;
#line 234 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 1289 "sudoku-view.c"
		{
			gboolean _tmp5_ = FALSE;
#line 234 "../src/sudoku-view.vala"
			_tmp5_ = TRUE;
#line 234 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1296 "sudoku-view.c"
				SudokuGame* _tmp7_;
				SudokuBoard* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
#line 234 "../src/sudoku-view.vala"
				if (!_tmp5_) {
#line 1303 "sudoku-view.c"
					gint _tmp6_;
#line 234 "../src/sudoku-view.vala"
					_tmp6_ = col_tmp;
#line 234 "../src/sudoku-view.vala"
					col_tmp = _tmp6_ + 1;
#line 1309 "sudoku-view.c"
				}
#line 234 "../src/sudoku-view.vala"
				_tmp5_ = FALSE;
#line 234 "../src/sudoku-view.vala"
				_tmp7_ = self->game;
#line 234 "../src/sudoku-view.vala"
				_tmp8_ = _tmp7_->board;
#line 234 "../src/sudoku-view.vala"
				_tmp9_ = sudoku_board_get_cols (_tmp8_);
#line 234 "../src/sudoku-view.vala"
				_tmp10_ = _tmp9_;
#line 234 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp10_)) {
#line 234 "../src/sudoku-view.vala"
					break;
#line 1325 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 236 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 1331 "sudoku-view.c"
					{
						gboolean _tmp11_ = FALSE;
#line 236 "../src/sudoku-view.vala"
						_tmp11_ = TRUE;
#line 236 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1338 "sudoku-view.c"
							SudokuGame* _tmp13_;
							SudokuBoard* _tmp14_;
							gint _tmp15_;
							gint _tmp16_;
							SudokuCell** _tmp17_;
							gint _tmp17__length1;
							gint _tmp17__length2;
							SudokuCell* _tmp18_;
							gboolean _tmp19_ = FALSE;
#line 236 "../src/sudoku-view.vala"
							if (!_tmp11_) {
#line 1350 "sudoku-view.c"
								gint _tmp12_;
#line 236 "../src/sudoku-view.vala"
								_tmp12_ = row_tmp;
#line 236 "../src/sudoku-view.vala"
								row_tmp = _tmp12_ + 1;
#line 1356 "sudoku-view.c"
							}
#line 236 "../src/sudoku-view.vala"
							_tmp11_ = FALSE;
#line 236 "../src/sudoku-view.vala"
							_tmp13_ = self->game;
#line 236 "../src/sudoku-view.vala"
							_tmp14_ = _tmp13_->board;
#line 236 "../src/sudoku-view.vala"
							_tmp15_ = sudoku_board_get_rows (_tmp14_);
#line 236 "../src/sudoku-view.vala"
							_tmp16_ = _tmp15_;
#line 236 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp16_)) {
#line 236 "../src/sudoku-view.vala"
								break;
#line 1372 "sudoku-view.c"
							}
#line 238 "../src/sudoku-view.vala"
							_tmp17_ = self->priv->cells;
#line 238 "../src/sudoku-view.vala"
							_tmp17__length1 = self->priv->cells_length1;
#line 238 "../src/sudoku-view.vala"
							_tmp17__length2 = self->priv->cells_length2;
#line 238 "../src/sudoku-view.vala"
							_tmp18_ = _tmp17_[(row_tmp * _tmp17__length2) + col_tmp];
#line 238 "../src/sudoku-view.vala"
							sudoku_cell_check_warnings (_tmp18_);
#line 239 "../src/sudoku-view.vala"
							if (has_selection) {
#line 239 "../src/sudoku-view.vala"
								_tmp19_ = self->priv->_highlighter;
#line 1388 "sudoku-view.c"
							} else {
#line 239 "../src/sudoku-view.vala"
								_tmp19_ = FALSE;
#line 1392 "sudoku-view.c"
							}
#line 239 "../src/sudoku-view.vala"
							if (_tmp19_) {
#line 1396 "sudoku-view.c"
								gboolean _tmp20_ = FALSE;
								gboolean _tmp21_ = FALSE;
								SudokuCell** _tmp39_;
								gint _tmp39__length1;
								gint _tmp39__length2;
								SudokuCell* _tmp40_;
#line 241 "../src/sudoku-view.vala"
								if (col_tmp == self->selected_col) {
#line 241 "../src/sudoku-view.vala"
									_tmp21_ = TRUE;
#line 1407 "sudoku-view.c"
								} else {
#line 242 "../src/sudoku-view.vala"
									_tmp21_ = row_tmp == self->selected_row;
#line 1411 "sudoku-view.c"
								}
#line 240 "../src/sudoku-view.vala"
								if (_tmp21_) {
#line 241 "../src/sudoku-view.vala"
									_tmp20_ = TRUE;
#line 1417 "sudoku-view.c"
								} else {
									gboolean _tmp22_ = FALSE;
									SudokuGame* _tmp23_;
									SudokuBoard* _tmp24_;
									gint _tmp25_;
									gint _tmp26_;
									SudokuGame* _tmp27_;
									SudokuBoard* _tmp28_;
									gint _tmp29_;
									gint _tmp30_;
#line 243 "../src/sudoku-view.vala"
									_tmp23_ = self->game;
#line 243 "../src/sudoku-view.vala"
									_tmp24_ = _tmp23_->board;
#line 243 "../src/sudoku-view.vala"
									_tmp25_ = sudoku_board_get_block_cols (_tmp24_);
#line 243 "../src/sudoku-view.vala"
									_tmp26_ = _tmp25_;
#line 243 "../src/sudoku-view.vala"
									_tmp27_ = self->game;
#line 243 "../src/sudoku-view.vala"
									_tmp28_ = _tmp27_->board;
#line 243 "../src/sudoku-view.vala"
									_tmp29_ = sudoku_board_get_block_cols (_tmp28_);
#line 243 "../src/sudoku-view.vala"
									_tmp30_ = _tmp29_;
#line 243 "../src/sudoku-view.vala"
									if ((col_tmp / _tmp26_) == (self->selected_col / _tmp30_)) {
#line 1446 "sudoku-view.c"
										SudokuGame* _tmp31_;
										SudokuBoard* _tmp32_;
										gint _tmp33_;
										gint _tmp34_;
										SudokuGame* _tmp35_;
										SudokuBoard* _tmp36_;
										gint _tmp37_;
										gint _tmp38_;
#line 244 "../src/sudoku-view.vala"
										_tmp31_ = self->game;
#line 244 "../src/sudoku-view.vala"
										_tmp32_ = _tmp31_->board;
#line 244 "../src/sudoku-view.vala"
										_tmp33_ = sudoku_board_get_block_rows (_tmp32_);
#line 244 "../src/sudoku-view.vala"
										_tmp34_ = _tmp33_;
#line 244 "../src/sudoku-view.vala"
										_tmp35_ = self->game;
#line 244 "../src/sudoku-view.vala"
										_tmp36_ = _tmp35_->board;
#line 244 "../src/sudoku-view.vala"
										_tmp37_ = sudoku_board_get_block_rows (_tmp36_);
#line 244 "../src/sudoku-view.vala"
										_tmp38_ = _tmp37_;
#line 244 "../src/sudoku-view.vala"
										_tmp22_ = (row_tmp / _tmp34_) == (self->selected_row / _tmp38_);
#line 1473 "sudoku-view.c"
									} else {
#line 243 "../src/sudoku-view.vala"
										_tmp22_ = FALSE;
#line 1477 "sudoku-view.c"
									}
#line 243 "../src/sudoku-view.vala"
									_tmp20_ = _tmp22_;
#line 1481 "sudoku-view.c"
								}
#line 240 "../src/sudoku-view.vala"
								_tmp39_ = self->priv->cells;
#line 240 "../src/sudoku-view.vala"
								_tmp39__length1 = self->priv->cells_length1;
#line 240 "../src/sudoku-view.vala"
								_tmp39__length2 = self->priv->cells_length2;
#line 240 "../src/sudoku-view.vala"
								_tmp40_ = _tmp39_[(row_tmp * _tmp39__length2) + col_tmp];
#line 240 "../src/sudoku-view.vala"
								sudoku_cell_set_highlighted_background (_tmp40_, _tmp20_);
#line 246 "../src/sudoku-view.vala"
								if (cell_value > 0) {
#line 1495 "sudoku-view.c"
									SudokuCell** _tmp41_;
									gint _tmp41__length1;
									gint _tmp41__length2;
									SudokuCell* _tmp42_;
									SudokuCell** _tmp43_;
									gint _tmp43__length1;
									gint _tmp43__length2;
									SudokuCell* _tmp44_;
									gint _tmp45_;
									gint _tmp46_;
#line 247 "../src/sudoku-view.vala"
									_tmp41_ = self->priv->cells;
#line 247 "../src/sudoku-view.vala"
									_tmp41__length1 = self->priv->cells_length1;
#line 247 "../src/sudoku-view.vala"
									_tmp41__length2 = self->priv->cells_length2;
#line 247 "../src/sudoku-view.vala"
									_tmp42_ = _tmp41_[(row_tmp * _tmp41__length2) + col_tmp];
#line 247 "../src/sudoku-view.vala"
									_tmp43_ = self->priv->cells;
#line 247 "../src/sudoku-view.vala"
									_tmp43__length1 = self->priv->cells_length1;
#line 247 "../src/sudoku-view.vala"
									_tmp43__length2 = self->priv->cells_length2;
#line 247 "../src/sudoku-view.vala"
									_tmp44_ = _tmp43_[(row_tmp * _tmp43__length2) + col_tmp];
#line 247 "../src/sudoku-view.vala"
									_tmp45_ = sudoku_cell_get_value (_tmp44_);
#line 247 "../src/sudoku-view.vala"
									_tmp46_ = _tmp45_;
#line 247 "../src/sudoku-view.vala"
									sudoku_cell_set_highlighted_value (_tmp42_, cell_value == _tmp46_);
#line 1528 "sudoku-view.c"
								} else {
									SudokuCell** _tmp47_;
									gint _tmp47__length1;
									gint _tmp47__length2;
									SudokuCell* _tmp48_;
#line 249 "../src/sudoku-view.vala"
									_tmp47_ = self->priv->cells;
#line 249 "../src/sudoku-view.vala"
									_tmp47__length1 = self->priv->cells_length1;
#line 249 "../src/sudoku-view.vala"
									_tmp47__length2 = self->priv->cells_length2;
#line 249 "../src/sudoku-view.vala"
									_tmp48_ = _tmp47_[(row_tmp * _tmp47__length2) + col_tmp];
#line 249 "../src/sudoku-view.vala"
									sudoku_cell_set_highlighted_value (_tmp48_, FALSE);
#line 1544 "sudoku-view.c"
								}
							}
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_clear_highlights (SudokuView* self)
{
#line 255 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 1560 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 257 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 1565 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 257 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 257 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1572 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 257 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 1579 "sudoku-view.c"
					gint _tmp1_;
#line 257 "../src/sudoku-view.vala"
					_tmp1_ = col_tmp;
#line 257 "../src/sudoku-view.vala"
					col_tmp = _tmp1_ + 1;
#line 1585 "sudoku-view.c"
				}
#line 257 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 257 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 257 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 257 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_cols (_tmp3_);
#line 257 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 257 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp5_)) {
#line 257 "../src/sudoku-view.vala"
					break;
#line 1601 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 259 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 1607 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 259 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 259 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1614 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 259 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 1629 "sudoku-view.c"
								gint _tmp7_;
#line 259 "../src/sudoku-view.vala"
								_tmp7_ = row_tmp;
#line 259 "../src/sudoku-view.vala"
								row_tmp = _tmp7_ + 1;
#line 1635 "sudoku-view.c"
							}
#line 259 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 259 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 259 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 259 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_rows (_tmp9_);
#line 259 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 259 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp11_)) {
#line 259 "../src/sudoku-view.vala"
								break;
#line 1651 "sudoku-view.c"
							}
#line 261 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 261 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 261 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 261 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(row_tmp * _tmp12__length2) + col_tmp];
#line 261 "../src/sudoku-view.vala"
							sudoku_cell_set_highlighted_value (_tmp13_, FALSE);
#line 262 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 262 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 262 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 262 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_[(row_tmp * _tmp14__length2) + col_tmp];
#line 262 "../src/sudoku-view.vala"
							sudoku_cell_set_highlighted_background (_tmp15_, FALSE);
#line 1673 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_clear (SudokuView* self)
{
#line 267 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 1687 "sudoku-view.c"
	{
		gint i = 0;
#line 269 "../src/sudoku-view.vala"
		i = 0;
#line 1692 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 269 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 269 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1699 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 269 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 1706 "sudoku-view.c"
					gint _tmp1_;
#line 269 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 269 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 1712 "sudoku-view.c"
				}
#line 269 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 269 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 269 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 269 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 269 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 269 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 269 "../src/sudoku-view.vala"
					break;
#line 1728 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 270 "../src/sudoku-view.vala"
					j = 0;
#line 1734 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 270 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 270 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1741 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuGame* _tmp12_;
							SudokuBoard* _tmp13_;
#line 270 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 1750 "sudoku-view.c"
								gint _tmp7_;
#line 270 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 270 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 1756 "sudoku-view.c"
							}
#line 270 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 270 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 270 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 270 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 270 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 270 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 270 "../src/sudoku-view.vala"
								break;
#line 1772 "sudoku-view.c"
							}
#line 271 "../src/sudoku-view.vala"
							_tmp12_ = self->game;
#line 271 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_->board;
#line 271 "../src/sudoku-view.vala"
							sudoku_board_disable_all_earmarks (_tmp13_, i, j);
#line 1780 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_redraw (SudokuView* self)
{
#line 274 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 1794 "sudoku-view.c"
	{
		gint i = 0;
#line 276 "../src/sudoku-view.vala"
		i = 0;
#line 1799 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 276 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 276 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1806 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 276 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 1813 "sudoku-view.c"
					gint _tmp1_;
#line 276 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 276 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 1819 "sudoku-view.c"
				}
#line 276 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 276 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 276 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 276 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 276 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 276 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 276 "../src/sudoku-view.vala"
					break;
#line 1835 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 277 "../src/sudoku-view.vala"
					j = 0;
#line 1841 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 277 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 277 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1848 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
#line 277 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 1859 "sudoku-view.c"
								gint _tmp7_;
#line 277 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 277 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 1865 "sudoku-view.c"
							}
#line 277 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 277 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 277 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 277 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 277 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 277 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 277 "../src/sudoku-view.vala"
								break;
#line 1881 "sudoku-view.c"
							}
#line 278 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 278 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 278 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 278 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 278 "../src/sudoku-view.vala"
							sudoku_cell_check_warnings (_tmp13_);
#line 1893 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
#line 284 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 284 "../src/sudoku-view.vala"
	result = self->priv->_show_warnings;
#line 284 "../src/sudoku-view.vala"
	return result;
#line 1912 "sudoku-view.c"
}

void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
#line 285 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 286 "../src/sudoku-view.vala"
	self->priv->_show_warnings = value;
#line 1923 "sudoku-view.c"
	{
		gint i = 0;
#line 287 "../src/sudoku-view.vala"
		i = 0;
#line 1928 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 287 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 287 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1935 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 287 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 1942 "sudoku-view.c"
					gint _tmp1_;
#line 287 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 287 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 1948 "sudoku-view.c"
				}
#line 287 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 287 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 287 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 287 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 287 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 287 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 287 "../src/sudoku-view.vala"
					break;
#line 1964 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 288 "../src/sudoku-view.vala"
					j = 0;
#line 1970 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 288 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 288 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1977 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
#line 288 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 1988 "sudoku-view.c"
								gint _tmp7_;
#line 288 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 288 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 1994 "sudoku-view.c"
							}
#line 288 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 288 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 288 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 288 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 288 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 288 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 288 "../src/sudoku-view.vala"
								break;
#line 2010 "sudoku-view.c"
							}
#line 289 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 289 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 289 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 289 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 289 "../src/sudoku-view.vala"
							sudoku_cell_set_show_warnings (_tmp13_, self->priv->_show_warnings);
#line 2022 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 285 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 2031 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_extra_warnings (SudokuView* self)
{
	gboolean result;
#line 296 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 296 "../src/sudoku-view.vala"
	result = self->priv->_show_extra_warnings;
#line 296 "../src/sudoku-view.vala"
	return result;
#line 2044 "sudoku-view.c"
}

void
sudoku_view_set_show_extra_warnings (SudokuView* self,
                                     gboolean value)
{
#line 297 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = value;
#line 2055 "sudoku-view.c"
	{
		gint i = 0;
#line 299 "../src/sudoku-view.vala"
		i = 0;
#line 2060 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 299 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 299 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2067 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 299 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2074 "sudoku-view.c"
					gint _tmp1_;
#line 299 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 299 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2080 "sudoku-view.c"
				}
#line 299 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 299 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 299 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 299 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 299 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 299 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 299 "../src/sudoku-view.vala"
					break;
#line 2096 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 300 "../src/sudoku-view.vala"
					j = 0;
#line 2102 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 300 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 300 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2109 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
#line 300 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 2120 "sudoku-view.c"
								gint _tmp7_;
#line 300 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 300 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 2126 "sudoku-view.c"
							}
#line 300 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 300 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 300 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 300 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 300 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 300 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 300 "../src/sudoku-view.vala"
								break;
#line 2142 "sudoku-view.c"
							}
#line 301 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 301 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 301 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 301 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 301 "../src/sudoku-view.vala"
							sudoku_cell_set_show_extra_warnings (_tmp13_, self->priv->_show_extra_warnings);
#line 2154 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 297 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY]);
#line 2163 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
#line 308 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 308 "../src/sudoku-view.vala"
	result = self->priv->_show_possibilities;
#line 308 "../src/sudoku-view.vala"
	return result;
#line 2176 "sudoku-view.c"
}

void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
#line 309 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 310 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = value;
#line 2187 "sudoku-view.c"
	{
		gint i = 0;
#line 311 "../src/sudoku-view.vala"
		i = 0;
#line 2192 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 311 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 311 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2199 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 311 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2206 "sudoku-view.c"
					gint _tmp1_;
#line 311 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 311 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2212 "sudoku-view.c"
				}
#line 311 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 311 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 311 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 311 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 311 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 311 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 311 "../src/sudoku-view.vala"
					break;
#line 2228 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 312 "../src/sudoku-view.vala"
					j = 0;
#line 2234 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 312 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 312 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2241 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
#line 312 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 2252 "sudoku-view.c"
								gint _tmp7_;
#line 312 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 312 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 2258 "sudoku-view.c"
							}
#line 312 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 312 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 312 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 312 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 312 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 312 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 312 "../src/sudoku-view.vala"
								break;
#line 2274 "sudoku-view.c"
							}
#line 313 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 313 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 313 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 313 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 313 "../src/sudoku-view.vala"
							_tmp13_->show_possibilities = value;
#line 2286 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 309 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 2295 "sudoku-view.c"
}

gboolean
sudoku_view_get_initialize_earmarks (SudokuView* self)
{
	gboolean result;
#line 320 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 320 "../src/sudoku-view.vala"
	result = self->priv->_initialize_earmarks;
#line 320 "../src/sudoku-view.vala"
	return result;
#line 2308 "sudoku-view.c"
}

void
sudoku_view_set_initialize_earmarks (SudokuView* self,
                                     gboolean value)
{
#line 321 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 322 "../src/sudoku-view.vala"
	self->priv->_initialize_earmarks = value;
#line 2319 "sudoku-view.c"
	{
		gint i = 0;
#line 323 "../src/sudoku-view.vala"
		i = 0;
#line 2324 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 323 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 323 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2331 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 323 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2338 "sudoku-view.c"
					gint _tmp1_;
#line 323 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 323 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2344 "sudoku-view.c"
				}
#line 323 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 323 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 323 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 323 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 323 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 323 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 323 "../src/sudoku-view.vala"
					break;
#line 2360 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 324 "../src/sudoku-view.vala"
					j = 0;
#line 2366 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 324 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 324 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2373 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
#line 324 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 2384 "sudoku-view.c"
								gint _tmp7_;
#line 324 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 324 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 2390 "sudoku-view.c"
							}
#line 324 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 324 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 324 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 324 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 324 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 324 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 324 "../src/sudoku-view.vala"
								break;
#line 2406 "sudoku-view.c"
							}
#line 325 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 325 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 325 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 325 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 325 "../src/sudoku-view.vala"
							sudoku_cell_set_initialize_earmarks (_tmp13_, value);
#line 2418 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 321 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY]);
#line 2427 "sudoku-view.c"
}

gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
#line 332 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 332 "../src/sudoku-view.vala"
	result = self->priv->_highlighter;
#line 332 "../src/sudoku-view.vala"
	return result;
#line 2440 "sudoku-view.c"
}

void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
#line 333 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 334 "../src/sudoku-view.vala"
	self->priv->_highlighter = value;
#line 335 "../src/sudoku-view.vala"
	if (!self->priv->_highlighter) {
#line 336 "../src/sudoku-view.vala"
		sudoku_view_clear_highlights (self);
#line 2455 "sudoku-view.c"
	}
#line 333 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
#line 2459 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda13_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	SudokuView* _tmp4_;
	gboolean result;
#line 160 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 161 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 161 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 163 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 163 "../src/sudoku-view.vala"
	if (_tmp2_->selected_row == -1) {
#line 163 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 2483 "sudoku-view.c"
	} else {
		SudokuView* _tmp3_;
#line 163 "../src/sudoku-view.vala"
		_tmp3_ = view;
#line 163 "../src/sudoku-view.vala"
		_tmp1_ = _tmp3_->selected_col == -1;
#line 2490 "sudoku-view.c"
	}
#line 163 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 164 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 164 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 164 "../src/sudoku-view.vala"
		return result;
#line 2500 "sudoku-view.c"
	}
#line 166 "../src/sudoku-view.vala"
	_tmp4_ = view;
#line 166 "../src/sudoku-view.vala"
	if (_tmp4_->selected_row == 0) {
#line 2506 "sudoku-view.c"
		SudokuView* _tmp5_;
		SudokuCell** _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		SudokuView* _tmp7_;
		SudokuCell* _tmp8_;
#line 167 "../src/sudoku-view.vala"
		_tmp5_ = view;
#line 167 "../src/sudoku-view.vala"
		_tmp6_ = _tmp5_->priv->cells;
#line 167 "../src/sudoku-view.vala"
		_tmp6__length1 = _tmp5_->priv->cells_length1;
#line 167 "../src/sudoku-view.vala"
		_tmp6__length2 = _tmp5_->priv->cells_length2;
#line 167 "../src/sudoku-view.vala"
		_tmp7_ = view;
#line 167 "../src/sudoku-view.vala"
		_tmp8_ = _tmp6_[(8 * _tmp6__length2) + _tmp7_->selected_col];
#line 167 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp8_);
#line 2527 "sudoku-view.c"
	} else {
		SudokuView* _tmp9_;
		SudokuCell** _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		SudokuView* _tmp11_;
		SudokuView* _tmp12_;
		SudokuCell* _tmp13_;
#line 169 "../src/sudoku-view.vala"
		_tmp9_ = view;
#line 169 "../src/sudoku-view.vala"
		_tmp10_ = _tmp9_->priv->cells;
#line 169 "../src/sudoku-view.vala"
		_tmp10__length1 = _tmp9_->priv->cells_length1;
#line 169 "../src/sudoku-view.vala"
		_tmp10__length2 = _tmp9_->priv->cells_length2;
#line 169 "../src/sudoku-view.vala"
		_tmp11_ = view;
#line 169 "../src/sudoku-view.vala"
		_tmp12_ = view;
#line 169 "../src/sudoku-view.vala"
		_tmp13_ = _tmp10_[((_tmp11_->selected_row - 1) * _tmp10__length2) + _tmp12_->selected_col];
#line 169 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp13_);
#line 2552 "sudoku-view.c"
	}
#line 171 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 171 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 171 "../src/sudoku-view.vala"
	return result;
#line 2560 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda13__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda13_ (widget);
#line 160 "../src/sudoku-view.vala"
	return result;
#line 2572 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda14_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	SudokuView* _tmp4_;
	gboolean result;
#line 173 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 174 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 174 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 176 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 176 "../src/sudoku-view.vala"
	if (_tmp2_->selected_row == -1) {
#line 176 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 2596 "sudoku-view.c"
	} else {
		SudokuView* _tmp3_;
#line 176 "../src/sudoku-view.vala"
		_tmp3_ = view;
#line 176 "../src/sudoku-view.vala"
		_tmp1_ = _tmp3_->selected_col == -1;
#line 2603 "sudoku-view.c"
	}
#line 176 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 177 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 177 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 177 "../src/sudoku-view.vala"
		return result;
#line 2613 "sudoku-view.c"
	}
#line 179 "../src/sudoku-view.vala"
	_tmp4_ = view;
#line 179 "../src/sudoku-view.vala"
	if (_tmp4_->selected_row == 8) {
#line 2619 "sudoku-view.c"
		SudokuView* _tmp5_;
		SudokuCell** _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		SudokuView* _tmp7_;
		SudokuCell* _tmp8_;
#line 180 "../src/sudoku-view.vala"
		_tmp5_ = view;
#line 180 "../src/sudoku-view.vala"
		_tmp6_ = _tmp5_->priv->cells;
#line 180 "../src/sudoku-view.vala"
		_tmp6__length1 = _tmp5_->priv->cells_length1;
#line 180 "../src/sudoku-view.vala"
		_tmp6__length2 = _tmp5_->priv->cells_length2;
#line 180 "../src/sudoku-view.vala"
		_tmp7_ = view;
#line 180 "../src/sudoku-view.vala"
		_tmp8_ = _tmp6_[(0 * _tmp6__length2) + _tmp7_->selected_col];
#line 180 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp8_);
#line 2640 "sudoku-view.c"
	} else {
		SudokuView* _tmp9_;
		SudokuCell** _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		SudokuView* _tmp11_;
		SudokuView* _tmp12_;
		SudokuCell* _tmp13_;
#line 182 "../src/sudoku-view.vala"
		_tmp9_ = view;
#line 182 "../src/sudoku-view.vala"
		_tmp10_ = _tmp9_->priv->cells;
#line 182 "../src/sudoku-view.vala"
		_tmp10__length1 = _tmp9_->priv->cells_length1;
#line 182 "../src/sudoku-view.vala"
		_tmp10__length2 = _tmp9_->priv->cells_length2;
#line 182 "../src/sudoku-view.vala"
		_tmp11_ = view;
#line 182 "../src/sudoku-view.vala"
		_tmp12_ = view;
#line 182 "../src/sudoku-view.vala"
		_tmp13_ = _tmp10_[((_tmp11_->selected_row + 1) * _tmp10__length2) + _tmp12_->selected_col];
#line 182 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp13_);
#line 2665 "sudoku-view.c"
	}
#line 184 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 184 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 184 "../src/sudoku-view.vala"
	return result;
#line 2673 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda14__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda14_ (widget);
#line 173 "../src/sudoku-view.vala"
	return result;
#line 2685 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda15_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	SudokuView* _tmp4_;
	gboolean result;
#line 186 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 187 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 187 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 189 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 189 "../src/sudoku-view.vala"
	if (_tmp2_->selected_row == -1) {
#line 189 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 2709 "sudoku-view.c"
	} else {
		SudokuView* _tmp3_;
#line 189 "../src/sudoku-view.vala"
		_tmp3_ = view;
#line 189 "../src/sudoku-view.vala"
		_tmp1_ = _tmp3_->selected_col == -1;
#line 2716 "sudoku-view.c"
	}
#line 189 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 190 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 190 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 190 "../src/sudoku-view.vala"
		return result;
#line 2726 "sudoku-view.c"
	}
#line 192 "../src/sudoku-view.vala"
	_tmp4_ = view;
#line 192 "../src/sudoku-view.vala"
	if (_tmp4_->selected_col == 0) {
#line 2732 "sudoku-view.c"
		SudokuView* _tmp5_;
		SudokuCell** _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		SudokuView* _tmp7_;
		SudokuCell* _tmp8_;
#line 193 "../src/sudoku-view.vala"
		_tmp5_ = view;
#line 193 "../src/sudoku-view.vala"
		_tmp6_ = _tmp5_->priv->cells;
#line 193 "../src/sudoku-view.vala"
		_tmp6__length1 = _tmp5_->priv->cells_length1;
#line 193 "../src/sudoku-view.vala"
		_tmp6__length2 = _tmp5_->priv->cells_length2;
#line 193 "../src/sudoku-view.vala"
		_tmp7_ = view;
#line 193 "../src/sudoku-view.vala"
		_tmp8_ = _tmp6_[(_tmp7_->selected_row * _tmp6__length2) + 8];
#line 193 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp8_);
#line 2753 "sudoku-view.c"
	} else {
		SudokuView* _tmp9_;
		SudokuCell** _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		SudokuView* _tmp11_;
		SudokuView* _tmp12_;
		SudokuCell* _tmp13_;
#line 195 "../src/sudoku-view.vala"
		_tmp9_ = view;
#line 195 "../src/sudoku-view.vala"
		_tmp10_ = _tmp9_->priv->cells;
#line 195 "../src/sudoku-view.vala"
		_tmp10__length1 = _tmp9_->priv->cells_length1;
#line 195 "../src/sudoku-view.vala"
		_tmp10__length2 = _tmp9_->priv->cells_length2;
#line 195 "../src/sudoku-view.vala"
		_tmp11_ = view;
#line 195 "../src/sudoku-view.vala"
		_tmp12_ = view;
#line 195 "../src/sudoku-view.vala"
		_tmp13_ = _tmp10_[(_tmp11_->selected_row * _tmp10__length2) + (_tmp12_->selected_col - 1)];
#line 195 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp13_);
#line 2778 "sudoku-view.c"
	}
#line 197 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 197 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 197 "../src/sudoku-view.vala"
	return result;
#line 2786 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda15__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda15_ (widget);
#line 186 "../src/sudoku-view.vala"
	return result;
#line 2798 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda16_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	SudokuView* _tmp4_;
	gboolean result;
#line 199 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 200 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 200 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 202 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 202 "../src/sudoku-view.vala"
	if (_tmp2_->selected_row == -1) {
#line 202 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 2822 "sudoku-view.c"
	} else {
		SudokuView* _tmp3_;
#line 202 "../src/sudoku-view.vala"
		_tmp3_ = view;
#line 202 "../src/sudoku-view.vala"
		_tmp1_ = _tmp3_->selected_col == -1;
#line 2829 "sudoku-view.c"
	}
#line 202 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 203 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 203 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 203 "../src/sudoku-view.vala"
		return result;
#line 2839 "sudoku-view.c"
	}
#line 205 "../src/sudoku-view.vala"
	_tmp4_ = view;
#line 205 "../src/sudoku-view.vala"
	if (_tmp4_->selected_col == 8) {
#line 2845 "sudoku-view.c"
		SudokuView* _tmp5_;
		SudokuCell** _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		SudokuView* _tmp7_;
		SudokuCell* _tmp8_;
#line 206 "../src/sudoku-view.vala"
		_tmp5_ = view;
#line 206 "../src/sudoku-view.vala"
		_tmp6_ = _tmp5_->priv->cells;
#line 206 "../src/sudoku-view.vala"
		_tmp6__length1 = _tmp5_->priv->cells_length1;
#line 206 "../src/sudoku-view.vala"
		_tmp6__length2 = _tmp5_->priv->cells_length2;
#line 206 "../src/sudoku-view.vala"
		_tmp7_ = view;
#line 206 "../src/sudoku-view.vala"
		_tmp8_ = _tmp6_[(_tmp7_->selected_row * _tmp6__length2) + 0];
#line 206 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp8_);
#line 2866 "sudoku-view.c"
	} else {
		SudokuView* _tmp9_;
		SudokuCell** _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		SudokuView* _tmp11_;
		SudokuView* _tmp12_;
		SudokuCell* _tmp13_;
#line 208 "../src/sudoku-view.vala"
		_tmp9_ = view;
#line 208 "../src/sudoku-view.vala"
		_tmp10_ = _tmp9_->priv->cells;
#line 208 "../src/sudoku-view.vala"
		_tmp10__length1 = _tmp9_->priv->cells_length1;
#line 208 "../src/sudoku-view.vala"
		_tmp10__length2 = _tmp9_->priv->cells_length2;
#line 208 "../src/sudoku-view.vala"
		_tmp11_ = view;
#line 208 "../src/sudoku-view.vala"
		_tmp12_ = view;
#line 208 "../src/sudoku-view.vala"
		_tmp13_ = _tmp10_[(_tmp11_->selected_row * _tmp10__length2) + (_tmp12_->selected_col + 1)];
#line 208 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp13_);
#line 2891 "sudoku-view.c"
	}
#line 210 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 210 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 210 "../src/sudoku-view.vala"
	return result;
#line 2899 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda16__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda16_ (widget);
#line 199 "../src/sudoku-view.vala"
	return result;
#line 2911 "sudoku-view.c"
}

static void
sudoku_view_class_init (SudokuViewClass * klass,
                        gpointer klass_data)
{
	GtkShortcutFunc up_func = NULL;
	gpointer up_func_target;
	GDestroyNotify up_func_target_destroy_notify;
	GtkShortcutFunc down_func = NULL;
	gpointer down_func_target;
	GDestroyNotify down_func_target_destroy_notify;
	GtkShortcutFunc left_func = NULL;
	gpointer left_func_target;
	GDestroyNotify left_func_target_destroy_notify;
	GtkShortcutFunc right_func = NULL;
	gpointer right_func_target;
	GDestroyNotify right_func_target_destroy_notify;
	GtkShortcutFunc _tmp0_;
	gpointer _tmp0__target;
	GtkShortcutFunc _tmp1_;
	gpointer _tmp1__target;
	GtkShortcutFunc _tmp2_;
	gpointer _tmp2__target;
	GtkShortcutFunc _tmp3_;
	gpointer _tmp3__target;
	GtkShortcutFunc _tmp4_;
	gpointer _tmp4__target;
	GtkShortcutFunc _tmp5_;
	gpointer _tmp5__target;
	GtkShortcutFunc _tmp6_;
	gpointer _tmp6__target;
	GtkShortcutFunc _tmp7_;
	gpointer _tmp7__target;
	GtkShortcutFunc _tmp8_;
	gpointer _tmp8__target;
	GtkShortcutFunc _tmp9_;
	gpointer _tmp9__target;
	GtkShortcutFunc _tmp10_;
	gpointer _tmp10__target;
	GtkShortcutFunc _tmp11_;
	gpointer _tmp11__target;
#line 26 "../src/sudoku-view.vala"
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/sudoku-view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-extra-warnings", "show-extra-warnings", "show-extra-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY] = g_param_spec_boolean ("initialize-earmarks", "initialize-earmarks", "initialize-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 160 "../src/sudoku-view.vala"
	up_func = __sudoku_view___lambda13__gtk_shortcut_func;
#line 160 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 160 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 173 "../src/sudoku-view.vala"
	down_func = __sudoku_view___lambda14__gtk_shortcut_func;
#line 173 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 173 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 186 "../src/sudoku-view.vala"
	left_func = __sudoku_view___lambda15__gtk_shortcut_func;
#line 186 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 186 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 199 "../src/sudoku-view.vala"
	right_func = __sudoku_view___lambda16__gtk_shortcut_func;
#line 199 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 199 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 213 "../src/sudoku-view.vala"
	_tmp0_ = up_func;
#line 213 "../src/sudoku-view.vala"
	_tmp0__target = up_func_target;
#line 213 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Up, 0, _tmp0_, _tmp0__target, NULL, NULL);
#line 214 "../src/sudoku-view.vala"
	_tmp1_ = up_func;
#line 214 "../src/sudoku-view.vala"
	_tmp1__target = up_func_target;
#line 214 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Up, 0, _tmp1_, _tmp1__target, NULL, NULL);
#line 215 "../src/sudoku-view.vala"
	_tmp2_ = up_func;
#line 215 "../src/sudoku-view.vala"
	_tmp2__target = up_func_target;
#line 215 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_w, 0, _tmp2_, _tmp2__target, NULL, NULL);
#line 216 "../src/sudoku-view.vala"
	_tmp3_ = down_func;
#line 216 "../src/sudoku-view.vala"
	_tmp3__target = down_func_target;
#line 216 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Down, 0, _tmp3_, _tmp3__target, NULL, NULL);
#line 217 "../src/sudoku-view.vala"
	_tmp4_ = down_func;
#line 217 "../src/sudoku-view.vala"
	_tmp4__target = down_func_target;
#line 217 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Down, 0, _tmp4_, _tmp4__target, NULL, NULL);
#line 218 "../src/sudoku-view.vala"
	_tmp5_ = down_func;
#line 218 "../src/sudoku-view.vala"
	_tmp5__target = down_func_target;
#line 218 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_s, 0, _tmp5_, _tmp5__target, NULL, NULL);
#line 219 "../src/sudoku-view.vala"
	_tmp6_ = left_func;
#line 219 "../src/sudoku-view.vala"
	_tmp6__target = left_func_target;
#line 219 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Left, 0, _tmp6_, _tmp6__target, NULL, NULL);
#line 220 "../src/sudoku-view.vala"
	_tmp7_ = left_func;
#line 220 "../src/sudoku-view.vala"
	_tmp7__target = left_func_target;
#line 220 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Left, 0, _tmp7_, _tmp7__target, NULL, NULL);
#line 221 "../src/sudoku-view.vala"
	_tmp8_ = left_func;
#line 221 "../src/sudoku-view.vala"
	_tmp8__target = left_func_target;
#line 221 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_a, 0, _tmp8_, _tmp8__target, NULL, NULL);
#line 222 "../src/sudoku-view.vala"
	_tmp9_ = right_func;
#line 222 "../src/sudoku-view.vala"
	_tmp9__target = right_func_target;
#line 222 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Right, 0, _tmp9_, _tmp9__target, NULL, NULL);
#line 223 "../src/sudoku-view.vala"
	_tmp10_ = right_func;
#line 223 "../src/sudoku-view.vala"
	_tmp10__target = right_func_target;
#line 223 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Right, 0, _tmp10_, _tmp10__target, NULL, NULL);
#line 224 "../src/sudoku-view.vala"
	_tmp11_ = right_func;
#line 224 "../src/sudoku-view.vala"
	_tmp11__target = right_func_target;
#line 224 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_d, 0, _tmp11_, _tmp11__target, NULL, NULL);
#line 159 "../src/sudoku-view.vala"
	(right_func_target_destroy_notify == NULL) ? NULL : (right_func_target_destroy_notify (right_func_target), NULL);
#line 159 "../src/sudoku-view.vala"
	right_func = NULL;
#line 159 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 159 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 159 "../src/sudoku-view.vala"
	(left_func_target_destroy_notify == NULL) ? NULL : (left_func_target_destroy_notify (left_func_target), NULL);
#line 159 "../src/sudoku-view.vala"
	left_func = NULL;
#line 159 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 159 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 159 "../src/sudoku-view.vala"
	(down_func_target_destroy_notify == NULL) ? NULL : (down_func_target_destroy_notify (down_func_target), NULL);
#line 159 "../src/sudoku-view.vala"
	down_func = NULL;
#line 159 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 159 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 159 "../src/sudoku-view.vala"
	(up_func_target_destroy_notify == NULL) ? NULL : (up_func_target_destroy_notify (up_func_target), NULL);
#line 159 "../src/sudoku-view.vala"
	up_func = NULL;
#line 159 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 159 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 3102 "sudoku-view.c"
}

static void
sudoku_view_instance_init (SudokuView * self,
                           gpointer klass)
{
#line 26 "../src/sudoku-view.vala"
	self->priv = sudoku_view_get_instance_private (self);
#line 32 "../src/sudoku-view.vala"
	self->priv->previous_board_broken_state = FALSE;
#line 37 "../src/sudoku-view.vala"
	self->selected_row = 0;
#line 38 "../src/sudoku-view.vala"
	self->selected_col = 0;
#line 281 "../src/sudoku-view.vala"
	self->priv->_show_warnings = FALSE;
#line 293 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = FALSE;
#line 305 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = FALSE;
#line 317 "../src/sudoku-view.vala"
	self->priv->_initialize_earmarks = FALSE;
#line 329 "../src/sudoku-view.vala"
	self->priv->_highlighter = FALSE;
#line 3127 "sudoku-view.c"
}

static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
#line 26 "../src/sudoku-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
#line 28 "../src/sudoku-view.vala"
	_g_object_unref0 (self->game);
#line 29 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 30 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused);
#line 34 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 35 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
#line 3148 "sudoku-view.c"
}

static GType
sudoku_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
	GType sudoku_view_type_id;
	sudoku_view_type_id = g_type_register_static (adw_bin_get_type (), "SudokuView", &g_define_type_info, 0);
	SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
	return sudoku_view_type_id;
}

GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_view_type_id__once)) {
		GType sudoku_view_type_id;
		sudoku_view_type_id = sudoku_view_get_type_once ();
		g_once_init_leave (&sudoku_view_type_id__once, sudoku_view_type_id);
	}
	return sudoku_view_type_id__once;
}

static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_extra_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_initialize_earmarks (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 3213 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 3219 "sudoku-view.c"
	}
}

static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_extra_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_initialize_earmarks (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 3263 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 3269 "sudoku-view.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

